--chains 4v4

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Building)
import(Module_Spells)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end

local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 2000
local team2Score = 2000
--stronger lasers (deal more damage to score and hp)
local team1Quantifier = 1
local team2Quantifier = 1
local powerUpLocations = {} for i = 8,40 do table.insert(powerUpLocations,i) end

local freezeSpell = M_SPELL_HYPNOTISM --freeze fire (captains)
----------------------------------------------------spell constants
sti = spells_type_info()
tmi = thing_move_info()

sti[freezeSpell].OneOffMaximum = 1
sti[freezeSpell].WorldCoordRange = 4096
sti[freezeSpell].CursorSpriteNum = 162
sti[freezeSpell].AvailableSpriteIdx = 1733
sti[freezeSpell].NotAvailableSpriteIdx = 1733
sti[freezeSpell].ClickedSpriteIdx = 1733

local addedTimer = 8
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)


tmi[TMI_PERSON_MEDICINE_MAN].BaseSpeed = 112
set_correct_gui_menu()
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				cor = marker_to_coord3d(0),
				speed = -1,
				reinc = -1,
				spellCDR = -1,
				spellc3d = marker_to_coord3d(255),
				spellRefill = -1,
				ldb = 8
			},
			{
				online = -1,
				alive = 1,
				color = -2,
				drawClr = 12,
				name = "red",
				cor = marker_to_coord3d(1),
				speed = -1,
				reinc = -1,
				ldb = 8
			},
			{
				online = -1,
				alive = 1,
				color = 3,
				drawClr = 5,
				name = "yellow",
				cor = marker_to_coord3d(2),
				speed = -1,
				reinc = -1,
				ldb = 8
			},
			{
				online = -1,
				alive = 1,
				color = 1,
				drawClr = 3,
				name = "green",
				cor = marker_to_coord3d(3),
				speed = -1,
				reinc = -1,
				ldb = 8
			},
			{
				score = 0,
				kills = 0,
				online = -1,
				alive = 1,
				color = 10,
				drawClr = 7,
				name = "cyan",
				cor = marker_to_coord3d(4),
				speed = -1,
				reinc = -1,
				ldb = 8
			},
			{
				online = -1,
				alive = 1,
				color = 11,
				drawClr = 6,
				name = "magenta",
				cor = marker_to_coord3d(5),
				speed = -1,
				reinc = -1,
				ldb = 8
			},
			{
				online = -1,
				alive = 1,
				color = 7,
				drawClr = 16,
				name = "black",
				cor = marker_to_coord3d(6),
				speed = -1,
				reinc = -1,
				ldb = 8
			},
			{
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				cor = marker_to_coord3d(7),
				speed = -1,
				reinc = -1,
				spellCDR = -1,
				spellc3d = marker_to_coord3d(255),
				spellRefill = -1,
				ldb = 8
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--[[if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil and win < 1 then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil and pl[i].reinc == -1 then
			pl[i].alive = 0
			pl[i].reinc = 12*6
			if i < 4 then
				team1Score = team1Score - 20
			else
				team2Score = team2Score - 20
			end
			--add death visual
			local Dsprite = 24
			if pl[i].ldb ~= 8 then
				Dsprite = 2083 + pl[i].ldb
			end
			local Dname = "..."
			if Dsprite ~= 24 then
				Dname = pl[pl[i].ldb].name
			end
			local Dname2 = pl[i].name
			table.insert(deaths,{Dname,Dname2,Dsprite,2083+i,12*7})
		end
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------

function CopyC3d(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end

function FreezeFire(pn,c3d)
	local f = createThing(T_EFFECT,M_EFFECT_FIRECLOUD ,8,c3d,false,false) centre_coord3d_on_block(f.Pos.D3)
	SearchMapCells(SQUARE ,0, 0, 2, world_coord3d_to_map_idx(c3d), function(me)
		me.Flags = EnableFlag(me.Flags, (1<<2))
		me.Flags = EnableFlag(me.Flags, (1<<7))
	return true end)
end

--higher life
for i = 0,7 do
	if getShaman(i) ~= nil then
		getShaman(i).u.Pers.MaxLife = 2500
		getShaman(i).u.Pers.Life = getShaman(i).u.Pers.MaxLife
	end
end

function ShowLaser(pn)
	local color = 0
	if pn < 4 then color = 2 else color = 9 end

	local function DrawChain(pn,targ)
		local s = getShaman(pn)
		local t = getShaman(targ)
		if s ~= nil and t ~= nil and get_world_dist_xz(s.Pos.D2,t.Pos.D2) < 512*24 then
			
			local z = (t.Pos.D2.Zpos - s.Pos.D2.Zpos)
			local x = (t.Pos.D2.Xpos - s.Pos.D2.Xpos)
			local ax = math.abs(x)
			local az = math.abs(z)
			
			
			if (x > 0 and z > 32767) then
				if (ax > ((256*256)>>1)) then x = -(ax - (256*256)) end
				if (az > ((256*256)>>1)) then z = (az - (256*256)) end
			else
				if (x < 0) then
					if (z >= 0) then
						if (ax > ((256*256)>>1)) then x = -(ax - (256*256)) end
						if (az > ((256*256)>>1)) then z = (az - (256*256)) end
					else
						if (ax > ((256*256)>>1)) then x = -(ax - (256*256)) end
						if (az > ((256*256)>>1)) then z = -(az - (256*256)) end
					end
				else
					if (z >= 0) then
						if (ax > ((256*256)>>1)) then x = (ax - (256*256)) end
						if (az > ((256*256)>>1)) then z = -(az - (256*256)) end
					else
						if (ax > ((256*256)>>1)) then x = (ax - (256*256)) end
						if (az > ((256*256)>>1)) then z = -(az - (256*256)) end
					end
				end
			end
			
			local angle = math.atan(z, x) * 180 / math.pi
			angle = math.ceil(angle)
			if (angle<0) then
				angle=angle+360
			end

			local rotation = (angle * math.pi) / 180
			--local alt_limit = s.Pos.D3.Ypos+256
			--local alt_low_limit = s.Pos.D3.Ypos-(512-128)
			local distance_xyz = get_world_dist_xyz(s.Pos.D3,t.Pos.D3)
			local amount = math.ceil(distance_xyz / 256)
			for i=1,amount-1 do
				local spawnC3d = Coord3D.new()
				spawnC3d.Xpos = math.ceil(s.Pos.D3.Xpos + (math.cos(rotation) * 256*i))
				spawnC3d.Zpos = math.ceil(s.Pos.D3.Zpos + (math.sin(rotation) * 256*i))
				spawnC3d.Ypos = s.Pos.D3.Ypos
				local res = point_altitude(spawnC3d.Xpos,spawnC3d.Zpos)
				--if (res < alt_limit and res > alt_low_limit) then
					alt_limit = res+256
					alt_low_limit = res-(512-128)
					local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,spawnC3d,false,false)
					smok.DrawInfo.Alpha = color ; smok.u.Effect.Duration = 2
					local me = world_coord2d_to_map_ptr(smok.Pos.D2)
				--end
			end
		end
	end
		
	if pn == 1 then
		DrawChain(pn,2)
	elseif pn == 2 then
		DrawChain(pn,3)
	elseif pn == 3 then
		DrawChain(pn,1)
	elseif pn == 4 then
		DrawChain(pn,5)
	elseif pn == 5 then
		DrawChain(pn,6)
	elseif pn == 6 then
		DrawChain(pn,4)
	end
end

function KillOthers(pn)
	win = 1
	timer = -1
	--log_msg(8,"The game has ended.")
	gns.GameParams.Flags2 = gns.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
	_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
	if team1Score > team2Score then
		log_msg(8,"The game has ended. Blue team is victorious!")
	elseif team2Score > team1Score then
		log_msg(8,"The game has ended. Orange team is victorious!")
	end
	if pn > 3 then
		for i = 4,7 do
			SET_NO_REINC(i)
			ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
				damage_person(t, 8, 20000, TRUE)
				return true
			end)
			gns.Flags = gns.Flags | GNS_LEVEL_FAILED
		end
		for i = 0,3 do
			if getShaman(i) == nil then
				createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
				centre_coord3d_on_block(getShaman(i).Pos.D3)
			end
			gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
		end
	else
		for i = 0,3 do
			SET_NO_REINC(i)
			ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
				damage_person(t, 8, 20000, TRUE)
				return true
			end)
			gns.Flags = gns.Flags | GNS_LEVEL_FAILED
		end
		for i = 4,7 do
			if getShaman(i) == nil then
				createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
				centre_coord3d_on_block(getShaman(i).Pos.D3)
			end
			gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
		end
	end
end



function OnTurn()

	if win ~= 1 then AliveandOnline() end

	--quantifiers going down
	if team1Quantifier > 1 then
		team1Quantifier = team1Quantifier - 1
	end
	if team2Quantifier > 1 then
		team2Quantifier = team2Quantifier - 1
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		for k,v in ipairs (captains) do
			_gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[freezeSpell] = _gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[freezeSpell] & 240
			_gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[freezeSpell] = _gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[freezeSpell] | 1
		end
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
	end
	if win == 0 then
		--catch power ups
		ProcessGlobalTypeList(T_EFFECT,function(p)
			if p.Model == M_EFFECT_FIREBALL and p.DrawInfo.DrawNum >= 1731 and p.DrawInfo.DrawNum <= 1732 then
				for i = 0,7 do
					if getShaman(i) ~= nil then
						if get_world_dist_xz(getShaman(i).Pos.D2,p.Pos.D2) <= 192 then
							local dn = p.DrawInfo.DrawNum
							if dn == 1731 then
								--boots
								getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_BLOODLUST_ACTIVE)
								getShaman(i).u.Pers.u.Owned.BloodlustCount = math.random(37,49) -- ~~20-30secs
							else
								--prism
								if i < 4 then
									team1Quantifier = 12*15
								else
									team2Quantifier = 12*15
								end
							end
							p.DrawInfo.DrawNum = 1265
							p.DrawInfo.Alpha = 0
							p.u.Effect.Duration = 1
							queue_sound_event(nil, SND_EVENT_BLDG_ROTATE, SEF_FIXED_VARS)
						end
					end
				end
			end
		return true end)
		--create power ups
		if everySeconds(25) then
			local rpt = 0
			repeat
				rpt = rpt + 1
				local mk = math.random(8,40)
				local has = 0
				SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(marker_to_coord3d(mk)), function(me)
					me.MapWhoList:processList( function (t)
						if t.Type == T_EFFECT and t.Model == M_EFFECT_FIREBALL then
							has = 1
						end
					return true end)
				return true end)
				if has == 0 then 
					rpt = 100
					local pup = createThing(T_EFFECT,M_EFFECT_FIREBALL,TRIBE_HOSTBOT,marker_to_coord3d(mk),false,false)
					set_thing_draw_info(pup,TDI_SPRITE_F1_D1, math.random(1731,1732)) 
					pup.DrawInfo.Alpha = -16
					pup.Pos.D3.Ypos = pup.Pos.D3.Ypos + 4
					pup.u.Effect.Duration = -1
				end
			until rpt > 8
		end
		--give blast shots
		if everySeconds(5) then
			for i = 0,7 do
				if pl[i].alive > 0 then
					local shots = GET_NUM_ONE_OFF_SPELLS(i,M_SPELL_BLAST)
					if shots < 4 then
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] & 240
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] | shots+1
					end
				end
			end
		end
		--give freeze shots
		for k,v in ipairs(captains) do
			if pl[v].alive > 0 then
				local shots = GET_NUM_ONE_OFF_SPELLS(v,freezeSpell)
				if pl[v].spellRefill > 0 then
					pl[v].spellRefill = pl[v].spellRefill - 1
				elseif pl[v].spellRefill == 0 then
					pl[v].spellRefill = -1
					_gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[freezeSpell] = _gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[freezeSpell] & 240
					_gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[freezeSpell] = _gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[freezeSpell] | 1
				end
				if pl[v].spellRefill == 60 then
					SearchMapCells(SQUARE ,0, 0, 2, world_coord3d_to_map_idx(pl[v].spellc3d), function(me)
						me.Flags = DisableFlag(me.Flags, (1<<2))
						me.Flags = DisableFlag(me.Flags, (1<<7))
					return true end)
				end
			end
		end
		--process spells delay (freezefire)
		for k,v in ipairs(captains) do
			if pl[v].spellCDR > 0 then
				pl[v].spellCDR = pl[v].spellCDR - 1
			elseif pl[v].spellCDR == 0 then
				pl[v].spellCDR = -1
				FreezeFire(v,pl[v].spellc3d)
			end
		end
		--revive shamans
		for i = 0,7 do
			if getShaman(i) == nil and pl[i].online == 1 and pl[i].reinc > 0 then
				pl[i].reinc = pl[i].reinc - 1
			elseif getShaman(i) == nil and pl[i].reinc == 0 then
				createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
				getShaman(i).u.Pers.MaxLife = 2500
				getShaman(i).u.Pers.Life = getShaman(i).u.Pers.MaxLife
				getShaman(i).Flags3 = DisableFlag(getShaman(i).Flags3, TF3_BLOODLUST_ACTIVE)
				pl[i].alive = 1
				pl[i].reinc = -1
			end
		end
		--draw lasers
		for i = 1,6 do
			if getShaman(i) ~= nil and pl[i].alive > 0 then
				ShowLaser(i)
			end
		end
		--draw sparkle on gluers head
		if getShaman(0) ~= nil then
			local smok = createThing(T_EFFECT,60,TRIBE_HOSTBOT,getShaman(0).Pos.D3,false,false)
			smok.DrawInfo.Alpha = 2 ; smok.u.Effect.Duration = 2
		end
		if getShaman(7) ~= nil then
			local smok = createThing(T_EFFECT,60,TRIBE_HOSTBOT,getShaman(7).Pos.D3,false,false)
			smok.DrawInfo.Alpha = 9 ; smok.u.Effect.Duration = 2
		end
		--kill who touches lasers
		for i = 0,7 do
			if getShaman(i) ~= nil then
				local color = 2 ; if i > 3 then color = 9 end
				local foundOne = 0
				SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(getShaman(i).Pos.D3), function(me)
					me.MapWhoList:processList( function (t)
						if t.Type == T_EFFECT and t.Model == M_EFFECT_SMALL_SPARKLE and t.DrawInfo.Alpha ~= color and foundOne == 0 then
							if get_world_dist_xz(getShaman(i).Pos.D2,t.Pos.D2) <= 128+32 then
								if i < 4 then
									local enhancer = 1 if team2Quantifier > 1 then enhancer = 2 end
									damage_person (getShaman(i),8,(128*enhancer),1)
									team1Score = team1Score - (4*enhancer)
									if team1Score < 0 then team1Score = 0 end
									if team1Score == 0 then KillOthers(i) end
								else
									local enhancer = 1 if team1Quantifier > 1 then enhancer = 2 end
									damage_person (getShaman(i),8,(128*enhancer),1)
									team2Score = team2Score - (4*enhancer)
									if team2Score < 0 then team2Score = 0 end
									if team2Score == 0 then KillOthers(i) end
								end
								createThing(T_EFFECT,M_EFFECT_EXPLOSION_2,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
								queue_sound_event(nil,SND_EVENT_ANGEL_BLAST, SEF_FIXED_VARS)
								foundOne = 1 --avoids more than 1 proc on sparkles
								--createThing(T_EFFECT,60 ,TRIBE_HOSTBOT,t.Pos.D3,false,false)
							end
						end
					return true end)
				return true end)
			end
		end
		--win if score reaches 0
		if team1Score < 0 then team1Score = 0 end
		if team1Score == 0 then KillOthers(0) end
		if team2Score < 0 then team2Score = 0 end
		if team2Score == 0 then KillOthers(7) end
		--process timer
		if timer > 0 then
			timer = timer - 1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				gns.GameParams.Flags2 = gns.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	--process shamans not being targetable
	ProcessGlobalSpecialListAll(0, function(targ)
		if (targ.Type == T_PERSON) and (targ.Model == M_PERSON_MEDICINE_MAN) then
			local cmd = get_thing_curr_cmd_list_ptr(targ)
			if (cmd ~= nil) then
				if (cmd.CommandType == CMD_ATTACK_AREA_2) or (cmd.CommandType == CMD_ATTACK_TARGET) then
					cmd.CommandType = CMD_HEAD_PRAY
				end
			end
		end
	return true
	end)
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			pl[i].ldb = getShaman(i).u.Pers.u.Owned.LastDamagedBy
		end
	end
end


--local dropIcon = 0
function OnCreateThing(t)
	--[[if t.Type == T_SPELL then
		KILL_ALL_MSG_ID(dropIcon)
		dropIcon = dropIcon + 1
		CLEAR_ALL_MSG()
	end]]
	if t.Type == T_EFFECT and t.Model == freezeSpell then
		t.u.Effect.Duration = 1
	end
	if (t.Type == T_SPELL) then
		if win == 1 then
			t.Model = M_SPELL_NONE
		end
		if (t.Model == freezeSpell) then
			--t.Model = M_SPELL_NONE
			queue_sound_event(nil,SND_EVENT_FIRE, SEF_FIXED_VARS)
			pl[t.Owner].spellCDR = 8
			pl[t.Owner].spellc3d = CopyC3d(t.Pos.D3)
			pl[t.Owner].spellRefill = 12*10
			local newS = createThing(T_SPELL, M_SPELL_SHIELD, t.Owner, t.Pos.D3, false, false)
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[freezeSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[freezeSpell] & 240
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[freezeSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[freezeSpell] | 0
		end
	end
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/2000)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/2000"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/2000)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/2000"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		--boots icon
		if getShaman(_gnsi.PlayerNum) ~= nil then
			if getShaman(_gnsi.PlayerNum).Flags3 & TF3_BLOODLUST_ACTIVE > 0 then
				local icon = math.floor(h/16)
				DrawBox(math.floor(guiW + 4),math.floor(h-4-icon),icon,icon,0)
				LbDraw_ScaledSprite(math.floor(guiW + 4),math.floor(h-4-icon),get_sprite(0,1731),icon,icon)
			end
		end
		--quantifier icon
		if team1Quantifier > 1 then
			local icon = math.floor(h/16)
			LbDraw_ScaledSprite(math.floor(guiW + 4+8),6+barThickness,get_sprite(0,1732),icon,icon)
		end
		if team2Quantifier > 1 then
			local icon = math.floor(h/16)
			LbDraw_ScaledSprite(math.floor(w-4-icon-8),6+barThickness,get_sprite(0,1732),icon,icon)
		end
			
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end
end


function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_SHAM_HYPNO) or (event == SND_EVENT_ESHAM_HYPNO) then
		return 1
	end
end


--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Chains MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Each team of 4 has 3 players working together, creating a chain")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- They must trap enemy shamans, making them touch the chains, while avoiding enemy chains")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- This 3 players occasionally earn shots of blasts, which can be used to position enemy shamans against your chains, or to damage them")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Chains deal damage to shamans, as well as lower the team's points")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Each team's captain (blue,orange) has a different role:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- They have the unique \"freeze\" spell, which can be used to freeze shamans on the spot for 3 seconds")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- A shaman dying will also lose their team 20 points ; Shamans have 2500 hp ; shamans respawn after 5 seconds")
		imgui.NextColumn()
		imgui.TextUnformatted("- Chains break if the shamans are too far apart")
		imgui.NextColumn()
		imgui.TextUnformatted("Power-ups randomly appear: one gives speed to the shaman (20-30s); the other doubles the team' chain's damage (15s)")
		imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to destroy the enemy points is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points left wins).")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("FREEZE (captains) - hypnotism")
		imgui.NextColumn()
		
		imgui.End()
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(4,30),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2121)