--color battle 4v4

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Building)
import(Module_Spells)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end

local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  SET_NO_REINC(i)
  set_player_reinc_site_off(getPlayer(i))
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 0
local team2Score = 0

----------------------------------------------------spell constants
tmi = thing_move_info()
sti = spells_type_info()

local addedTimer = 8
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)


tmi[TMI_PERSON_MEDICINE_MAN].BaseSpeed = 96
set_correct_gui_menu()
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				id = 0,
				cor = marker_to_coord3d(0),
				speed = -1,
				reinc = -1,
				online = -1,
				team = 0,
				ldb = 8
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 12,
				name = "red",
				id = 1,
				cor = marker_to_coord3d(1),
				speed = -1,
				reinc = -1,
				online = -1,
				team = 0,
				ldb = 8
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 5,
				name = "yellow",
				id = 2,
				cor = marker_to_coord3d(2),
				speed = -1,
				reinc = -1,
				online = -1,
				team = 0,
				ldb = 8
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 3,
				name = "green",
				id = 3,
				cor = marker_to_coord3d(3),
				speed = -1,
				reinc = -1,
				online = -1,
				team = 0,
				ldb = 8
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 7,
				name = "cyan",
				id = 4,
				cor = marker_to_coord3d(4),
				speed = -1,
				reinc = -1,
				online = -1,
				team = 7,
				ldb = 8
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 6,
				name = "magenta",
				id = 5,
				cor = marker_to_coord3d(5),
				speed = -1,
				reinc = -1,
				online = -1,
				team = 7,
				ldb = 8
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 16,
				name = "black",
				id = 6,
				cor = marker_to_coord3d(6),
				speed = -1,
				reinc = -1,
				online = -1,
				team = 7,
				ldb = 8
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				id = 7,
				cor = marker_to_coord3d(7),
				speed = -1,
				reinc = -1,
				online = -1,
				team = 7,
				ldb = 8
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--[[if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil and win < 1 then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil and pl[i].reinc == -1 then
			pl[i].alive = 0
			pl[i].reinc = 12*6
			if i < 4 then
				team2Score = team2Score + 10
			else
				team1Score = team1Score + 10
			end
			--add death visual
			local Dsprite = 24
			if pl[i].ldb ~= 8 then
				Dsprite = 2083 + pl[i].ldb
			end
			local Dname = "..."
			if Dsprite ~= 24 then
				Dname = pl[pl[i].ldb].name
			end
			local Dname2 = pl[i].name
			table.insert(deaths,{Dname,Dname2,Dsprite,2083+i,12*7})
		end
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
local paintPointsSpr = 1734
local paintRemoveSpr = 1735
local paintConvertSpr = 1736
----------------------------------------------------
local power1 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(8),false,false)
power1.DrawInfo.DrawNum = paintPointsSpr
power1.DrawInfo.Alpha = -16 --real colors
power1.Pos.D3.Ypos = power1.Pos.D3.Ypos + 5
--
local power2 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(8),false,false)
power2.DrawInfo.DrawNum = paintPointsSpr
power2.DrawInfo.Alpha = -16 --real colors
power2.Pos.D3.Ypos = power2.Pos.D3.Ypos + 5
--
local power3 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(8),false,false)
power3.DrawInfo.DrawNum = paintPointsSpr	
power3.DrawInfo.Alpha = -16 --real colors
power3.Pos.D3.Ypos = power3.Pos.D3.Ypos + 5
----------------------------------------------------
local power9 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(8),false,false) --remove all enemy colors
power9.DrawInfo.DrawNum = paintRemoveSpr
power9.DrawInfo.Alpha = -16 --real colors
power9.Pos.D3.Ypos = power9.Pos.D3.Ypos + 5
----------------------------------------------------
----------------------------------------------------
local power13 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(8),false,false) --convert all enemy colors
power13.DrawInfo.DrawNum = paintConvertSpr
power13.DrawInfo.Alpha = -16 --real colors
power13.Pos.D3.Ypos = power13.Pos.D3.Ypos + 5


function GetPoints(pn)
	local cnt = 0
	ProcessGlobalTypeList(T_EFFECT,function(c)
		if (c.Type == 7) and (c.Model == 66) then
			if c.Owner == pl[pn].team and c ~= nil then
				c.u.Effect.Duration = 1
				cnt = cnt+1
				c.u.Effect.Duration = 1
			end
		end
	return true end)
	if pn < 4 then
		team1Score = team1Score + cnt
	else
		team2Score = team2Score + cnt
	end
	queue_sound_event(nil, SND_EVENT_BEAMDOWN, SEF_FIXED_VARS)
end

function RemoveEn(pn)
	ProcessGlobalTypeList(T_EFFECT,function(c)
		if (c.Type == 7) and (c.Model == 66) then
			if c.Owner ~= pl[pn].team and c ~= nil then
				c.u.Effect.Duration = 1
				c.u.Effect.Duration = 1
			end
		end
	return true end)
	queue_sound_event(nil, SND_EVENT_BEAMUP, SEF_FIXED_VARS)
end

function ConvertEn(pn)
	ProcessGlobalTypeList(T_EFFECT,function(c)
		if (c.Type == 7) and (c.Model == 66) then
			if c.Owner ~= pl[pn].team and c ~= nil then
				c.u.Effect.Duration = 1
				local s = createThing(T_EFFECT,66,pl[pn].team,c.Pos.D3,false,false)
				s.u.Effect.Duration = -1
				s.DrawInfo.Alpha = pl[pn].color
				s.Pos.D3.Ypos = -128
				c.u.Effect.Duration = 1
			end
		end
	return true end)
	queue_sound_event(nil, SND_EVENT_CMD_MENU_POPUP, SEF_FIXED_VARS)
end

function Paint(pn)
	ProcessGlobalTypeList(T_EFFECT,function(t)
		if (t.Type == 7) and (t.Model == 66) then
			--check if sparkle is enemys:
			if (t.Owner ~= pl[pn].team) and are_coords_on_same_map_cell(getShaman(pn).Pos.D2,t.Pos.D2) == 1 then
				t.u.Effect.Duration = 1 --kill it
			--see if we own one there
			elseif t.Owner == pl[pn].team and are_coords_on_same_map_cell(getShaman(pn).Pos.D2,t.Pos.D2) == 1 then
				pl[pn].paint = pl[pn].paint + 1 --one found!
			end
		end
	return true
	end)
	if pl[pn].paint == 0 then
		local s = createThing(T_EFFECT,66,pl[pn].team,getShaman(pn).Pos.D3,false,false)
		s.u.Effect.Duration = -1
		s.DrawInfo.Alpha = pl[pn].color
		s.Pos.D3.Ypos = -128
	end
end



--
local dist = 256
local paintIcon = 0
local PupTime = 12*6
local PuPEvilTime = 12*8 + 12*(G_RANDOM(12))
local PuP13Time = 12*17 + 12*(G_RANDOM(13))
function OnTurn()

	if win ~= 1 then AliveandOnline() end

	--reset score if too big
	if team1Score > 2000 then team1Score = 2000 end
	if team2Score > 2000 then team2Score = 2000 end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	if win == 0 then
		--give blast shots
		if everySeconds(12) then
			for i = 0,7 do
				if pl[i].alive > 0 then
					local shots = GET_NUM_ONE_OFF_SPELLS(i,M_SPELL_BLAST)
					if shots < 4 then
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] & 240
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] | shots+1
					end
				end
			end
		end
		--give lightning shots to captains
		if everySeconds(30) then
			for k,v in ipairs(captains) do
				if pl[v].alive > 0 then
					local shots = GET_NUM_ONE_OFF_SPELLS(v,M_SPELL_LIGHTNING_BOLT)
					if shots < 4 then
						_gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] & 240
						_gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[v].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] | shots+1
					end
				end
			end
		end
		--win by pts
		if team1Score == 2000 or team2Score == 2000 then
			if team1Score == 2000 and team2Score == 2000 then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		--process timer
		if timer > 0 then
			timer = timer - 1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				gns.GameParams.Flags2 = gns.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
		--revive shamans
		for i = 0,7 do
			if pl[i].online == 1 then
				if getShaman(i) == nil and pl[i].reinc > 0 then
					pl[i].reinc = pl[i].reinc - 1
				elseif getShaman(i) == nil and pl[i].reinc == 0 then
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
					getShaman(i).Flags3 = DisableFlag(getShaman(i).Flags3, TF3_BLOODLUST_ACTIVE)
					pl[i].alive = 1
					pl[i].reinc = -1
				end
			end
		end
		--paint cells
		if timer > 0 then
			for i = 0,7,1 do
				if pl[i].online == 1 and pl[i].alive == 1 then
					if getShaman(i) ~= nil and getShaman(i).Pos.D3.Ypos < 48 then
						Paint(i)
						pl[i].paint = 0 --resets and allows to paint in next cell
					end
				end
			end
		end
		--create boots
		if everySeconds(45) then
			local rpt = 0
			repeat
				rpt = rpt + 1
				local mk = math.random(9,51)
				local has = 0
				SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(marker_to_coord3d(mk)), function(me)
					me.MapWhoList:processList( function (t)
						if t.Type == T_EFFECT or t.Type == T_PERSON or t.Type == T_GENERAL then
							has = 1
						end
					return true end)
				return true end)
				if has == 0 then
					rpt = 100
					local pup = createThing(T_EFFECT,M_EFFECT_FIREBALL,TRIBE_HOSTBOT,marker_to_coord3d(mk),false,false)
					set_thing_draw_info(pup,TDI_SPRITE_F1_D1, 1731)
					pup.Flags2 = EnableFlag(pup.Flags2, TF2_DONT_DRAW_IN_WORLD_VIEW)
					pup.DrawInfo.Alpha = -16
					pup.Pos.D3.Ypos = pup.Pos.D3.Ypos + 4
					pup.u.Effect.Duration = -1
				end
			until rpt > 8
		end
		--catch boots power up
		ProcessGlobalTypeList(T_EFFECT,function(p)
			if p.Model == M_EFFECT_FIREBALL and p.DrawInfo.DrawNum == 1731 then
				for i = 0,7 do
					if getShaman(i) ~= nil and getShaman(i).Pos.D3.Ypos < 48 then
						if get_world_dist_xz(getShaman(i).Pos.D2,p.Pos.D2) <= 192 then
							getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_BLOODLUST_ACTIVE)
							getShaman(i).u.Pers.u.Owned.BloodlustCount = math.random(16,30) -- ~~10-20secs
							p.DrawInfo.DrawNum = 1265
							p.DrawInfo.Alpha = 0
							p.u.Effect.Duration = 1
							queue_sound_event(nil, SND_EVENT_BLDG_ROTATE, SEF_FIXED_VARS)
						end
					end
				end
			end
		return true end)
		--process catching powerups
		if are_coords_on_same_map_cell(marker_to_coord2d(8),power1.Pos.D2) == 0 then
			for i = 0,7,1 do
				if getShaman(i) ~= nil and getShaman(i).Pos.D3.Ypos < 48 then
					if get_world_dist_xz(getShaman(i).Pos.D2,power1.Pos.D2) < dist then
						createThing(T_EFFECT,M_EFFECT_ORBITER,8,getShaman(i).Pos.D3,false,false)
						move_thing_within_mapwho(power1,marker_to_coord3d(8))
						power1.DrawInfo.DrawNum = 54
						power1.DrawInfo.Alpha = 0
						GetPoints(i)
					end
				end
			end
		end
		if are_coords_on_same_map_cell(marker_to_coord2d(8),power2.Pos.D2) == 0 then
			for i = 0,7,1 do
				if getShaman(i) ~= nil and getShaman(i).Pos.D3.Ypos < 48 then
					if get_world_dist_xz(getShaman(i).Pos.D2,power2.Pos.D2) < dist then
						createThing(T_EFFECT,M_EFFECT_ORBITER,8,getShaman(i).Pos.D3,false,false)
						move_thing_within_mapwho(power2,marker_to_coord3d(8))
						power2.DrawInfo.DrawNum = 54
						power2.DrawInfo.Alpha = 0
						GetPoints(i)
					end
				end
			end
		end
		if are_coords_on_same_map_cell(marker_to_coord2d(8),power3.Pos.D2) == 0 then
			for i = 0,7,1 do
				if getShaman(i) ~= nil then
					if get_world_dist_xz(getShaman(i).Pos.D2,power3.Pos.D2) < dist then
						createThing(T_EFFECT,M_EFFECT_ORBITER,8,getShaman(i).Pos.D3,false,false)
						move_thing_within_mapwho(power3,marker_to_coord3d(8))
						power3.DrawInfo.DrawNum = 54
						power3.DrawInfo.Alpha = 0
						GetPoints(i)
					end
				end
			end
		end
		--brush
		if are_coords_on_same_map_cell(marker_to_coord2d(8),power9.Pos.D2) == 0 then
			for i = 0,7,1 do
				if getShaman(i) ~= nil and getShaman(i).Pos.D3.Ypos < 48 then
					if get_world_dist_xz(getShaman(i).Pos.D2,power9.Pos.D2) < dist then
						createThing(T_EFFECT,M_EFFECT_ORBITER,8,getShaman(i).Pos.D3,false,false)
						move_thing_within_mapwho(power9,marker_to_coord3d(8))
						power9.DrawInfo.DrawNum = 54
						power9.DrawInfo.Alpha = 0
						RemoveEn(i)
					end
				end
			end
		end
		--convert
		if are_coords_on_same_map_cell(marker_to_coord2d(8),power13.Pos.D2) == 0 then
			for i = 0,7,1 do
				if getShaman(i) ~= nil and getShaman(i).Pos.D3.Ypos < 48 then
					if get_world_dist_xz(getShaman(i).Pos.D2,power13.Pos.D2) < dist then
						createThing(T_EFFECT,M_EFFECT_ORBITER,8,getShaman(i).Pos.D3,false,false)
						move_thing_within_mapwho(power13,marker_to_coord3d(8))
						power13.DrawInfo.DrawNum = 54
						power13.DrawInfo.Alpha = 0
						ConvertEn(i)
					end
				end
			end
		end
		--process 13PowerUptimer going down
		if PuP13Time > 0 then
			PuP13Time = PuP13Time - 1
		elseif PuP13Time < 1 then
			PuP13Time = 12*17 + 12*(G_RANDOM(13))
			if are_coords_on_same_map_cell(power13.Pos.D2,marker_to_coord2d(8)) == 1 then
				PuP13Time = 12*17 + 12*(G_RANDOM(13))
				local x = math.random(-16,14)
				local z = math.random(-16,14)
				local m = MapPosXZ.new()
				local c3d = Coord3D.new()
				m.XZ.X = x
				m.XZ.Z = z
				map_idx_to_world_coord3d(m.Pos, c3d)
				move_thing_within_mapwho(power13,c3d)
				power13.DrawInfo.DrawNum = paintConvertSpr 
				power13.DrawInfo.Alpha = -16
				power13.Pos.D3.Ypos = power13.Pos.D3.Ypos + 8
				queue_sound_event(nil, SND_EVENT_BLDG_STAMP, SEF_FIXED_VARS)
			end
		end
		--process evilPowerUptimer going down
		if PuPEvilTime > 0 then
			PuPEvilTime = PuPEvilTime - 1
		elseif PuPEvilTime < 1 then
			PuPEvilTime = 12*8 + 12*(G_RANDOM(12))
			if are_coords_on_same_map_cell(power9.Pos.D2,marker_to_coord2d(8)) == 1 then
				PuPEvilTime = 12*8 + 12*(G_RANDOM(12))
				local x = math.random(-16,14)
				local z = math.random(-16,14)
				local m = MapPosXZ.new()
				local c3d = Coord3D.new()
				m.XZ.X = x
				m.XZ.Z = z
				map_idx_to_world_coord3d(m.Pos, c3d)
				move_thing_within_mapwho(power9,c3d)
				power9.DrawInfo.DrawNum = paintRemoveSpr 
				power9.DrawInfo.Alpha = -16
				power9.Pos.D3.Ypos = power9.Pos.D3.Ypos + 8
				queue_sound_event(nil, SND_EVENT_BLDG_STAMP, SEF_FIXED_VARS)
			end
		end
		--process PowerUptimer going down
		if PupTime > 0 then
			PupTime = PupTime - 1
		elseif PupTime < 1 then
			PupTime = 12*5 + G_RANDOM(2)
			local power1Loc = are_coords_on_same_map_cell(power1.Pos.D2,marker_to_coord2d(8))
			local power2Loc = are_coords_on_same_map_cell(power2.Pos.D2,marker_to_coord2d(8))
			local power3Loc = are_coords_on_same_map_cell(power3.Pos.D2,marker_to_coord2d(8))
			if power1Loc == 1 then
				PupTime = 12*5 + G_RANDOM(2)
				local x = math.random(-16,14)
				local z = math.random(-16,14)
				local m = MapPosXZ.new()
				local c3d = Coord3D.new()
				m.XZ.X = x
				m.XZ.Z = z
				map_idx_to_world_coord3d(m.Pos, c3d)
				move_thing_within_mapwho(power1,c3d)
				power1.DrawInfo.DrawNum = paintPointsSpr 
				power1.DrawInfo.Alpha = -16
				power1.Pos.D3.Ypos = power1.Pos.D3.Ypos + 8
				queue_sound_event(nil, SND_EVENT_BLDG_STAMP, SEF_FIXED_VARS)
			elseif power1Loc == 0 and power2Loc == 1 then
				PupTime = 12*5 + G_RANDOM(2)
				local x = math.random(-16,14)
				local z = math.random(-16,14)
				local m = MapPosXZ.new()
				local c3d = Coord3D.new()
				m.XZ.X = x
				m.XZ.Z = z
				map_idx_to_world_coord3d(m.Pos, c3d)
				move_thing_within_mapwho(power2,c3d)
				power2.DrawInfo.DrawNum = paintPointsSpr 
				power2.DrawInfo.Alpha = -16
				power2.Pos.D3.Ypos = power2.Pos.D3.Ypos + 8
				queue_sound_event(nil, SND_EVENT_BLDG_STAMP, SEF_FIXED_VARS)
			elseif power1Loc == 0 and power2Loc == 0 and power3Loc == 1 then
				PupTime = 12*5 + G_RANDOM(2)
				local x = math.random(-16,14)
				local z = math.random(-16,14)
				local m = MapPosXZ.new()
				local c3d = Coord3D.new()
				m.XZ.X = x
				m.XZ.Z = z
				map_idx_to_world_coord3d(m.Pos, c3d)
				move_thing_within_mapwho(power3,c3d)
				power3.DrawInfo.DrawNum = paintPointsSpr 												
				power3.DrawInfo.Alpha = -16
				power3.Pos.D3.Ypos = power3.Pos.D3.Ypos + 8
				queue_sound_event(nil, SND_EVENT_BLDG_STAMP, SEF_FIXED_VARS)
			end
		end
	end
	--process shamans not being targetable
	ProcessGlobalSpecialListAll(0, function(targ)
		if (targ.Type == T_PERSON) and (targ.Model == M_PERSON_MEDICINE_MAN) then
			local cmd = get_thing_curr_cmd_list_ptr(targ)
			if (cmd ~= nil) then
				if (cmd.CommandType == CMD_ATTACK_AREA_2) or (cmd.CommandType == CMD_ATTACK_TARGET) then
					cmd.CommandType = CMD_HEAD_PRAY
				end
			end
		end
	return true
	end)
	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
			smok.DrawInfo.Alpha = pl[i].color ; smok.u.Effect.Duration = 2
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		set_correct_gui_menu()
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
	end
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			pl[i].ldb = getShaman(i).u.Pers.u.Owned.LastDamagedBy
		end
	end
end


function OnCreateThing(t)
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/2000)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/2000"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/2000)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/2000"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		--boots icon
		if getShaman(_gnsi.PlayerNum) ~= nil then
			if getShaman(_gnsi.PlayerNum).Flags3 & TF3_BLOODLUST_ACTIVE > 0 then
				local icon = math.floor(h/16)
				DrawBox(math.floor(guiW + 4),math.floor(h-4-icon),icon,icon,0)
				LbDraw_ScaledSprite(math.floor(guiW + 4),math.floor(h-4-icon),get_sprite(0,1731),icon,icon)
			end
		end
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end
end



--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Color Battle MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Each team has 4 shamans who will colorize the path as they walk")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Walking on non-colorized land will paint it for your team")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Walking on land of your color will do nothing")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Walking on land that is your enemy's color will paint over it, becoming yours")
	   	imgui.NextColumn()
		imgui.TextUnformatted("However, for a team to score points, they must catch the \"color bucket\" power up.")
	   	imgui.NextColumn()
		imgui.TextUnformatted("There are 4 power-ups players can find:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* -Catch \"color bucket\" to get 1 point for each painted tile of your team's color (then the color fades) *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* -Catch \"paint remover spray\" to get rid of the enemy color *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* -Catch \"recolorizer brush\" to make all the enemy tiles your color *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* -Catch \"boots\" to make your shaman faster for 10-20 seconds *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Shamans occasionally earn shots of blast, which can be used to kill and delay the enemy team. Shamans respawn after 5 seconds")
	   	imgui.NextColumn()
		imgui.TextUnformatted("On top of this, team captains (blue,orange) earn 1 lightning spell every 30 seconds")
	   	imgui.NextColumn()
		imgui.TextUnformatted("A shaman dying earns the other team 10 points")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points wins).")
	   	imgui.NextColumn()
		
		imgui.End()
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(254,56),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2122)