--4v4 Deathrun Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Building)
import(Module_Spells)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 0
local team2Score = 0
unwalkableZones = {}
for j = 205,236,1 do
	table.insert(unwalkableZones,j)
end
----------------------------------------------------spell constants
sti = spells_type_info()
tmi = thing_move_info()

local stopSpell = M_SPELL_CONVERT_WILD
sti[stopSpell].OneOffMaximum = 1
sti[stopSpell].WorldCoordRange = 2048
sti[stopSpell].AvailableSpriteIdx = 441
sti[stopSpell].NotAvailableSpriteIdx = 441
sti[stopSpell].ClickedSpriteIdx = 441
sti[stopSpell].CursorSpriteNum = 0
--sti[stopSpell].ToolTipStrIdx = sti[M_SPELL_WHIRLWIND].ToolTipStrIdx
--sti[stopSpell].ToolTipStrIdxLSME = sti[M_SPELL_WHIRLWIND].ToolTipStrIdxLSME
tmi[TMI_PERSON_MEDICINE_MAN].BaseSpeed = 64+32
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
Players = {
			[0] =
			{
				score = 0,
				alive = 1,
				online = -1,
				color = 2,
				drawClr = 4,
				name = "blue",
				id = 0,
				cor = marker_to_coord3d(0),
				laps = 0,
				stage = 1,
				checkpoint = marker_to_coord3d(0)
			},
			{
				score = 0,
				alive = 1,
				online = -1,
				color = 2,
				drawClr = 12,
				name = "red",
				id = 1,
				cor = marker_to_coord3d(1),
				laps = 0,
				stage = 1,
				checkpoint = marker_to_coord3d(1)
			},
			{
				score = 0,
				alive = 1,
				online = -1,
				color = 2,
				drawClr = 5,
				name = "yellow",
				id = 2,
				cor = marker_to_coord3d(2),
				laps = 0,
				stage = 1,
				checkpoint = marker_to_coord3d(2)
			},
			{
				score = 0,
				alive = 1,
				online = -1,
				color = 2,
				drawClr = 3,
				name = "green",
				id = 3,
				cor = marker_to_coord3d(3),
				laps = 0,
				stage = 1,
				checkpoint = marker_to_coord3d(3)
			},
			{
				score = 0,
				alive = 1,
				online = -1,
				color = 9,
				drawClr = 7,
				name = "cyan",
				id = 4,
				cor = marker_to_coord3d(4),
				laps = 0,
				stage = 1,
				checkpoint = marker_to_coord3d(4)
			},
			{
				score = 0,
				alive = 1,
				online = -1,
				color = 9,
				drawClr = 6,
				name = "magenta",
				id = 5,
				cor = marker_to_coord3d(5),
				laps = 0,
				stage = 1,
				checkpoint = marker_to_coord3d(5)
			},
			{
				score = 0,
				alive = 1,
				online = -1,
				color = 9,
				drawClr = 16,
				name = "black",
				id = 6,
				cor = marker_to_coord3d(6),
				laps = 0,
				stage = 1,
				checkpoint = marker_to_coord3d(6)
			},
			{
				score = 0,
				alive = 1,
				online = -1,
				color = 9,
				drawClr = 2,
				name = "orange",
				id = 7,
				cor = marker_to_coord3d(7),
				laps = 0,
				stage = 1,
				checkpoint = marker_to_coord3d(7)
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		Players[pn].name = get_player_name(pn, true)
		local name = #Players[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(Players[pn].name, i, i) 
			end
			Players[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		Players[pn].online = 1
	else
		Players[pn].online = 0
		Players[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		Players[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			Players[i].online = 1
		else
			Players[i].online = 0
			Players[i].alive = 0
			--[[if (string.sub(Players[i].name, 1, 1) ~= "*") and (string.sub(Players[i].name, 1, 8) ~= "NoPlayer") then
				Players[i].name = "*" .. Players[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil then
			Players[i].alive = 0
		end
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
local firstLap = 0 --just for first lap timer info
local firstLapTimer = 0
local firstWinner = 0 --info who finished 2 laps first (16pts and completed game)
local firstWinnerTimer = 0

local flag0 = createThing(T_EFFECT,60,8,marker_to_coord3d(70),false,false) ; set_thing_draw_info(flag0,TDI_SPRITE_F1_D1, 2091) ; flag0.u.Effect.Duration = -1 ; flag0.DrawInfo.Alpha = -16
local flag1 = createThing(T_EFFECT,60,8,marker_to_coord3d(70),false,false) ; set_thing_draw_info(flag1,TDI_SPRITE_F1_D1, 2092) ; flag1.u.Effect.Duration = -1 ; flag1.DrawInfo.Alpha = -16
local flag2 = createThing(T_EFFECT,60,8,marker_to_coord3d(70),false,false) ; set_thing_draw_info(flag2,TDI_SPRITE_F1_D1, 2093) ; flag2.u.Effect.Duration = -1 ; flag2.DrawInfo.Alpha = -16
local flag3 = createThing(T_EFFECT,60,8,marker_to_coord3d(70),false,false) ; set_thing_draw_info(flag3,TDI_SPRITE_F1_D1, 2094) ; flag3.u.Effect.Duration = -1 ; flag3.DrawInfo.Alpha = -16
local flag4 = createThing(T_EFFECT,60,8,marker_to_coord3d(70),false,false) ; set_thing_draw_info(flag4,TDI_SPRITE_F1_D1, 2095) ; flag4.u.Effect.Duration = -1 ; flag4.DrawInfo.Alpha = -16
local flag5 = createThing(T_EFFECT,60,8,marker_to_coord3d(70),false,false) ; set_thing_draw_info(flag5,TDI_SPRITE_F1_D1, 2096) ; flag5.u.Effect.Duration = -1 ; flag5.DrawInfo.Alpha = -16
local flag6 = createThing(T_EFFECT,60,8,marker_to_coord3d(70),false,false) ; set_thing_draw_info(flag6,TDI_SPRITE_F1_D1, 2097) ; flag6.u.Effect.Duration = -1 ; flag6.DrawInfo.Alpha = -16
local flag7 = createThing(T_EFFECT,60,8,marker_to_coord3d(70),false,false) ; set_thing_draw_info(flag7,TDI_SPRITE_F1_D1, 2098) ; flag7.u.Effect.Duration = -1 ; flag7.DrawInfo.Alpha = -16

function CrowdCheering()
	ProcessGlobalSpecialListAll(0, function(t)
		if t.Model ~=  M_PERSON_MEDICINE_MAN then
			if math.random(10) < 3 then
				local r = math.random(0,6)
				if r == 0 then set_person_draw_info_by_anim(t,S_ANIM_BRAVE_CHEER_A) elseif r == 1 then set_person_draw_info_by_anim(t,S_ANIM_BRAVE_CHEER_B) elseif r == 2 then set_person_draw_info_by_anim(t,S_ANIM_BRAVE_CHEER_C)
				elseif r == 5 then set_person_draw_info_by_anim(t,S_ANIM_BRAVE_PADDLE) elseif r > 5 then if math.random(0,30) < 4 then set_person_draw_info_by_anim(t,S_ANIM_BRAVE_JUMP) end end
			end
		end
	return true end)
end

function Unwalkable()
	for i,KEY in ipairs(unwalkableZones) do --unwalkable markers
		local mk2c3d = marker_to_coord3d(KEY)
		SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(mk2c3d), function(me)
			me.Flags = EnableFlag(me.Flags, (1<<2))
			me.Flags = EnableFlag(me.Flags, (1<<19))
		return true
		end)
	end
end

local SomeoneOnStage1, SomeoneOnStage2, SomeoneOnStage3, SomeoneOnStage4, SomeoneOnStage5, SomeoneOnStage6 = true, false, false, false, false, false
function SomeoneOnStageX()
	local a = 0
	for i = 0,7 do
		if Players[i].online == 1 and getShaman(i) ~= nil and Players[i].stage == 1 then
			a = a + 1 break
		end
	end
	if a > 0 then SomeoneOnStage1 = true else SomeoneOnStage1 = false end
	--
	local a = 0
	for i = 0,7 do
		if Players[i].online == 1 and getShaman(i) ~= nil and Players[i].stage == 2 then
			a = a + 1 break
		end
	end
	if a > 0 then SomeoneOnStage2 = true else SomeoneOnStage2 = false end
	--
	local a = 0
	for i = 0,7 do
		if Players[i].online == 1 and getShaman(i) ~= nil and Players[i].stage == 3 then
			a = a + 1 break
		end
	end
	if a > 0 then SomeoneOnStage3 = true else SomeoneOnStage3 = false end
	--
	local a = 0
	for i = 0,7 do
		if Players[i].online == 1 and getShaman(i) ~= nil and Players[i].stage == 4 then
			a = a + 1 break
		end
	end
	if a > 0 then SomeoneOnStage4 = true else SomeoneOnStage4 = false end
	--
	local a = 0
	for i = 0,7 do
		if Players[i].online == 1 and getShaman(i) ~= nil and Players[i].stage == 5 then
			a = a + 1 break
		end
	end
	if a > 0 then SomeoneOnStage5 = true else SomeoneOnStage5 = false end
	--
	local a = 0
	for i = 0,7 do
		if Players[i].online == 1 and getShaman(i) ~= nil and Players[i].stage == 6 then
			a = a + 1 break
		end
	end
	if a > 0 then SomeoneOnStage6 = true else SomeoneOnStage6 = false end
end

function Checkpoint()
	for i = 0,7 do
		for mk = 8,12 do
			if IS_SHAMAN_IN_AREA(i,mk,1) == 1 then
				if Players[i].stage < mk-6 and Players[i].stage ~= 6 then
					--get score
					Players[i].score = Players[i].score + 1
					if Players[i].score < 16 then
						if i < 4 then
							team1Score = team1Score + 1
						else
							team2Score = team2Score + 1
						end
					end
					queue_sound_event(nil,SND_EVENT_BLDG_STAMP, SEF_FIXED_VARS)
					--set stage
					Players[i].stage = mk-6
					--move flags
					if i == 0 then if flag0 ~= nil then move_thing_within_mapwho(flag0,marker_to_coord3d(13+(8*(Players[i].stage-2))+i)) ; centre_coord3d_on_block(flag0.Pos.D3) end 
					elseif i == 1 then if flag1 ~= nil then move_thing_within_mapwho(flag1,marker_to_coord3d(13+(8*(Players[i].stage-2))+i)) ; centre_coord3d_on_block(flag1.Pos.D3) end 
					elseif i == 2 then if flag1 ~= nil then move_thing_within_mapwho(flag2,marker_to_coord3d(13+(8*(Players[i].stage-2))+i)) ; centre_coord3d_on_block(flag2.Pos.D3) end 
					elseif i == 3 then if flag1 ~= nil then move_thing_within_mapwho(flag3,marker_to_coord3d(13+(8*(Players[i].stage-2))+i)) ; centre_coord3d_on_block(flag3.Pos.D3) end 
					elseif i == 4 then if flag1 ~= nil then move_thing_within_mapwho(flag4,marker_to_coord3d(13+(8*(Players[i].stage-2))+i)) ; centre_coord3d_on_block(flag4.Pos.D3) end 
					elseif i == 5 then if flag1 ~= nil then move_thing_within_mapwho(flag5,marker_to_coord3d(13+(8*(Players[i].stage-2))+i)) ; centre_coord3d_on_block(flag5.Pos.D3) end 
					elseif i == 6 then if flag1 ~= nil then move_thing_within_mapwho(flag6,marker_to_coord3d(13+(8*(Players[i].stage-2))+i)) ; centre_coord3d_on_block(flag6.Pos.D3) end 
					elseif i == 7 then if flag1 ~= nil then move_thing_within_mapwho(flag7,marker_to_coord3d(13+(8*(Players[i].stage-2))+i)) ; centre_coord3d_on_block(flag7.Pos.D3) end end
				end
			end
		end
	end
end

function LapFinish(i)
	if Players[i].stage == 6 then
		--check if first lap of game for casual info:
		if firstLap == 0 then
			firstLap = 1
			log_msg(8, "" .. Players[i].name .. " was the first player to finish a full lap, in just " .. TurnsToClock(math.floor(firstLapTimer/12)) .. " !")
			queue_sound_event(nil,SND_EVENT_NEWPLAYER, SEF_FIXED_VARS)
		elseif firstLap == 1 then
			firstLap = 2
			log_msg(8, "" .. Players[i].name .. " was the first player to finish both laps, in just " .. TurnsToClock(math.floor(firstWinnerTimer/12)) .. ", completing the run (16pts)!")
			queue_sound_event(nil,SND_EVENT_NEWPLAYER, SEF_FIXED_VARS)
		end
		--get score
		if Players[i].score < 16 then
			if i < 4 then
				team1Score = team1Score + 3
			else
				team2Score = team2Score + 3
			end
		end
		Players[i].score = Players[i].score + 3
		Players[i].stage = 1
		Players[i].laps = Players[i].laps + 1
		if Players[i].score == 16 then
			queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
			log_msg(8, "" .. Players[i].name .. " has finished the two laps, scoring 16 points for the team!")
		else
			queue_sound_event(nil,SND_EVENT_NEWPLAYER, SEF_FIXED_VARS)
		end
		if i == 0 then if flag0 ~= nil then move_thing_within_mapwho(flag0,marker_to_coord3d(i)) ; centre_coord3d_on_block(flag0.Pos.D3) end 
		elseif i == 1 then if flag1 ~= nil then move_thing_within_mapwho(flag1,marker_to_coord3d(i)) ; centre_coord3d_on_block(flag1.Pos.D3) end 
		elseif i == 2 then if flag1 ~= nil then move_thing_within_mapwho(flag2,marker_to_coord3d(i)) ; centre_coord3d_on_block(flag2.Pos.D3) end 
		elseif i == 3 then if flag1 ~= nil then move_thing_within_mapwho(flag3,marker_to_coord3d(i)) ; centre_coord3d_on_block(flag3.Pos.D3) end 
		elseif i == 4 then if flag1 ~= nil then move_thing_within_mapwho(flag4,marker_to_coord3d(i)) ; centre_coord3d_on_block(flag4.Pos.D3) end 
		elseif i == 5 then if flag1 ~= nil then move_thing_within_mapwho(flag5,marker_to_coord3d(i)) ; centre_coord3d_on_block(flag5.Pos.D3) end 
		elseif i == 6 then if flag1 ~= nil then move_thing_within_mapwho(flag6,marker_to_coord3d(i)) ; centre_coord3d_on_block(flag6.Pos.D3) end 
		elseif i == 7 then if flag1 ~= nil then move_thing_within_mapwho(flag7,marker_to_coord3d(i)) ; centre_coord3d_on_block(flag7.Pos.D3) end end
	end
end

function LavaSquares2()
	stage2CDR = 8
	for key, value in ipairs(lavaTable) do
		local c3d = Coord3D.new()
		map_idx_to_world_coord3d_centre(value,c3d)
		local s = createThing(T_EFFECT,M_EFFECT_FIREBALL_2,TRIBE_NEUTRAL,c3d,false,false)
		s.Pos.D3.Ypos = -128
		s.u.Effect.Duration = 6
		--kill shamans
		for i = 0,7 do
			if getShaman(i) ~= nil and get_world_dist_xz(getShaman(i).Pos.D2,s.Pos.D2) < 256+32 then
				createThing(T_EFFECT,M_EFFECT_SPHERE_EXPLODE_1,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
				queue_sound_event(getShaman(i), SND_EVENT_ANGEL_BLAST, SEF_PLAY_ME)
				move_thing_within_mapwho(getShaman(i),marker_to_coord3d((13+(8*(Players[i].stage-2))+i)))
				MOVE_SHAMAN_TO_MARKER(i,(126+Players[i].stage))
			end
		end
	end
end

local moveA = 0
local moveB = 0
local moveC = 0
local moveD = 0
local moveE = 0
function MoveFires4()
	ProcessGlobalTypeList(T_EFFECT,function(t)
		if (t.Type == 7) and (t.Model == M_EFFECT_WW_ELEMENT) then
			local a = 0
			for i = 88,92 do
				if are_coords_on_same_map_cell(t.Pos.D2,marker_to_coord2d(i)) == 1 then
					a = 1 break
				end
			end
			if a == 1 then
				if moveA == 0 then
					if t.Pos.D3.Ypos < 512 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos + 32
					else
						moveA = 1
					end
				else
					if t.Pos.D3.Ypos > 8 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos - 32
					else
						moveA = 0
					end
				end
			end
			--
			local a = 0
			for i = 93,97 do
				if are_coords_on_same_map_cell(t.Pos.D2,marker_to_coord2d(i)) == 1 then
					a = 1 break
				end
			end
			if a == 1 then
				if moveB == 0 then
					if t.Pos.D3.Ypos < 512 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos + 48
					else
						moveB = 1
					end
				else
					if t.Pos.D3.Ypos > 8 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos - 48
					else
						moveB = 0
					end
				end
			end
			--
			local a = 0
			for i = 98,102 do
				if are_coords_on_same_map_cell(t.Pos.D2,marker_to_coord2d(i)) == 1 then
					a = 1 break
				end
			end
			if a == 1 then
				if moveC == 0 then
					if t.Pos.D3.Ypos < 320 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos + 42
					else
						moveC = 1
					end
				else
					if t.Pos.D3.Ypos > 8 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos - 42
					else
						moveC = 0
					end
				end
			end
			--
			local a = 0
			for i = 103,114 do
				if are_coords_on_same_map_cell(t.Pos.D2,marker_to_coord2d(i)) == 1 then
					a = 1 break
				end
			end
			if a == 1 then
				if moveD == 0 then
					if t.Pos.D3.Ypos < 128 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos + 56
					else
						moveD = 1
					end
				else
					if t.Pos.D3.Ypos > -460 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos - 56
					else
						moveD = 0
					end
				end
			end
			--
			local a = 0
			for i = 115,126 do
				if are_coords_on_same_map_cell(t.Pos.D2,marker_to_coord2d(i)) == 1 then
					a = 1 break
				end
			end
			if a == 1 then
				if moveE == 0 then
					if t.Pos.D3.Ypos < 256 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos + 8
					else
						moveE = 1
					end
				else
					if t.Pos.D3.Ypos > 8 then
						 t.Pos.D3.Ypos =  t.Pos.D3.Ypos - 8
					else
						moveE = 0
					end
				end
			end
			--kill
			for i = 0,7 do
				if getShaman(i) ~= nil and are_coords_on_same_map_cell(getShaman(i).Pos.D2,t.Pos.D2) == 1 then
					local x = (t.Pos.D3.Xpos - getShaman(i).Pos.D3.Xpos)
					local z = (t.Pos.D3.Zpos - getShaman(i).Pos.D3.Zpos)
					local y = (t.Pos.D3.Ypos)
					if (y < 128) and (y > 0) then
						if (x < 256) and (z < 256) then
							createThing(T_EFFECT,M_EFFECT_SPHERE_EXPLODE_1,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
							queue_sound_event(getShaman(i), SND_EVENT_ANGEL_BLAST, SEF_PLAY_ME)
							move_thing_within_mapwho(getShaman(i),marker_to_coord3d((13+(8*(Players[i].stage-2))+i)))
							MOVE_SHAMAN_TO_MARKER(i,(126+Players[i].stage))
						end
					end
				end
			end
		end
	return true
	end)
end

----------------------------------------
--vars for traps
--stage2:
local stage2Timer = -1
local stage2CDR = -1
lavaTable = {}
--stage3:
local sinkPhase = 1
local stage3CDR = -1
--stage 4:
for i = 88,126 do
	local a = createThing(T_EFFECT,M_EFFECT_WW_ELEMENT,TRIBE_NEUTRAL,marker_to_coord3d(i),false,false)
	centre_coord3d_on_block(a.Pos.D3)
	a.u.Effect.Duration = -1
	set_thing_draw_info(a,TDI_SPRITE_F1_D1, 1120)
	if i <= 92 then a.DrawInfo.Alpha = 6
	elseif i <= 97 then a.DrawInfo.Alpha = 7 
	elseif i <= 102 then a.DrawInfo.Alpha = 0 
	elseif i <= 114 then a.DrawInfo.Alpha = 9 
	else a.DrawInfo.Alpha = 2 end
end
--stage5:
local wallZones = {133,139,145,151,157,163,169,175,181,187,193,199,205,211,217,223,229,235}
local createWallCDR = 0
local windTable = {}
local splashTable = {}
m1 = MapPosXZ.new()
for x=160,170,2 do
    for z=68,102,2 do
        m1.XZ.X = x
        m1.XZ.Z = z
        table.insert(splashTable, m1.Pos)
    end
end
--stage6:
local generateLightsCDR = 0
local randomMK1 = math.random(241,254)
local randomMK2 = math.random(241,254)
local randomMK3 = math.random(241,254)
local randomMK4 = math.random(241,254)
local size1, size2, size3, size4 = 0,0,0,0
--anti cheat zones
antiCheatZones = {56,57,58,59,60,61,62,63,65,66,67,68}
----------------------------------------


function OnTurn()
																				--log_msg(8,"" .. Players[0].score)
	if win ~= 1 then AliveandOnline() end
	
	--first lap info
	if firstLap == 0 and win == 0 then
		firstLapTimer = firstLapTimer + 1
	end
	if firstWinner == 0 and win == 0 then
		firstWinnerTimer = firstWinnerTimer + 1
	end
	
	--anti cheat zones (sides)
	for k,v in ipairs(antiCheatZones) do
		for i = 0,7 do
			if getShaman(i) ~= nil then
				--if get_world_dist_xz(getShaman(i).Pos.D2, marker_to_coord2d(v)) < 512 then
				if are_coords_on_same_map_cell(getShaman(i).Pos.D2, marker_to_coord2d(v)) == 1 then
					if Players[i].score < 16 then
						if Players[i].stage == 1 then
							move_thing_within_mapwho(getShaman(i),marker_to_coord3d(i))
						else
							move_thing_within_mapwho(getShaman(i),marker_to_coord3d((13+(8*(Players[i].stage-2))+i)))
						end
						MOVE_SHAMAN_TO_MARKER(i,(126+Players[i].stage))
						log_msg(8,"Stop cheating, " .. Players[i].name .. "!")
					end
				end
			end
		end
	end
	
	--stage6 traps (deadly circles)
	if SomeoneOnStage6 then
		if generateLightsCDR > 0 then
			generateLightsCDR = generateLightsCDR - 1
			if generateLightsCDR <= 12 then
				--kill ppl inside
				for i = 0,7 do
					if getShaman(i) ~= nil then
						local dist1 = get_world_dist_xyz(getShaman(i).Pos.D3, marker_to_coord3d(randomMK1))
						local dist2 = get_world_dist_xyz(getShaman(i).Pos.D3, marker_to_coord3d(randomMK2))
						local dist3 = get_world_dist_xyz(getShaman(i).Pos.D3, marker_to_coord3d(randomMK3))
						local dist4 = get_world_dist_xyz(getShaman(i).Pos.D3, marker_to_coord3d(randomMK4))
						if (dist1 < (512 * size1)) or (dist2 < (512 * size2)) or(dist3 < (512 * size3)) or(dist4 < (512 * size4)) then
							queue_sound_event(getShaman(i), SND_EVENT_INVIS_OFF, SEF_PLAY_ME)
							move_thing_within_mapwho(getShaman(i),marker_to_coord3d((13+(8*(Players[i].stage-2))+i)))
							MOVE_SHAMAN_TO_MARKER(i,(126+Players[i].stage))
						end
					end
				end
				local clr = math.random(1,10)
				ProcessGlobalTypeList(T_EFFECT,function(t)
					if (t.Type == 7) and (t.Model == 61) then
						if t.DrawInfo.Alpha == 0 then t.DrawInfo.Alpha = clr end
					end
				return true end)
			end
		else
			SearchMapCells(SQUARE, 0, 0 , 4, world_coord3d_to_map_idx(marker_to_coord3d(247)), function(me)
					me.ShadeIncr = 0
				return true
				end)
			generateLightsCDR = 24
			repeat
				randomMK1 = math.random(241,254)
				randomMK2 = math.random(241,254)
				randomMK3 = math.random(241,254)
			until randomMK1 ~= randomMK2 and randomMK1 ~= randomMK3 and randomMK2 ~= randomMK3
			size1, size2, size3, size4 = math.random(1,3),2,math.random(1,3),math.random(1,2)
			for i=0,64 do
			  local rotation = (((i * 8)) * math.pi) / 180
			  local c3d = Coord3D.new()
			  c3d.Xpos = marker_to_coord3d(randomMK1).Xpos + math.floor((math.cos(rotation) * (512 * size1)))
			  c3d.Zpos = marker_to_coord3d(randomMK1).Zpos + math.floor((math.sin(rotation) * (512 * size1)))
			  local m = createThing(7, 61, 8, c3d, false, false)
			  m.Pos.D3.Ypos = 0
			  m.DrawInfo.Alpha = 0
			  m.u.Effect.Duration = 23
			end
			for i=0,64 do
			  local rotation = (((i * 8)) * math.pi) / 180
			  local c3d = Coord3D.new()
			  c3d.Xpos = marker_to_coord3d(randomMK2).Xpos + math.floor((math.cos(rotation) * (512 * size2)))
			  c3d.Zpos = marker_to_coord3d(randomMK2).Zpos + math.floor((math.sin(rotation) * (512 * size2)))
			  local m = createThing(7, 61, 8, c3d, false, false)
			  m.Pos.D3.Ypos = 0
			  m.DrawInfo.Alpha = 0
			  m.u.Effect.Duration = 23
			end
			for i=0,64 do
			  local rotation = (((i * 8)) * math.pi) / 180
			  local c3d = Coord3D.new()
			  c3d.Xpos = marker_to_coord3d(randomMK3).Xpos + math.floor((math.cos(rotation) * (512 * size3)))
			  c3d.Zpos = marker_to_coord3d(randomMK3).Zpos + math.floor((math.sin(rotation) * (512 * size3)))
			  local m = createThing(7, 61, 8, c3d, false, false)
			  m.Pos.D3.Ypos = 0
			  m.DrawInfo.Alpha = 0
			  m.u.Effect.Duration = 23
			end
			for i=0,64 do
			  local rotation = (((i * 8)) * math.pi) / 180
			  local c3d = Coord3D.new()
			  c3d.Xpos = marker_to_coord3d(randomMK4).Xpos + math.floor((math.cos(rotation) * (512 * size4)))
			  c3d.Zpos = marker_to_coord3d(randomMK4).Zpos + math.floor((math.sin(rotation) * (512 * size4)))
			  local m = createThing(7, 61, 8, c3d, false, false)
			  m.Pos.D3.Ypos = 0
			  m.DrawInfo.Alpha = 0
			  m.u.Effect.Duration = 23
			end
		end
	end
	
	--stage5 traps (windwalls)
	if SomeoneOnStage5 then
		if createWallCDR > 0 then
			createWallCDR = createWallCDR - 1
			if createWallCDR < 20 then
				--splashes
				if every2Pow(1) then
					local randomSplash = splashTable[math.random(#splashTable)]
					local c3d = Coord3D.new()
					map_idx_to_world_coord3d_centre(randomSplash,c3d)
					createThing(T_EFFECT,M_EFFECT_SPLASH,TRIBE_NEUTRAL,c3d,false,false)
				end
				--winds
				for k,v in ipairs(windTable) do
					for i = v,v+5 do
						for j = 0,7 do
							if getShaman(j) ~= nil then
								if IS_SHAMAN_IN_AREA(j,i,0) == 1 then
									queue_sound_event(getShaman(j), SND_EVENT_SP_WHIRLWIND, SEF_PLAY_ME)
									--getShaman(j).Pos.D3.Ypos = getShaman(j).Pos.D3.Ypos +128 -- nah fuck that lol
									--getShaman(j).Pos.D3.Xpos = getShaman(j).Pos.D3.Xpos - 248 --old way
									local c3d = CopyC3d(getShaman(j).Pos.D3)
									c3d.Xpos = c3d.Xpos - 220
									move_thing_within_mapwho(getShaman(j), c3d)
									
								end
							end
						end
						--create winds vfx
						if i ~= v and i ~= v+1 then
							local r = math.random(100)
							if r < 5 then
								local w = createThing(T_EFFECT,M_EFFECT_WW_DUST,TRIBE_NEUTRAL,marker_to_coord3d(i),false,false)
								w.u.Effect.Duration = createWallCDR + math.random(1,6)
							end
						end
					end
				end
			end
		else
			createWallCDR = 12*4
			windTable = {}
			for k,v in ipairs(wallZones) do
				local rnd = math.random(0,100)
				if rnd < 28 + G_RANDOM(17) then
					SearchMapCells(SQUARE,2,0,1,world_coord3d_to_map_idx(marker_to_coord3d(v)), function (me)
						me.Alt = 512
						set_square_map_params(world_coord3d_to_map_idx(marker_to_coord3d(v)),0,TRUE)
					return true
					end)
				else
					table.insert(windTable,v)
					SearchMapCells(SQUARE,2,0,1,world_coord3d_to_map_idx(marker_to_coord3d(v)), function (me)
						me.Alt = 0
						set_square_map_params(world_coord3d_to_map_idx(marker_to_coord3d(v)),0,TRUE)
					return true
					end)
				end
			end
		end
	end
	
	--stage4 traps (fire lines updown)
	if SomeoneOnStage4 then
		MoveFires4()
	end
	
	--stage3 traps (sinkbridges)
	if SomeoneOnStage3 and stage3CDR == -1 then
		if sinkPhase == 1 then
			TRIGGER_THING (53)
			sinkPhase = 2
			stage3CDR = 12*4
		else
			TRIGGER_THING (54)
			TRIGGER_THING (55)
			sinkPhase = 1
			stage3CDR = 33
		end
	end
	if stage3CDR > 0 then
		stage3CDR = stage3CDR - 1
	else
		stage3CDR = -1
	end
	
	--stage2 traps (hot zones)
	if SomeoneOnStage2 then			
		if stage2CDR > 0 then
			stage2CDR = stage2CDR - 1
		else
			stage2CDR = -1
		end
		if stage2Timer == -1 then
			stage2Timer = 12
			lavaTable = {}
			local aa = 0
			repeat
				local m1 = MapPosXZ.new()
				m1.XZ.X = math.random(64,74)
				m1.XZ.Z = math.random(56,94)
				table.insert(lavaTable, m1.Pos)
				aa = aa + 1
			until aa >= 44
			for key, value in ipairs(lavaTable) do
				local c3d = Coord3D.new()
				map_idx_to_world_coord3d_centre(value,c3d)
				local s = createThing(T_EFFECT,M_EFFECT_FIREBALL,TRIBE_NEUTRAL,c3d,false,false)
				s.u.Effect.Duration = 10
			end
		else
			if stage2Timer > 0 then
				stage2Timer = stage2Timer - 1
			elseif stage2Timer == 0 then
				stage2Timer = -1
				LavaSquares2()
			end
		end
	end

	--timer
	if win == 0 then
		if every2Pow(2) then
			--check if ppl on stages, so that stuff happens there vs pause
			SomeoneOnStageX()
			--checkpoints
			Checkpoint()
			--check if lap
			for i = 0,7 do
				if IS_SHAMAN_IN_AREA(i,4,1) == 1 then
					LapFinish(i)
				end
			end
			--checkpoint coords
			for i = 0,7 do
				if Players[i].online == 1 then
					if Players[i].stage ~= 1 then
						Players[i].checkpoint = marker_to_coord3d(Players[i].stage+6)
					else
						Players[i].checkpoint = marker_to_coord3d(4)
					end
				end
			end
		end
		if every2Pow(3) then
			for i = 0,7 do
				--reinc shaman
				if Players[i].online == 1 and getShaman(i) == nil then
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,Players[i].checkpoint,false,false)
				end
				--give spell if bug
				if GET_NUM_ONE_OFF_SPELLS(i,stopSpell) == 0 then
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[stopSpell] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[stopSpell] & 240
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[stopSpell] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[stopSpell] | 1
				end
			end
		end
		--win by pts
		if team1Score == 64 or team2Score == 64 then
			if team1Score == 64 and team2Score == 64 then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,Players[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,Players[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,Players[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		if timer > 0 then
			timer = timer -1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,Players[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,Players[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	
	if every2Pow(math.random(1,4)) then
		CrowdCheering()
	end

	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
			smok.DrawInfo.Alpha = Players[i].color ; smok.u.Effect.Duration = 2
			smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 32
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12*60*10 + 12 --10mins
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		for i = 0,7 do
			GIVE_ONE_SHOT(stopSpell,i)
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
		if flag0 ~= nil then move_thing_within_mapwho(flag0,marker_to_coord3d(0)) ; centre_coord3d_on_block(flag0.Pos.D3) end
		if flag1 ~= nil then move_thing_within_mapwho(flag1,marker_to_coord3d(1)) ; centre_coord3d_on_block(flag1.Pos.D3) end
		if flag2 ~= nil then move_thing_within_mapwho(flag2,marker_to_coord3d(2)) ; centre_coord3d_on_block(flag2.Pos.D3) end
		if flag3 ~= nil then move_thing_within_mapwho(flag3,marker_to_coord3d(3)) ; centre_coord3d_on_block(flag3.Pos.D3) end
		if flag4 ~= nil then move_thing_within_mapwho(flag4,marker_to_coord3d(4)) ; centre_coord3d_on_block(flag4.Pos.D3) end
		if flag5 ~= nil then move_thing_within_mapwho(flag5,marker_to_coord3d(5)) ; centre_coord3d_on_block(flag5.Pos.D3) end
		if flag6 ~= nil then move_thing_within_mapwho(flag6,marker_to_coord3d(6)) ; centre_coord3d_on_block(flag6.Pos.D3) end
		if flag7 ~= nil then move_thing_within_mapwho(flag7,marker_to_coord3d(7)) ; centre_coord3d_on_block(flag7.Pos.D3) end
	end
	--process shamans not being targetable
	ProcessGlobalSpecialListAll(0, function(targ)
		if (targ.Type == T_PERSON) then
			local cmd = get_thing_curr_cmd_list_ptr(targ)
			if (cmd ~= nil) then
				if (cmd.CommandType == CMD_ATTACK_AREA_2) or (cmd.CommandType == CMD_ATTACK_TARGET) then
					cmd.CommandType = CMD_HEAD_PRAY
				end
			end
		end
	return true
	end)
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
end



function OnCreateThing(t)
	if (t.Type == T_EFFECT) and (t.Model == M_EFFECT_CONVERT_WILD) then
		t.u.Effect.Duration = 1
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and Players[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/64)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/64"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/64)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/64"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		--show tips what to do
		if win == 0 then
			if Players[_gnsi.PlayerNum].laps == 0 then
				local line1h = math.floor(h-12-(24*2))
				local line2h = math.floor(h-12-(24*1))
				
				local string1a = "Stage 1: Slow terrain"
				local string1b = "Aid yourself by spellwalking"
				
				local string2a = "Stage 2: Quick mines and mountain"
				local string2b = "Dodge the explosions, and blast trick to fall off the mountain"
				
				local string3a = "Stage 3: Sinking Bridges"
				local string3b = "Right before the bridge sinks, cast a spell to survive"
				
				local string4a = "Stage 4: Bouncing Fireballs"
				local string4b = "Don't let them hit your shaman"
				
				local string5a = "Stage 5: Windwalls and mountain climb"
				local string5b = "Avoid the eastern winds by taking cover behind a wall, if you're lucky"
				
				local string6a = "Stage 6: Deadly Circles"
				local string6b = "Dont touch or be inside any circle once they become colored"
				--
				PopSetFont(3)
				if Players[_gnsi.PlayerNum].stage == 1 then
					LbDraw_Text(math.floor(middle2-(string_width(string1a)/2)),line1h,tostring(string1a),0)
					LbDraw_Text(math.floor(middle2-(string_width(string1b)/2)),line2h,tostring(string1b),0)
				elseif Players[_gnsi.PlayerNum].stage == 2 then
					LbDraw_Text(math.floor(middle2-(string_width(string2a)/2)),line1h,tostring(string2a),0)
					LbDraw_Text(math.floor(middle2-(string_width(string2b)/2)),line2h,tostring(string2b),0)
				elseif Players[_gnsi.PlayerNum].stage == 3 then
					LbDraw_Text(math.floor(middle2-(string_width(string3a)/2)),line1h,tostring(string3a),0)
					LbDraw_Text(math.floor(middle2-(string_width(string3b)/2)),line2h,tostring(string3b),0)
				elseif Players[_gnsi.PlayerNum].stage == 4 then
					LbDraw_Text(math.floor(middle2-(string_width(string4a)/2)),line1h,tostring(string4a),0)
					LbDraw_Text(math.floor(middle2-(string_width(string4b)/2)),line2h,tostring(string4b),0)
				elseif Players[_gnsi.PlayerNum].stage == 5 then
					LbDraw_Text(math.floor(middle2-(string_width(string5a)/2)),line1h,tostring(string5a),0)
					LbDraw_Text(math.floor(middle2-(string_width(string5b)/2)),line2h,tostring(string5b),0)
				elseif Players[_gnsi.PlayerNum].stage == 6 then
					LbDraw_Text(math.floor(middle2-(string_width(string6a)/2)),line1h,tostring(string6a),0)
					LbDraw_Text(math.floor(middle2-(string_width(string6b)/2)),line2h,tostring(string6b),0)
				end
			end
			--finished
			local line1h = math.floor(h-12-(24*2))
			local line2h = math.floor(h-12-(24*1))
			
			local string1a = "You have completed 2 laps and scored 16 points"
			local string1b = "You can still play but not score any more points"
			if Players[_gnsi.PlayerNum].score >= 16 then
				LbDraw_Text(math.floor(middle2-(string_width(string1a)/2)),line1h,tostring(string1a),0)
				LbDraw_Text(math.floor(middle2-(string_width(string1b)/2)),line2h,tostring(string1b),0)
			end
		end
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
		end
	end
end

------------------------------------------------------------------------------------------
--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Deathrun MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Players run this deadly olympic marathon, reaching as far as possible before the timer ends")
	   	imgui.NextColumn()
		imgui.TextUnformatted("6 stages per lap, each stage has unique difficulties/obstacles")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Each stage earns the team 1 point; Each completed lap earns the team 3 points (meaning 8 total points per lap per shaman)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Checkpoints before each stage - shamans instantly reincarnate there if they die")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* Use the infinite-free spell to spellwalk/blasttrick, etc *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("(Though, shamans are not allowed to spellwalk through the side of mountains/hill climbings (cheat))")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* Read each stage's description on the bottom of the screen (only during your first lap) *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Stage traps:")
		imgui.NextColumn()
		imgui.TextUnformatted("1: slow terrain")
		imgui.NextColumn()
		imgui.TextUnformatted("2: quick explosive mines and mountain climb/jump")
		imgui.NextColumn()
		imgui.TextUnformatted("3: sinking bridges")
		imgui.NextColumn()
		imgui.TextUnformatted("4: bouncing fireballs")
		imgui.NextColumn()
		imgui.TextUnformatted("5: wind walls and mountain")
		imgui.NextColumn()
		imgui.TextUnformatted("6: deadly circles")
		imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective (each shaman finishing 2 laps (64 pts)) is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 10 minutes (whoever has most points wins).")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("BLANK SPELL - convert")
		imgui.NextColumn()
		
		imgui.End()
	end
end

--create crowd
crowdTable = {}
local m = MapPosXZ.new()
for x = -52,40,2 do
	m.XZ.X = x
    m.XZ.Z = 64
    table.insert(crowdTable, m.Pos)
end
for x = -52,40,2 do
	m.XZ.X = x
       m.XZ.Z = 110
       table.insert(crowdTable, m.Pos)
end
for Z = 66,108,2 do
	m.XZ.X = 40
    m.XZ.Z = Z
    table.insert(crowdTable, m.Pos)
end
for Z = 66,108,2 do
	m.XZ.X = 204
    m.XZ.Z = Z
    table.insert(crowdTable, m.Pos)
end
--
crowdTable2 = {}
local m = MapPosXZ.new()
for x = -48,36,2 do
	m.XZ.X = x
    m.XZ.Z = 68
    table.insert(crowdTable2, m.Pos)
end
for x = -48,36,2 do
	m.XZ.X = x
       m.XZ.Z = 106
       table.insert(crowdTable2, m.Pos)
end
for Z = 70,104,2 do
	m.XZ.X = 36
    m.XZ.Z = Z
    table.insert(crowdTable2, m.Pos)
end
for Z = 70,104,2 do
	m.XZ.X = 208
    m.XZ.Z = Z
    table.insert(crowdTable2, m.Pos)
end
--
crowdTable3 = {}
local m = MapPosXZ.new()
for x = -44,32,2 do
	m.XZ.X = x
    m.XZ.Z = 72
    table.insert(crowdTable3, m.Pos)
end
for x = -44,32,2 do
	m.XZ.X = x
       m.XZ.Z = 102
       table.insert(crowdTable3, m.Pos)
end
for Z = 74,100,2 do
	m.XZ.X = 32
    m.XZ.Z = Z
    table.insert(crowdTable3, m.Pos)
end
for Z = 74,100,2 do
	m.XZ.X = 212
    m.XZ.Z = Z
    table.insert(crowdTable3, m.Pos)
end


for key, value in ipairs(crowdTable) do --2194
	local c3d = Coord3D.new()
	map_idx_to_world_coord3d_centre(value,c3d)
	local crowd = createThing(T_PERSON,M_PERSON_SPY,math.random(0,7),c3d,false,false)
	crowd.Flags2 = EnableFlag(crowd.Flags2, TF2_DONT_DRAW_IN_WORLD_VIEW)
end
for key, value in ipairs(crowdTable2) do --2194
	local c3d = Coord3D.new()
	map_idx_to_world_coord3d_centre(value,c3d)
	local crowd = createThing(T_PERSON,M_PERSON_SPY,math.random(0,7),c3d,false,false)
	crowd.Flags2 = EnableFlag(crowd.Flags2, TF2_DONT_DRAW_IN_WORLD_VIEW)
end
for key, value in ipairs(crowdTable3) do --2194
	local c3d = Coord3D.new()
	map_idx_to_world_coord3d_centre(value,c3d)
	local crowd = createThing(T_PERSON,M_PERSON_SPY,math.random(0,7),c3d,false,false)
	crowd.Flags2 = EnableFlag(crowd.Flags2, TF2_DONT_DRAW_IN_WORLD_VIEW)
end

for i = 71,72 do
local fire = createThing(T_EFFECT,M_EFFECT_WW_DUST,8,marker_to_coord3d(i),false,false)
centre_coord3d_on_block(fire.Pos.D3)
set_thing_draw_info(fire,TDI_SPRITE_F9_D1_ALPHA, 1090)
fire.u.Effect.Duration = -1
fire.DrawInfo.Alpha = -5
end

for i = 8,12 do
local fire = createThing(T_EFFECT,M_EFFECT_WW_DUST,8,marker_to_coord3d(i),false,false)
centre_coord3d_on_block(fire.Pos.D3)
set_thing_draw_info(fire,TDI_SPRITE_F9_D1_ALPHA, 1090)
fire.u.Effect.Duration = -1
fire.DrawInfo.Alpha = 0
fire.Pos.D3.Ypos = fire.Pos.D3.Ypos + 282
end

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_INFO_DROP) or (event == SND_EVENT_INFO_BOUNCE) or (event == SND_EVENT_CONVERT) or (event == SND_EVENT_SHAM_CONVERT) or (event == SND_EVENT_ESHAM_CONVERT) or (event == SND_EVENT_CONVERT_WILDMAN) then
		return 1
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(252,226),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2121)
