--4v4 The Floor is Lava Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Spells)
import(Module_Building)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 0
local team2Score = 0
local maxScore = 120

sinkTable = {}
local stageTimer = -1
local phase = -1
local stage = 0
----------------------------------------------------spell constants
sti = spells_type_info()
tmi = thing_move_info()
tmi[TMI_PERSON_MEDICINE_MAN].BaseSpeed = 96

local addedTimer = 8
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)

local meteor = M_SPELL_INSECT_PLAGUE
sti[meteor].OneOffMaximum = 1
sti[meteor].WorldCoordRange = 4096
sti[meteor].CursorSpriteNum = 152
sti[meteor].AvailableSpriteIdx = 2145
sti[meteor].NotAvailableSpriteIdx = 2145
sti[meteor].ClickedSpriteIdx = 2145

set_correct_gui_menu()
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				id = 0,
				cor = marker_to_coord3d(137),
				reinc = -1,
				online = -1,
				ldb = 0,
				meteorAffected = -1,
				getMeteor = 12*5 + 12*math.random(10)
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 12,
				name = "red",
				id = 1,
				cor = marker_to_coord3d(26),
				reinc = -1,
				online = -1,
				ldb = 0,
				meteorAffected = -1,
				getMeteor = 12*5 + 12*math.random(10)
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 5,
				name = "yellow",
				id = 2,
				cor = marker_to_coord3d(24),
				reinc = -1,
				online = -1,
				ldb = 0,
				meteorAffected = -1,
				getMeteor = 12*5 + 12*math.random(10)
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 3,
				name = "green",
				id = 3,
				cor = marker_to_coord3d(47),
				reinc = -1,
				online = -1,
				ldb = 0,
				meteorAffected = -1,
				getMeteor = 12*5 + 12*math.random(10)
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 7,
				name = "cyan",
				id = 4,
				cor = marker_to_coord3d(66),
				reinc = -1,
				online = -1,
				ldb = 0,
				meteorAffected = -1,
				getMeteor = 12*5 + 12*math.random(10)
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 6,
				name = "magenta",
				id = 5,
				cor = marker_to_coord3d(158),
				reinc = -1,
				online = -1,
				ldb = 0,
				meteorAffected = -1,
				getMeteor = 12*5 + 12*math.random(10)
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 16,
				name = "black",
				id = 6,
				cor = marker_to_coord3d(148),
				reinc = -1,
				online = -1,
				ldb = 0,
				meteorAffected = -1,
				getMeteor = 12*5 + 12*math.random(10)
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				id = 7,
				cor = marker_to_coord3d(109),
				reinc = -1,
				online = -1,
				ldb = 0,
				meteorAffected = -1,
				getMeteor = 12*5 + 12*math.random(10)
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--if (string.sub(Players[i].name, 1, 1) ~= "*") and (string.sub(Players[i].name, 1, 8) ~= "NoPlayer") then
				--Players[i].name = "*" .. Players[i].name .. "" --disconnected symbol on scoreboard
			--end
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil then
			pl[i].alive = 0
		end
	end
end

function LavaFloor()
	SearchMapCells(SQUARE,0,0,7,world_coord3d_to_map_idx(marker_to_coord3d(203)), function (me)
		if me.Alt <= 48 then
			local _me = MAP_ELEM_PTR_2_IDX(me)
			local c3d = Coord3D.new()
            map_idx_to_world_coord3d(_me,c3d)
			local effect = createThing(T_EFFECT,M_EFFECT_LAVA_GLOOP ,TRIBE_NEUTRAL,c3d,false,false)
		end
	return true
	end)
end

function ChangePhase()
	if phase == 0 then --CREATE EQ ZONES SPRITES
		--how many eqs
		sinkTable = {}
		for i = 0,16+G_RANDOM(32) do
			local rng = math.random(0,203)
			table.insert(sinkTable,rng)
		end
		--show sprites of eqs
		for key, value in ipairs(sinkTable) do
			local s = createThing(T_EFFECT,M_EFFECT_BIG_SPARKLE,TRIBE_NEUTRAL,marker_to_coord3d(value),false,false)
			s.u.Effect.Duration = 24 s.DrawInfo.Alpha = -16 set_thing_draw_info(s,TDI_SPRITE_F1_D1, 2141)
			--if stage >= 20 and stage < 30 then s.u.Effect.Duration = 18 elseif stage >= 30 then s.u.Effect.Duration = 12 end --faster eqs sprites (harder later)
		end
		queue_sound_event(nil, SND_EVENT_REIN_ROCK, SEF_FIXED_VARS)
		phase = 1
		stageTimer = 12*3
	elseif phase == 1 then --FALL FLOOR
		for key, value in ipairs(sinkTable) do
			SearchMapCells(SQUARE,0,0,1,world_coord3d_to_map_idx(marker_to_coord3d(value)), function (me)
				me.Alt = 32
				set_square_map_params(world_coord3d_to_map_idx(marker_to_coord3d(value)),0,TRUE)
			return true
			end)
		end
		queue_sound_event(nil, SND_EVENT_LANDSPLIT, SEF_FIXED_VARS)
		phase = 2
		stageTimer = 12*2
	elseif phase == 2 then --REGEN FLOOR
		SearchMapCells(SQUARE,0,0,7,world_coord3d_to_map_idx(marker_to_coord3d(203)), function (me)
			me.Alt = 570
			set_square_map_params(world_coord3d_to_map_idx(marker_to_coord3d(203)),8,TRUE)
			me.Flags = DisableFlag(me.Flags, (1<<2))
			me.Flags = DisableFlag(me.Flags, (1<<19))
		return true
		end)
		for i = 0,7 do
			if pl[i].online == 1 and getShaman(i) ~= nil then
				if i < 4 then team1Score = team1Score + 1 else team2Score = team2Score + 1 end
				local s = createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
				s.DrawInfo.Alpha = pl[i].color
			end
		end
		queue_sound_event(nil, SND_EVENT_SHRAPNEL, SEF_FIXED_VARS)
		phase = 3
		stageTimer = 6
	elseif phase == 3 then
		stage = stage + 1
		local al = 0
		for i = 0,7 do
			if pl[i].online == 1 and getShaman(i) ~= nil then al = al + 1 end
		end
		phase = 0
		if al > 0 then
			stageTimer = 12*1
			if stage % 3 == 0 then
				for i = 0,7 do
					if pl[i].online == 1 and getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						pl[i].alive = 1
						pl[i].meteorAffected = -1
					end
				end
			end
		else
			stageTimer = 12*3
			for i = 0,7 do
				if pl[i].online == 1 and getShaman(i) == nil then
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
					pl[i].alive = 1
					pl[i].meteorAffected = -1
				end
			end
		end
	end
end

function CreateMeteor(owner,c3d)
	local meteor = createThing(T_EFFECT,60,owner,c3d,false,false)
	set_thing_draw_info(meteor,TDI_SPRITE_F16_D1_ALPHA, 1329) meteor.DrawInfo.Alpha = pl[owner].color meteor.u.Effect.Duration = -1
	meteor.Pos.D3.Ypos = 2048--point_altitude(meteor.Pos.D3.Xpos,meteor.Pos.D3.Zpos) + 1024
	local meteor2 = createThing(T_EFFECT,60,8,c3d,false,false)
	set_thing_draw_info(meteor2,TDI_SPRITE_F4_D1_ALPHA, 1385)
	meteor2.DrawInfo.Alpha = pl[owner].color meteor2.u.Effect.Duration = -1
	meteor2.Pos.D3.Ypos = 2048-48
end

function ProcessMeteors()
	ProcessGlobalTypeList(T_EFFECT,function(t)
		if t.Model == 60 then
			if t.Pos.D3.Ypos > point_altitude(t.Pos.D3.Xpos,t.Pos.D3.Zpos) then
				--fall
				t.Pos.D3.Ypos = t.Pos.D3.Ypos - 24
			else
				--explode
				createThing(T_EFFECT,M_EFFECT_ROCK_EXPLOSION,TRIBE_HOSTBOT,t.Pos.D3,false,false)
				queue_sound_event(nil,SND_EVENT_SP_BLAST, SEF_FIXED_VARS)
				--kill stuff
				ProcessGlobalSpecialListAll(PEOPLELIST, function(p)
					if p.Owner ~= t.Owner then
						if get_world_dist_xz(p.Pos.D2,t.Pos.D2) < 512-64 then
							pl[p.Owner].meteorAffected = 12*3
						end
					end
				return true end)
				--remove meteor
				delete_thing_type(t)
			end
		end
	return true end)
end



function OnTurn()
		
	if win ~= 1 then AliveandOnline() end

	if win == 0 then
		--meteor falling
		if (gns.Flags & GNS_PAUSED == 0) then ProcessMeteors() end
		--lava gloop fall zones
		if phase == 2 and stageTimer > 6 then
			LavaFloor()
		end
		--game phase control
		if stageTimer > 0 then
			stageTimer = stageTimer - 1
		elseif stageTimer == 0 then
			stageTimer = -1
			ChangePhase()
		end
		for i = 0,7,1 do
			--full hp
			if pl[i].online == 1 and getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = getShaman(i).u.Pers.MaxLife
			end
			--recieve meteor spell
			if pl[i].online == 1 then
				if pl[i].getMeteor > 0 then
					pl[i].getMeteor = pl[i].getMeteor - 1
				elseif pl[i].getMeteor == 0 then
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[meteor] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[meteor] & 240
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[meteor] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[meteor] | 1
					pl[i].getMeteor = -1
				end
			end
			--shamans losing control meteor
			if pl[i].online == 1 and getShaman(i) ~= nil then
				if pl[i].meteorAffected > 0 then
					pl[i].meteorAffected = pl[i].meteorAffected - 1
					DESELECT_ALL_PEOPLE(i)
					MOVE_SHAMAN_TO_MARKER(i,math.random(0,203))
					local a = createThing(T_EFFECT,10,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
					a.u.Effect.Duration = 2
				elseif pl[i].meteorAffected == 0 then
					pl[i].meteorAffected = -1
				end
			end
			--process shamans dying
			if getShaman(i) ~= nil and getShaman(i).Pos.D3.Ypos < 256 + 64 then
				damage_person(getShaman(i), TRIBE_NEUTRAL, 5000, 1)
				pl[i].alive = 0
				queue_sound_event(nil, SND_EVENT_ANGEL_BLAST, SEF_FIXED_VARS)
			end
		end
		--win by pts
		if team1Score == maxScore or team2Score == maxScore then
			if team1Score == maxScore and team2Score == maxScore then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		if timer > 0 then
			timer = timer -1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		phase = 0
		stageTimer = 12*3
		set_correct_gui_menu()
	end
	--reset score if too big
	if team1Score > maxScore then team1Score = maxScore end
	if team2Score > maxScore then team2Score = maxScore end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			pl[i].ldb = getShaman(i).u.Pers.u.Owned.LastDamagedBy
		end
	end
	--process shamans not being targetable
	ProcessGlobalSpecialListAll(0, function(targ)
		if (targ.Type == T_PERSON) and (targ.Model == M_PERSON_MEDICINE_MAN) then
			local cmd = get_thing_curr_cmd_list_ptr(targ)
			if (cmd ~= nil) then
				if (cmd.CommandType == CMD_ATTACK_AREA_2) or (cmd.CommandType == CMD_ATTACK_TARGET) then
					cmd.CommandType = CMD_HEAD_PRAY
				end
			end
		end
	return true
	end)
	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
			smok.DrawInfo.Alpha = pl[i].color ; smok.u.Effect.Duration = 2
			smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 32
		end
	end
end



function OnCreateThing(t)
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
	if t.Type == T_SPELL then
		if t.Model == meteor then
			pl[t.Owner].getMeteor = 12*8 + 12*math.random(12)
			CreateMeteor(t.Owner,t.Pos.D3)
			queue_sound_event(nil,SND_EVENT_STONE_HEAD, SEF_FIXED_VARS)
		end
	end
	if t.Type == T_EFFECT then
		if t.Model == M_EFFECT_INSECT_PLAGUE then
			t.u.Effect.Duration = 1
		end
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		local gaugeW = (box*2)+2+2
		local gaugeH = math.floor((box+4)*7)
		local alertsW = math.floor(w-8-gaugeW+2)
		local alertsHstart = (h-8)-gaugeH+2
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/maxScore)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/" .. maxScore
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/maxScore)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/" .. maxScore
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,2101+(deaths[i][3]-2083)),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--round number
			LbDraw_Text(guiW + 4,h-20,"round: " .. stage,0)
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end
end

------------------------------------------------------------------------------------------
--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("The Floor is Lava MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Shamans walk around, avoiding unstable locations")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Each stage they survive earns their team 1 point.")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* Dead shamans respawn on the next multiple of 3 round: *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("(eg.: if a shaman dies on round 6, 7 or 8, she will respawn on round 9 (9 is a multiple of 3))")
		imgui.NextColumn()
		imgui.TextUnformatted("(Or, in case all shamans are dead after a round, everyone will reincarnate within the next round)")
		imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Shamans randomly earn meteorite spells. Upon cast, they fall until they hit the ground, affecting anything except the caster")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Shamans hit by a meteorite will panic for 3 seconds, losing control and moving around")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points wins).")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("METEOR - swarm")
		imgui.NextColumn()
		
		imgui.End()
	end
end

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_INFO_DROP) or (event == SND_EVENT_INFO_BOUNCE) or event == SND_EVENT_SHAM_INSECT or event == SND_EVENT_ESHAM_INSECT then
		return 1
	end
end
