--4v4 Paintball Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Building)
import(Module_Spells)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 0
local team2Score = 0
----------------------------------------------------spell constants
tmi = thing_move_info()
tmi[TMI_PERSON_MEDICINE_MAN].BaseSpeed = 106

sti = spells_type_info()
sti[M_SPELL_INSECT_PLAGUE].OneOffMaximum = 0
sti[M_SPELL_INSECT_PLAGUE].WorldCoordRange = 4096*2
sti[M_SPELL_INSECT_PLAGUE].CursorSpriteNum = 163
sti[M_SPELL_INSECT_PLAGUE].ToolTipStrIdx = sti[M_SPELL_VOLCANO].ToolTipStrIdx
sti[M_SPELL_INSECT_PLAGUE].ToolTipStrIdxLSME = sti[M_SPELL_VOLCANO].ToolTipStrIdxLSME
sti[M_SPELL_INSECT_PLAGUE].AvailableSpriteIdx = 1787
sti[M_SPELL_INSECT_PLAGUE].NotAvailableSpriteIdx = 1787
sti[M_SPELL_INSECT_PLAGUE].ClickedSpriteIdx = 1787

local addedTimer = 8
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)


set_correct_gui_menu()
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				cor = marker_to_coord3d(0),
				spellCDR = -1,
				spellc3d = -1,
				spellCDR2 = -1,
				spellc3d2 = -1,
				spellCDR3 = -1,
				spellc3d3 = -1,
				spellCDR4 = -1,
				spellc3d4 = -1,
				cdrID = 1,
				dedCDR = 0,
				flash = 0,
				online = -1
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = -2,
				drawClr = 12,
				name = "red",
				cor = marker_to_coord3d(1),
				spellCDR = -1,
				spellc3d = -1,
				spellCDR2 = -1,
				spellc3d2 = -1,
				spellCDR3 = -1,
				spellc3d3 = -1,
				spellCDR4 = -1,
				spellc3d4 = -1,
				cdrID = 1,
				dedCDR = 0,
				flash = 0,
				online = -1
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 3,
				drawClr = 5,
				name = "yellow",
				cor = marker_to_coord3d(2),
				spellCDR = -1,
				spellc3d = -1,
				spellCDR2 = -1,
				spellc3d2 = -1,
				spellCDR3 = -1,
				spellc3d3 = -1,
				spellCDR4 = -1,
				spellc3d4 = -1,
				cdrID = 1,
				dedCDR = 0,
				flash = 0,
				online = -1
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 1,
				drawClr = 3,
				name = "green",
				cor = marker_to_coord3d(3),
				spellCDR = -1,
				spellc3d = -1,
				spellCDR2 = -1,
				spellc3d2 = -1,
				spellCDR3 = -1,
				spellc3d3 = -1,
				spellCDR4 = -1,
				spellc3d4 = -1,
				cdrID = 1,
				dedCDR = 0,
				flash = 0,
				online = -1
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 10,
				drawClr = 7,
				name = "cyan",
				cor = marker_to_coord3d(4),
				spellCDR = -1,
				spellc3d = -1,
				spellCDR2 = -1,
				spellc3d2 = -1,
				spellCDR3 = -1,
				spellc3d3 = -1,
				spellCDR4 = -1,
				spellc3d4 = -1,
				cdrID = 1,
				dedCDR = 0,
				flash = 0,
				online = -1
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 11,
				drawClr = 6,
				name = "magenta",
				cor = marker_to_coord3d(5),
				spellCDR = -1,
				spellc3d = -1,
				spellCDR2 = -1,
				spellc3d2 = -1,
				spellCDR3 = -1,
				spellc3d3 = -1,
				spellCDR4 = -1,
				spellc3d4 = -1,
				cdrID = 1,
				dedCDR = 0,
				flash = 0,
				online = -1
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 7,
				drawClr = 16,
				name = "black",
				cor = marker_to_coord3d(6),
				spellCDR = -1,
				spellc3d = -1,
				spellCDR2 = -1,
				spellc3d2 = -1,
				spellCDR3 = -1,
				spellc3d3 = -1,
				spellCDR4 = -1,
				spellc3d4 = -1,
				cdrID = 1,
				dedCDR = 0,
				flash = 0,
				online = -1
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				cor = marker_to_coord3d(7),
				spellCDR = -1,
				spellc3d = -1,
				spellCDR2 = -1,
				spellc3d2 = -1,
				spellCDR3 = -1,
				spellc3d3 = -1,
				spellCDR4 = -1,
				spellc3d4 = -1,
				cdrID = 1,
				dedCDR = 0,
				flash = 0,
				online = -1
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--[[if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil then
			pl[i].alive = 0
		end
	end
end

--Same life
for i = 0,7 do
	if getShaman(i) ~= nil then
		getShaman(i).u.Pers.MaxLife = 1800
		getShaman(i).u.Pers.Life = getShaman(i).u.Pers.MaxLife
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
function CopyC3d(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end
function CopyC3d2(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end
function CopyC3d3(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end
function CopyC3d4(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end

mainclr = 1800 --main color
floorclr = {1832,1836,1840} --floor splash around
hitclr = 1928 --paint shaman chest if hit her
headshotclr = 1960 --paint shaman head if hit her very close (headshot)
deadclr = 2024 --paint in floor if shaman dies
function Paintball(pn,c3d)
	--ball main color
	local sss = createThing(T_EFFECT,60,8,c3d,false,false)
	set_thing_draw_info(sss,TDI_SPRITE_F4_D1_ALPHA, mainclr + (pn*4))
	sss.u.Effect.Duration = 12*8 + 8
	sss.DrawInfo.Alpha = -16
	--splash color
	local s = createThing(T_EFFECT,60,pn,c3d,false,false)
	set_thing_draw_info(s,TDI_SPRITE_F4_D1_ALPHA, floorclr[math.random(#floorclr)] + (pn*12))
	s.u.Effect.Duration = 12*8 + 12*(math.random(1,3)) + 4
	s.DrawInfo.Alpha = -16
	--water splash/snd
	SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(c3d), function(me)
		if (is_map_elem_sea_or_coast(me) > 0) then
			 s.u.Effect.Duration = 3
			 sss.u.Effect.Duration = 3
			 queue_sound_event(s,SND_EVENT_W_SPLASH, SEF_FIXED_VARS)
			 createThing(T_EFFECT,M_EFFECT_SPLASH,8,c3d,false,false)
		else
			createThing(T_EFFECT,M_EFFECT_SMOKE ,8,c3d,false,false)
			local f = createThing(T_EFFECT,M_EFFECT_WW_DUST,8,c3d,false,false) f.DrawInfo.Alpha = -11
		end
	return true
	end)
	--hit shamans
	local c2d = Coord2D.new()
	coord3D_to_coord2D(c3d, c2d)
	ProcessGlobalSpecialListAll(0, function(t)
		if t.Owner ~= pn then
			if getShaman(t.Owner) ~= nil and t.Flags3 & TF3_SHIELD_ACTIVE == 0 then
				if get_world_dist_xz(t.Pos.D2,c2d) < 224 and get_world_dist_xz(t.Pos.D2,c2d) >= 160 then --hit		(256-32 ; 256-64-32)
					local ss = createThing(T_EFFECT,60,8,c3d,false,false)
					set_thing_draw_info(ss,TDI_SPRITE_F4_D1_ALPHA, hitclr + (pn*4))
					ss.u.Effect.Duration = 7
					ss.DrawInfo.Alpha = -16
					pl[pn].score = pl[pn].score + 4
					pl[t.Owner].score = pl[t.Owner].score - 1
					if pn < 4 then
						if t.Owner > 3 then
							team1Score = team1Score + 4
							team2Score = team2Score - 1
						end
					else
						if t.Owner < 4 then
							team2Score = team2Score + 4
							team1Score = team1Score - 1
						end
					end
					getShaman(t.Owner).u.Pers.Life = getShaman(t.Owner).u.Pers.Life - math.ceil(getShaman(t.Owner).u.Pers.MaxLife/5) - 8 --20%
					pl[t.Owner].flash = 2
				elseif get_world_dist_xz(t.Pos.D2,c2d) < 160 then --headshot		(256-64-32)
					local ss = createThing(T_EFFECT,60,8,c3d,false,false)
					set_thing_draw_info(ss,TDI_SPRITE_F4_D1_ALPHA, headshotclr + (pn*4))
					ss.u.Effect.Duration = 5
					ss.DrawInfo.Alpha = -16
					pl[pn].score = pl[pn].score + 6
					pl[t.Owner].score = pl[t.Owner].score - 2
					if pn < 4 then
						if t.Owner > 3 then
							team1Score = team1Score + 6
							team2Score = team2Score - 2
						end
					else
						if t.Owner < 4 then
							team2Score = team2Score + 6
							team1Score = team1Score - 2
						end
					end
					getShaman(t.Owner).u.Pers.Life = getShaman(t.Owner).u.Pers.Life - math.ceil((getShaman(t.Owner).u.Pers.MaxLife/3)+(getShaman(t.Owner).u.Pers.MaxLife/13)) - 16 --40%
					pl[t.Owner].flash = 2
				end
			end
			--process shaman dying
			if getShaman(t.Owner).u.Pers.Life <= 0 and pl[t.Owner].dedCDR == 0 then
				pl[t.Owner].dedCDR = 12*3
				pl[pn].score = pl[pn].score + 15
				pl[t.Owner].score = pl[t.Owner].score - 5
				if pn < 4 then
					if t.Owner > 3 then
						team1Score = team1Score + 15
						team2Score = team2Score - 5
					end
				else
					if t.Owner < 4 then
						team2Score = team2Score + 15
						team1Score = team1Score - 5
					end
				end
				local sr = createThing(T_EFFECT,60,pn,c3d,false,false)
				set_thing_draw_info(sr,TDI_SPRITE_F4_D1_ALPHA, deadclr + (pn*4))
				sr.u.Effect.Duration = 12*7 + 12*(math.random(2,4)) + 4
				sr.DrawInfo.Alpha = -16
				if (pn < 4 and t.Owner > 3) or (pn > 3 and t.Owner < 4) then
					pl[pn].kills = pl[pn].kills + 1
					pl[t.Owner].deaths = pl[t.Owner].deaths + 1
					if getShaman(pn) ~= nil then
						getShaman(pn).u.Pers.Life = getShaman(pn).u.Pers.MaxLife --refill hp
						queue_sound_event(getShaman(pn),SND_EVENT_DISCOBLDG_START, SEF_FIXED_VARS)
						local orb = createThing(T_EFFECT,M_EFFECT_ORBITER,8,getShaman(pn).Pos.D3,false,false)
						orb.DrawInfo.Alpha = pl[pn].color
						local orb2 = createThing(T_EFFECT,M_EFFECT_ORBITER,8,getShaman(pn).Pos.D3,false,false)
					end
				end
				--add death visual
				--local Dsprite = 24
				--if pl[i].ldb ~= 8 then
					Dsprite = 2083 + pn --+ pl[pn].ldb
				--end
				local Dname = "..."
				if Dsprite ~= 24 then
					Dname = pl[pn].name
				end
				local Dname2 = pl[t.Owner].name
				table.insert(deaths,{Dname,Dname2,Dsprite,2083+t.Owner,12*7})
			end
		end
	return true end)
end



function OnTurn()

	if win ~= 1 then AliveandOnline() end
	
	if win == 0 then
		for i = 0,7,1 do
			--anti hp regen
			if every2Pow(3) then
				if getShaman(i) ~= nil then
					if getShaman(i).u.Pers.Life < getShaman(i).u.Pers.MaxLife then
						getShaman(i).u.Pers.Life = getShaman(i).u.Pers.Life - 32
					end
				end
			end
			--dead cdr decay (to avoid rapidfire killing earning more than 1 point)
			if pl[i].dedCDR > 0 then
				pl[i].dedCDR = pl[i].dedCDR - 1
			end
			--process spell cdr decay
			if pl[i].spellCDR > 0 then
				pl[i].spellCDR = pl[i].spellCDR - 1
			elseif pl[i].spellCDR == 0 then
				pl[i].spellCDR = -1
				Paintball(i,pl[i].spellc3d)
			end
			if pl[i].spellCDR2 > 0 then
				pl[i].spellCDR2 = pl[i].spellCDR2 - 1
			elseif pl[i].spellCDR2 == 0 then
				pl[i].spellCDR2 = -1
				Paintball(i,pl[i].spellc3d2)
			end
			if pl[i].spellCDR3 > 0 then
				pl[i].spellCDR3 = pl[i].spellCDR3 - 1
			elseif pl[i].spellCDR3 == 0 then
				pl[i].spellCDR3 = -1
				Paintball(i,pl[i].spellc3d3)
			end
			if pl[i].spellCDR4 > 0 then
				pl[i].spellCDR4 = pl[i].spellCDR4 - 1
			elseif pl[i].spellCDR4 == 0 then
				pl[i].spellCDR4 = -1
				Paintball(i,pl[i].spellc3d4)
			end
			--quick casting
			if _gsi.Players[i].SpellDelayCount == 10 then
				_gsi.Players[i].SpellDelayCount = 0
			end
			if getShaman(i) ~= nil then
				if getShaman(i).State == 22 then --casting
					getShaman(i).State = 17
				end
			end
		end
		if every2Pow(math.random(3,4)) then
			for i = 0,7,1 do
				--give bullets (max 7)
				local pSpells = GET_NUM_ONE_OFF_SPELLS(i,M_SPELL_INSECT_PLAGUE)
				if pSpells < 6 then
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] & 240
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] | pSpells+1
				else
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] & 240
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] | 7
				end
			end
		end
		if everySeconds(5) then
			for i = 0,7 do
				--reinc shaman who die
				if getShaman(i) == nil and pl[i].online == 1 then
					centre_coord3d_on_block(pl[i].cor)
					local m = createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
					if getShaman(i) ~= nil then
						getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
						getShaman(i).u.Pers.u.Owned.ShieldCount = 4
						getShaman(i).u.Pers.MaxLife = 2500
						getShaman(i).u.Pers.Life = getShaman(i).u.Pers.MaxLife
					end
				end
			end
		end
		--win by pts
		if team1Score == 1000 or team2Score == 1000 then
			if team1Score == 1000 and team2Score == 1000 then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		if timer > 0 then
			timer = timer -1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end	
	--process visual red flash
	for i = 0,7 do
		if pl[i].flash > 0 then
			pl[i].flash = pl[i].flash - 1
		else
			pl[i].flash = 0
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		for pn = 0,7,1 do
			_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] & 240
			_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] | 1
		end
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
	end
	--reset score if too big
	if team1Score > 1000 then team1Score = 1000 end
	if team2Score > 1000 then team2Score = 1000 end
	if team1Score < 0 then team1Score = 0 end
	if team2Score < 0 then team2Score = 0 end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
			smok.u.Effect.Duration = 2
			if i < 4 then
				smok.DrawInfo.Alpha = 2
			else
				smok.DrawInfo.Alpha = -1
			end
			smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 32
			if is_person_driver_in_any_vehicle(getShaman(i)) == 1 then
				smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 196
			end
		end
	end
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
end


local dropIcon = 0
function OnCreateThing(t)
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
	if t.Type == T_SPELL then
		KILL_ALL_MSG_ID(dropIcon)
		dropIcon = dropIcon + 1
		CLEAR_ALL_MSG()
	end
	if t.Type == T_EFFECT and t.Model == M_EFFECT_INSECT_PLAGUE then
		t.u.Effect.Duration = 1
	elseif t.Type == T_EFFECT and (t.Model == 4) then
		--show no spellcasting line
		t.DrawInfo.DrawNum = 2056
	end
	if (t.Type == T_SPELL) and (t.Model == M_SPELL_INSECT_PLAGUE) and getShaman(t.Owner) ~= nil and win == 0 then --paintball
		--t.Model = M_SPELL_INVISIBILITY --M_SPELL_NONE --changing model causes hyperspeed somethimes i think
		if pl[t.Owner].cdrID == 1 then
			pl[t.Owner].spellCDR = 4
			pl[t.Owner].spellc3d = CopyC3d(t.Pos.D3)
			pl[t.Owner].cdrID = 2
		elseif pl[t.Owner].cdrID == 2 then
			pl[t.Owner].spellCDR2 = 4
			pl[t.Owner].spellc3d2 = CopyC3d2(t.Pos.D3)
			pl[t.Owner].cdrID = 3
		elseif pl[t.Owner].cdrID == 3 then
			pl[t.Owner].spellCDR3 = 4
			pl[t.Owner].spellc3d3 = CopyC3d3(t.Pos.D3)
			pl[t.Owner].cdrID = 4
		elseif pl[t.Owner].cdrID == 4 then
			pl[t.Owner].spellCDR4 = 4
			pl[t.Owner].spellc3d4 = CopyC3d4(t.Pos.D3)
			pl[t.Owner].cdrID = 1
		end
		local smok = createThing(T_EFFECT,M_EFFECT_SMOKE,8,getShaman(t.Owner).Pos.D3,false,false)
		centre_coord3d_on_block(smok.Pos.D3)
		--remove shot
		local ptb = GET_NUM_ONE_OFF_SPELLS(t.Owner,M_SPELL_INSECT_PLAGUE)
		if ptb > 0 then
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] & 240
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] | ptb-1
		end
		--no s click follow
		if (not t.u.Spell.TargetThingIdx:isNull()) then
			if (t.u.Spell.TargetThingIdx:get().Model == M_PERSON_MEDICINE_MAN) then
				t.u.Spell.TargetThingIdx:set(0)
			end
		end
		--paint-gun trace code stolen from KOSJAK and edited a bit :>
		--[[
		local s = getShaman(t.Owner)
		if (s ~= nil) then
			local z = (t.Pos.D2.Zpos - s.Pos.D2.Zpos)
			local x = (t.Pos.D2.Xpos - s.Pos.D2.Xpos)
			local ax = math.abs(x)
			local az = math.abs(z)

			if (x > 0 and z > 32767) then
				if (ax > ((256*256)>>1)) then x = -(ax - (256*256)) end
				if (az > ((256*256)>>1)) then z = (az - (256*256)) end
			else
				if (x < 0) then
					if (z >= 0) then
						if (ax > ((256*256)>>1)) then x = -(ax - (256*256)) end
						if (az > ((256*256)>>1)) then z = (az - (256*256)) end
					else
						if (ax > ((256*256)>>1)) then x = -(ax - (256*256)) end
						if (az > ((256*256)>>1)) then z = -(az - (256*256)) end
					end
				else
					if (z >= 0) then
						if (ax > ((256*256)>>1)) then x = (ax - (256*256)) end
						if (az > ((256*256)>>1)) then z = -(az - (256*256)) end
					else
						if (ax > ((256*256)>>1)) then x = (ax - (256*256)) end
						if (az > ((256*256)>>1)) then z = -(az - (256*256)) end
					end
				end
			end
			
			local angle = math.atan(z, x) * 180 / math.pi
			angle = math.ceil(angle)
			if (angle<0) then
				angle=angle+360
			end

			local rotation = (angle * math.pi) / 180
			--local alt_limit = s.Pos.D3.Ypos+256
			--local alt_low_limit = s.Pos.D3.Ypos-(512-128)
			local process = true
			local distance_xyz = get_world_dist_xyz(s.Pos.D3,t.Pos.D3)
			local amount = math.ceil(distance_xyz / 256)
			for i=1,amount-1 do
				if (process) then
					local spawnC3d = Coord3D.new()
					spawnC3d.Xpos = math.ceil(s.Pos.D3.Xpos + (math.cos(rotation) * 256*i))
					spawnC3d.Zpos = math.ceil(s.Pos.D3.Zpos + (math.sin(rotation) * 256*i))
					spawnC3d.Ypos = s.Pos.D3.Ypos
					local res = point_altitude(spawnC3d.Xpos,spawnC3d.Zpos)
					--if (res < alt_limit and res > alt_low_limit) then
						alt_limit = res+256
						alt_low_limit = res-(512-128)
						local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,spawnC3d,false,false)
						if t.Owner < 4 then
							smok.DrawInfo.Alpha = 2
						else
							smok.DrawInfo.Alpha = 9
						end
						local me = world_coord2d_to_map_ptr(smok.Pos.D2)
					--end
				end
			end
		end]]
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		local bulletSize = math.floor(h/22)
		
		--kda, hp, flash
		if win ~= -1 then
			for i = 0,7,1 do
				if i == _gnsi.PlayerNum and pl[i].online == 1 then
					--show K/D bottom left
					PopSetFont(9)
					LbDraw_ScaledSprite(guiW+8+math.floor(bulletSize*2),h-8-bulletSize,get_sprite(0,81),bulletSize,bulletSize)
					LbDraw_Text(guiW+8+bulletSize+4+math.floor(bulletSize*2),h-8-bulletSize+(math.floor(bulletSize/6)),"" .. pl[i].deaths,0)
					LbDraw_ScaledSprite(guiW+8+math.floor(bulletSize*2),h-8-(math.floor(bulletSize*2)),get_sprite(0,176),bulletSize,bulletSize)
					LbDraw_Text(guiW+8+bulletSize+4+math.floor(bulletSize*2),h-8-(math.floor(bulletSize*2))+(math.floor(bulletSize/6)),"" .. pl[i].kills,0)
					--bullets
					for j = 1, GET_NUM_ONE_OFF_SPELLS(i,M_SPELL_INSECT_PLAGUE) do
						LbDraw_ScaledSprite(w-8-bulletSize,math.floor(h-8-((bulletSize*1.2)*j)),get_sprite(0,1792+i),bulletSize,bulletSize)
					end
					--show HP bar
					if getShaman(i) ~= nil then
						DrawBox(math.floor(guiW + guiW - 2),math.floor(h-8-(bulletSize/2)-2),math.floor(w-(guiW*3)+4),math.floor((bulletSize/2)+4),1)--outline blk
						DrawBox(math.floor(guiW + guiW),math.floor(h-8-(bulletSize/2)),math.floor(w-(guiW*3)),math.floor(bulletSize/2),2) --bar white
						local percent = math.floor((getShaman(i).u.Pers.Life * 100)/(getShaman(i).u.Pers.MaxLife))
						local barpercent = math.floor(((w-(guiW*3)) * percent) / 100)
						DrawBox(math.floor(guiW + guiW),math.floor(h-8-(bulletSize/2)),barpercent,math.floor(bulletSize/2),0)--damage
					end
				end
			end
		end
		
		--flash
		for i = 0,7,1 do
			if i == _gnsi.PlayerNum then
				if pl[i].flash > 0 then
					DrawBox(0,0,ScreenWidth(),ScreenHeight(),2)
				end
			end
		end
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/1000)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/1000"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/1000)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/1000"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end
end



--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Paintball MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Teams roam the land, trying to hit other shamans with their paint gun")
	   	imgui.NextColumn()
		imgui.TextUnformatted("The gun fires quickly (players can set hotkey for the 'swarm' spell and/or use CTRL for rapid cast)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Hitting a shaman will damage for 20% of their max health")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Hitting a shaman perfectly will deal double damage (40%)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Score is earned as it follows:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("+4 for hitting enemy;   +6 for headshotting enemy;   +15 for killing.")
	   	imgui.NextColumn()
		imgui.TextUnformatted("-1 for being hit;       -2 for being headshotted;    -5 for dying")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("* S-clicks don't follow the shamans ; Friendly fire is on *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* There's a 0.3s delay between shooting and it hitting the target *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* Check your K/D, HP, and bullet count (max 7) at the bottom *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points wins).")
		imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("PAINTGUN - swarm")
		
		imgui.End()
	end
end


--trees random size
ProcessGlobalSpecialList(TRIBE_NEUTRAL, WOODLIST, function(t)
  if (t.Model < 2) then
	t.u.ObjectInfo.Scale = 128+G_RANDOM(256+64)
  else
    t.u.ObjectInfo.Scale = t.u.ObjectInfo.Scale+G_RANDOM(64)
  end
  return true
end)

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_INFO_DROP) or (event == SND_EVENT_INFO_BOUNCE) then
		return 1
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(110,152),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2122)
