----4v4 Four Sectors Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Building)
import(Module_Spells)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 0
local team2Score = 0
local maxScore = 2500
local team1Quantifier = 1
local team2Quantifier = 1
local day = 1
local dayTimer = -1
local team1PerSec = 0
local team2PerSec = 0
local giveSpells = {M_SPELL_BLAST,M_SPELL_INSECT_PLAGUE,M_SPELL_LIGHTNING_BOLT,M_SPELL_WHIRLWIND,M_SPELL_GHOST_ARMY,M_SPELL_INVISIBILITY}
set_level_type(12)
local pupTimer = 12*50+ 12*math.random(10,20)
local pupBounce = 0
local team1pup = -1
local team2pup = -1
----------------------------------------------------spell constants
sti = spells_type_info()
tmi = thing_move_info()

sti[M_SPELL_INSECT_PLAGUE].Cost = sti[M_SPELL_INSECT_PLAGUE].Cost
sti[M_SPELL_INSECT_PLAGUE].OneOffMaximum = 3

sti[M_SPELL_WHIRLWIND].Cost = math.floor(sti[M_SPELL_WHIRLWIND].Cost * 1.3)
sti[M_SPELL_WHIRLWIND].OneOffMaximum = 2

sti[M_SPELL_GHOST_ARMY].Cost = math.floor(sti[M_SPELL_INSECT_PLAGUE].Cost * 1.5)
sti[M_SPELL_GHOST_ARMY].OneOffMaximum = 3

local suicide = M_SPELL_INVISIBILITY
sti[suicide].OneOffMaximum = 1
sti[suicide].Cost = 12000
sti[suicide].WorldCoordRange = 4096
sti[suicide].CursorSpriteNum = 37
sti[suicide].AvailableSpriteIdx = 2118
sti[suicide].NotAvailableSpriteIdx = 2118
sti[suicide].ClickedSpriteIdx = 2118

local addedTimer = 10
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].Cost = 800000
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].Cost = 600000
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)


tmi[TMI_PERSON_MEDICINE_MAN].BaseSpeed = 64
set_correct_gui_menu()

_constants = constants();
_constants.ShamenDeadManaPer256Gained = 8
_constants.ShamenDeadManaPer256Lost = 8
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				cor = marker_to_coord3d(1),
				reinc = -1,
				ldb = 8
			},
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 12,
				name = "red",
				cor = marker_to_coord3d(2),
				reinc = -1,
				ldb = 8
			},
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 5,
				name = "yellow",
				cor = marker_to_coord3d(3),
				reinc = -1,
				ldb = 8
			},
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 3,
				name = "green",
				cor = marker_to_coord3d(4),
				reinc = -1,
				ldb = 8
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 7,
				name = "cyan",
				cor = marker_to_coord3d(5),
				reinc = -1,
				ldb = 8
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 6,
				name = "magenta",
				cor = marker_to_coord3d(6),
				reinc = -1,
				ldb = 8
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 16,
				name = "black",
				cor = marker_to_coord3d(7),
				reinc = -1,
				ldb = 8
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				cor = marker_to_coord3d(8),
				reinc = -1,
				ldb = 8
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--[[if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil then
			pl[i].alive = 0
			if pl[i].reinc == -1 then
				pl[i].reinc = 12*5
				--add death visual
				local Dsprite = 24
				if pl[i].ldb ~= 8 then
					Dsprite = 2083 + pl[i].ldb
				end
				local Dname = "..."
				if Dsprite ~= 24 then
					Dname = pl[pl[i].ldb].name
				end
				local Dname2 = pl[i].name
				table.insert(deaths,{Dname,Dname2,Dsprite,2083+i,12*7})
			end
		end
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
local unwalkableZones = {33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50}
for i,KEY in ipairs(unwalkableZones) do
	local mk2c3d = marker_to_coord3d(KEY)
	SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(mk2c3d), function(me)
		me.Flags = EnableFlag(me.Flags, (1<<2))
		me.Flags = EnableFlag(me.Flags, (1<<19))
	return true
	end)
end

zones = {
			[0] =
			{
				name = "forest",
				owner = -1,
				mk = 17,
				radius = 5,
				neutralizer = 30*12
			},
			{
				name = "lakes",
				owner = -1,
				mk = 22,
				radius = 2,
				neutralizer = 30*12
			},
			{
				name = "desert",
				owner = -1,
				mk = 32,
				radius = 4,
				neutralizer = 30*12
			},
			{
				name = "graveyard",
				owner = -1,
				mk = 27,
				radius = 2,
				neutralizer = 30*12
			}
}

--sparkles in zones
for i = 0,#zones do
	SearchMapCells(CIRCULAR, 0, zones[i].radius , zones[i].radius - 1, world_coord3d_to_map_idx(marker_to_coord3d(zones[i].mk)), function(me)
		local _me = MAP_ELEM_PTR_2_IDX(me)
		local c3d = Coord3D.new()
		map_idx_to_world_coord3d_centre(_me,c3d)
		local spk = createThing(T_EFFECT,60,TRIBE_NEUTRAL,c3d,false,false)
		centre_coord3d_on_block(spk.Pos.D3)
		spk.DrawInfo.Alpha = 0
		spk.u.Effect.Duration = -1
	return true end)
end
--sparkles in portals
for i = 33,48 do
	local spk = createThing(T_EFFECT,60,TRIBE_NEUTRAL,marker_to_coord3d(i),false,false)
	spk.Pos.D3.Ypos = 555
	centre_coord3d_on_block(spk.Pos.D3)
	spk.DrawInfo.Alpha = 0
	spk.u.Effect.Duration = -1
end

function ChangeColors(zone,color)
	SearchMapCells(CIRCULAR, 0, zones[zone].radius , zones[zone].radius - 1, world_coord3d_to_map_idx(marker_to_coord3d(zones[zone].mk)), function(me)
		me.MapWhoList:processList( function (t)
			if (t.Type == T_EFFECT and t.Model == 60) then
				t.DrawInfo.Alpha = color
			end
		return true end)
	return true end)
	--in portals
	local portalSpk = {} for i = 33,48 do table.insert(portalSpk,i) end
	for k,v in ipairs(portalSpk) do
		SearchMapCells(CIRCULAR, 0, 0 , 0, world_coord3d_to_map_idx(marker_to_coord3d(v)), function(me)
			me.MapWhoList:processList( function (t)
				if (t.Type == T_EFFECT and t.Model == 60) then
					if zone == 0 then
						if v >= 33 and v <= 36 then
							t.DrawInfo.Alpha = color
						end
					elseif zone == 1 then
						if v >= 37 and v <= 40 then
							t.DrawInfo.Alpha = color
						end
					elseif zone == 2 then
						if v >= 41 and v <= 44 then
							t.DrawInfo.Alpha = color
						end
					else
						if v >= 45 and v <= 48 then
							t.DrawInfo.Alpha = color
						end
					end
				end
			return true end)
		return true end)
	end
end





function OnTurn()

	if win ~= 1 then AliveandOnline() end

	if win == 0 then
		--team having power up 20 secs
		if team1pup > 0 then
			team1pup = team1pup - 1
		elseif team1pup == 0 then
			queue_sound_event(nil, SND_EVENT_DISCOVERY_END,SEF_FIXED_VARS)
			team1pup = -1
			if team1Quantifier == 2 then team1Quantifier = 1 elseif team2Quantifier == 0 then team2Quantifier = 1 end
		end
		--
		if team2pup > 0 then
			team2pup = team2pup - 1
		elseif team2pup == 0 then
			queue_sound_event(nil, SND_EVENT_DISCOVERY_END,SEF_FIXED_VARS)
			team2pup = -1
			if team2Quantifier == 2 then team2Quantifier = 1 elseif team1Quantifier == 0 then team1Quantifier = 1 end
		end
		--catch power ups
		for i = 0,7 do
			if getShaman(i) ~= nil then
				local s = getShaman(i)
				if IS_SHAMAN_IN_AREA(i,0,0) > 0 then
					if s.Pos.D3.Ypos < 256 then
						SearchMapCells(CIRCULAR, 0, 0 , 0, world_coord3d_to_map_idx(marker_to_coord3d(0)), function(me)
							me.MapWhoList:processList( function (t)
								if (t.Type == T_EFFECT and t.Model == 10) then
									local pupType = t.DrawInfo.DrawNum
									if pupType == 2068 then
										if i < 4 then
											team1Quantifier = 2
											team1pup = 12*16
										else
											team2Quantifier = 2
											team2pup = 12*16
										end
									elseif pupType == 2069 then
										if i < 4 then
											team2Quantifier = 0
											team1pup = 12*16
										else
											team1Quantifier = 0
											team2pup = 12*16
										end
									end
									createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,marker_to_coord3d(0),false,false)
									queue_sound_event(nil, SND_EVENT_DISCOVERY,SEF_FIXED_VARS)
									t.DrawInfo.DrawNum = 2056
									t.u.Effect.Duration = 1
									pupTimer = 12*50+ 12*math.random(10,40)
								end
							return true end)
						return true end)
					end
				end
			end
		end
		--power up
		if pupTimer > 0 then
			pupTimer = pupTimer - 1
		elseif pupTimer == 0 then
			local exists = 0
			SearchMapCells(CIRCULAR, 0, 0 , 0, world_coord3d_to_map_idx(marker_to_coord3d(0)), function(me)
				me.MapWhoList:processList( function (t)
					if (t.Type == T_EFFECT and t.Model == 10) then
						exists = 1
					end
				return true end)
			return true end)
			if exists == 0 then
				local powerThing = createThing(T_EFFECT,10,TRIBE_HOSTBOT,marker_to_coord3d(0),false,false)
				centre_coord3d_on_block(powerThing.Pos.D3)
				set_thing_draw_info(powerThing,TDI_SPRITE_F1_D1, math.random(2068,2069))
				powerThing.u.Effect.Duration = -1
				powerThing.DrawInfo.Alpha = -16
				powerThing.Pos.D3.Ypos = powerThing.Pos.D3.Ypos + 196
				pupTimer = 12*50+ 12*math.random(10,40)
			else
				pupTimer = 12*30+ 12*math.random(5,10)
			end
		end
		--power up bounce
		ProcessGlobalTypeList(T_EFFECT ,function(t)
			if t.Model == 10 then
				if pupBounce == 0 then
					t.Pos.D3.Ypos = t.Pos.D3.Ypos + 8
				else
					t.Pos.D3.Ypos = t.Pos.D3.Ypos - 8
				end
			end
		return true end)
		if turn() % 24 == 0 and win > -1 then
			if pupBounce == 0 then pupBounce = 1 else pupBounce = 0 end
		end
		--day night
		if dayTimer > 0 then
			dayTimer = dayTimer - 1
		elseif dayTimer == 0 then
			if day == 1 then
				day = 0
				set_level_type(13)
			else
				day = 1
				set_level_type(12)
			end
			dayTimer = 12*90
		end
		--enter portals
		for i = 0,7 do
			if pl[i].online == 1 and getShaman(i) ~= nil then
				if IS_SHAMAN_IN_AREA(i,9,1) > 0 then
					local randomforest = math.random(13,16)
					createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,marker_to_coord3d(randomforest),false,false)
					createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
					move_thing_within_mapwho(getShaman(i), marker_to_coord3d(randomforest))
					MOVE_SHAMAN_TO_MARKER(i,randomforest)
					queue_sound_event(nil, SND_EVENT_GHOST_DIE ,SEF_FIXED_VARS)
					if getShaman(i).Flags3 & TF3_SHIELD_ACTIVE > 0 then
						getShaman(i).u.Pers.u.Owned.ShieldCount = 5
					end
					set_player_can_cast(M_SPELL_GHOST_ARMY,i)
				end
				if IS_SHAMAN_IN_AREA(i,10,1) > 0 then
					local randomlake = math.random(18,21)
					createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,marker_to_coord3d(randomlake),false,false)
					createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
					move_thing_within_mapwho(getShaman(i), marker_to_coord3d(randomlake))
					MOVE_SHAMAN_TO_MARKER(i,randomlake)
					queue_sound_event(nil, SND_EVENT_GHOST_DIE ,SEF_FIXED_VARS)
					if getShaman(i).Flags3 & TF3_SHIELD_ACTIVE > 0 then
						getShaman(i).u.Pers.u.Owned.ShieldCount = 5
					end
					for k,v in ipairs(giveSpells) do
						if v ~= suicide then
							set_player_cannot_cast(v,i)
						end
					end
					set_player_can_cast(M_SPELL_BLAST,i)
				end
				if IS_SHAMAN_IN_AREA(i,11,1) > 0 then
					local randomdesert = math.random(28,31)
					createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,marker_to_coord3d(randomdesert),false,false)
					createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
					move_thing_within_mapwho(getShaman(i), marker_to_coord3d(randomdesert))
					MOVE_SHAMAN_TO_MARKER(i,randomdesert)
					queue_sound_event(nil, SND_EVENT_GHOST_DIE ,SEF_FIXED_VARS)
					if getShaman(i).Flags3 & TF3_SHIELD_ACTIVE > 0 then
						getShaman(i).u.Pers.u.Owned.ShieldCount = 5
					end
					set_player_can_cast(M_SPELL_GHOST_ARMY,i)
				end
				if IS_SHAMAN_IN_AREA(i,12,1) > 0 then
					local randomgrave = math.random(23,26)
					createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,marker_to_coord3d(randomgrave),false,false)
					createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
					move_thing_within_mapwho(getShaman(i), marker_to_coord3d(randomgrave))
					MOVE_SHAMAN_TO_MARKER(i,randomgrave)
					queue_sound_event(nil, SND_EVENT_GHOST_DIE ,SEF_FIXED_VARS)
					if getShaman(i).Flags3 & TF3_SHIELD_ACTIVE > 0 then
						getShaman(i).u.Pers.u.Owned.ShieldCount = 5
					end
					set_player_can_cast(M_SPELL_GHOST_ARMY,i)
				end
			end
		end
		--reincarnate shamans
		for i = 0,7 do
			if pl[i].online == 1 then
				if pl[i].reinc > 0 then
					pl[i].reinc = pl[i].reinc - 1
				elseif pl[i].reinc == 0 then
					pl[i].reinc = -1
					pl[i].alive = 1
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
					centre_coord3d_on_block(getShaman(i).Pos.D3)
					if getShaman(i) ~= nil then
						getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
						getShaman(i).u.Pers.u.Owned.ShieldCount = -1
					end
					for k,v in ipairs(giveSpells) do
						if v ~= M_SPELL_GHOST_ARMY then
							set_player_can_cast(v,i)
						else
							set_player_cannot_cast(v,i)
						end
					end
				end
			end
		end
		--capture zones
		for i = 0,#zones do
			local t1 = 0
			local t2 = 0
			for j = 0,7 do
				if pl[j].online == 1 and getShaman(j) ~= nil then
					if (IS_SHAMAN_IN_AREA(j,zones[i].mk,zones[i].radius - 1) > 0) and getShaman(j).u.Pers.Life > 0 then
						if j < 4 then t1 = t1 + 1 else t2 = t2 + 1 end
					end
				end
			end
			if t1 > t2 then
				if zones[i].owner ~= 0 then zones[i].owner = 0 ChangeColors(i,2) end
			elseif t2 > t1 then
				if zones[i].owner ~= 7 then zones[i].owner = 7 ChangeColors(i,9) end
			end
			--zone neutralizer after 30s
			if zones[i].owner ~= -1 and zones[i].neutralizer > 0 and (t1+t2 == 0) then
				zones[i].neutralizer = zones[i].neutralizer - 1
				if zones[i].neutralizer == 0 then
					zones[i].neutralizer = 30*12
					zones[i].owner = -1
					ChangeColors(i,0)
				end
			else
				zones[i].neutralizer = 30*12
			end
		end
		--mana
		for i = 0,7 do
			GIVE_MANA_TO_PLAYER (i,800)
		end
		--desert tornados
		if every2Pow(8) then
			local dustMK = math.random(51,185)
			local dustD3 = marker_to_coord3d(dustMK)
			createThing(T_EFFECT,M_EFFECT_WHIRLWIND,TRIBE_NEUTRAL,dustD3,false,false)
		end
		if everySeconds(1) then
			--zones give points [f l d g]
			local a1,a2 = 0,0
			if zones[0].owner == 0 then team1Score = team1Score + (3*team1Quantifier) a1 = a1 + (3*team1Quantifier) elseif zones[0].owner == 7 then team2Score = team2Score + (3*team2Quantifier) a2 = a2+(3*team2Quantifier) end
			if zones[1].owner == 0 then team1Score = team1Score + (3*team1Quantifier) a1 = a1 + (3*team1Quantifier) elseif zones[1].owner == 7 then team2Score = team2Score + (3*team2Quantifier) a2 = a2+(3*team2Quantifier) end
			local desertPts = 4 if day == 0 then desertPts = 2 end
			if zones[2].owner == 0 then team1Score = team1Score + (desertPts*team1Quantifier) a1 = a1 + (desertPts*team1Quantifier) elseif zones[2].owner == 7 then team2Score = team2Score + (desertPts*team2Quantifier) a2 = a2+(desertPts*team2Quantifier) end
			local graveyardPts = 1 if day == 0 then graveyardPts = 5 end
			if zones[3].owner == 0 then team1Score = team1Score + (graveyardPts*team1Quantifier) a1 = a1 + (graveyardPts*team1Quantifier) elseif zones[3].owner == 7 then team2Score = team2Score + (graveyardPts*team2Quantifier) a2 = a2+(graveyardPts*team2Quantifier) end
			team1PerSec = a1
			team2PerSec = a2
		end
		--win by pts
		if team1Score == maxScore or team2Score == maxScore then
			if team1Score == maxScore and team2Score == maxScore then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		if timer > 0 then
			timer = timer -1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
			smok.DrawInfo.Alpha = pl[i].color ; smok.u.Effect.Duration = 2
			smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 32
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		dayTimer = 12*90
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		for i = 0,7 do
			for k,v in ipairs(giveSpells) do
				if v ~= M_SPELL_GHOST_ARMY then
					set_player_can_cast(v,i)
				end
			end
			if getShaman(i) ~= nil then
				getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
				getShaman(i).u.Pers.u.Owned.ShieldCount = -1
			end
		end
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
	end
	--reset score if too big
	if team1Score > 2500 then team1Score = 2500 end
	if team2Score > 2500 then team2Score = 2500 end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--kill ghost shamans
	ProcessGlobalSpecialListAll(PEOPLELIST, function(t)
		if t.Model == M_PERSON_MEDICINE_MAN and (t.Flags2 & TF2_THING_IS_A_GHOST_PERSON > 0) then
			damage_person(t, 8, 20000, TRUE)
		end
	return true end)
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			pl[i].ldb = getShaman(i).u.Pers.u.Owned.LastDamagedBy
		end
	end
end



function OnCreateThing(t)
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	else
		--suicide spell
		if t.Type == T_SPELL then
			if t.Model == suicide then
				if getShaman(t.Owner) ~= nil then
					createThing(T_EFFECT,M_EFFECT_ROCK_EXPLOSION ,8,getShaman(t.Owner).Pos.D3,false,false)
					queue_sound_event(t, SND_EVENT_FLESH_OUCH ,SEF_FIXED_VARS)
					getShaman(t.Owner).u.Pers.Life = 0
				end
			end
		end
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/2500)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/2500"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/2500)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/2500"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		--bot right corner show who owns zones
		local size,offset = math.floor(h/24),4
		for i = 0,3 do
			local clr,owner = 0,zones[i].owner ; if owner ~= -1 then if owner == 0 then clr = 4 else clr = 14 end end
			local start = h-4-(offset*3)-(size*4)
			DrawBox(w-4-size-1,start+offset*i+size*i-1,size+2,size+2,-1)
			DrawBox(w-4-size,start+offset*i+size*i,size,size,clr)
			LbDraw_ScaledSprite(w-4-size+2,start+offset*i+size*i+2,get_sprite(0,2064+i),size-4,size-4)
		end
		--top show pts/sec
		PopSetFont(1)
		local t1,t2 = "+" .. team1PerSec .. "/sec", "+" .. team2PerSec .. "/sec"
		LbDraw_Text(guiW+8+8,barThickness,t1,0)
		LbDraw_Text(w-8-8-string_width(t2),barThickness,t2,0)
		
		--show quantifiers and timers
		PopSetFont(11)
		if team1Quantifier == 2 then
			DrawBox(math.floor(guiW+8+(barLen/2)-(size/2)),barThickness+8,size,size,4)
			DrawBox(math.floor(guiW+8+(barLen/2)-(size/2)+2),barThickness+8+2,size-4,size-4,0)
			LbDraw_ScaledSprite(math.floor(guiW+8+(barLen/2)-(size/2)+2),barThickness+8+2,get_sprite(0,2068),size-4,size-4)
			local txt = "  " .. math.floor(team1pup/12) .. ""
			LbDraw_Text(math.floor(guiW+8+(barLen/2)-(size/2)),barThickness+size+8,txt,0)
		elseif team1Quantifier == 0 then
			DrawBox(math.floor(w-8-(barLen/2)-(size/2)),barThickness+8,size,size,14)
			DrawBox(math.floor(w-8-(barLen/2)-(size/2)+2),barThickness+8+2,size-4,size-4,0)
			LbDraw_ScaledSprite(math.floor(w-8-(barLen/2)-(size/2)+2),barThickness+8+2,get_sprite(0,2069),size-4,size-4)
			local txt = "  " .. math.floor(team2pup/12) .. ""
			LbDraw_Text(math.floor(w-8-(barLen/2)-(size/2)),barThickness+size+8,txt,0)
		elseif team2Quantifier == 2 then
			DrawBox(math.floor(w-8-(barLen/2)-(size/2)),barThickness+8,size,size,14)
			DrawBox(math.floor(w-8-(barLen/2)-(size/2)+2),barThickness+8+2,size-4,size-4,0)
			LbDraw_ScaledSprite(math.floor(w-8-(barLen/2)-(size/2)+2),barThickness+8+2,get_sprite(0,2068),size-4,size-4)
			local txt = "  " .. math.floor(team2pup/12) .. ""
			LbDraw_Text(math.floor(w-8-(barLen/2)-(size/2)),barThickness+size+8,txt,0)
		elseif team2Quantifier == 0 then
			DrawBox(math.floor(guiW+8+(barLen/2)-(size/2)),barThickness+8,size,size,4)
			DrawBox(math.floor(guiW+8+(barLen/2)-(size/2)+2),barThickness+8+2,size-4,size-4,0)
			LbDraw_ScaledSprite(math.floor(guiW+8+(barLen/2)-(size/2)+2),barThickness+8+2,get_sprite(0,2069),size-4,size-4)
			local txt = "  " .. math.floor(team1pup/12) .. ""
			LbDraw_Text(math.floor(guiW+8+(barLen/2)-(size/2)),barThickness+size+8,txt,0)
		end
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end
end



--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Four Sectors MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Teams must set up a plan to capture sectors, which will earn them points per second")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Each of the 4 sectors generate different points, depending on whether it's day or night time:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Forest:      +3 during day | +3 during night")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Lakes:       +3 during day | +3 during night")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Desert:      +4 during day | +2 during night")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Graveyard:   +1 during day | +5 during night")
		imgui.NextColumn()
		imgui.TextUnformatted("Each day/night cycle lasts 1.5 minutes ; zones become neutral after 30 seconds *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Occasionally, a power-up appears in the center of the map. It can be one of two:")
		imgui.NextColumn()
		imgui.TextUnformatted("- doubles your team's point income for 15 seconds")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- nulifies the enemy team's point income for 15 seconds")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 10 minutes (whoever has most points wins).")
		imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Extra note: the Lakes zone only allows the spell blast")
		imgui.NextColumn()
		imgui.TextUnformatted("Extra note: There is a suicide spell. It instantly kills your shaman (hotkey: invisibility)")
		
		imgui.End()
	end
end

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_SHAM_INVIS) or (event == SND_EVENT_ESHAM_INVIS) then
		return 1
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(130,28),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2122)