--Naval Warfare Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Building)
import(Module_Spells)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end

local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
	SET_NO_REINC(i)
	if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 0
local team2Score = 0
----------------------------------------------------spell constants
sti = spells_type_info()
tmi = thing_move_info()

local CannonSpell = M_SPELL_SWAMP
local greekFireSpell = M_SPELL_HYPNOTISM
--cannon ball
sti[CannonSpell].Cost = 10000
sti[CannonSpell].OneOffMaximum = 1
sti[CannonSpell].WorldCoordRange = 8192+4096
sti[CannonSpell].CursorSpriteNum = 163
sti[CannonSpell].AvailableSpriteIdx = 1740
sti[CannonSpell].NotAvailableSpriteIdx = 1740
sti[CannonSpell].ClickedSpriteIdx = 1740

--greek fire
sti[greekFireSpell].Cost = 90000
sti[greekFireSpell].OneOffMaximum = 2
sti[greekFireSpell].WorldCoordRange = 8192+2048
sti[greekFireSpell].CursorSpriteNum = 103
sti[greekFireSpell].ToolTipStrIdx = sti[M_SPELL_ARMAGEDDON].ToolTipStrIdx
sti[greekFireSpell].ToolTipStrIdxLSME = sti[M_SPELL_ARMAGEDDON].ToolTipStrIdxLSME
sti[greekFireSpell].AvailableSpriteIdx = 1741
sti[greekFireSpell].NotAvailableSpriteIdx = 1741
sti[greekFireSpell].ClickedSpriteIdx = 1741

local addedTimer = 8
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)

tmi[TMI_PERSON_MEDICINE_MAN].BaseSpeed = 64
set_correct_gui_menu()
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				id = 0,
				cor = marker_to_coord3d(0),
				cannonCDR = -1,
				cannonc3d = -1,
				lightCannonBall = 0,
				gunPowder = 0,
				boatOnFire = 0,
				boatHP = 1024,
				greekFire = -1,
				greekFirec3d = nil,
				respawn = -1,
				rechargeCannon = 0,
				reinc = -1
			},
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 12,
				name = "red",
				id = 1,
				cor = marker_to_coord3d(1),
				cannonCDR = -1,
				cannonc3d = -1,
				lightCannonBall = 0,
				gunPowder = 0,
				boatOnFire = 0,
				boatHP = 1024,
				greekFire = -1,
				greekFirec3d = nil,
				respawn = -1,
				rechargeCannon = 0,
				reinc = -1
			},
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 5,
				name = "yellow",
				id = 2,
				cor = marker_to_coord3d(2),
				cannonCDR = -1,
				cannonc3d = -1,
				lightCannonBall = 0,
				gunPowder = 0,
				boatOnFire = 0,
				boatHP = 1024,
				greekFire = -1,
				greekFirec3d = nil,
				respawn = -1,
				rechargeCannon = 0,
				reinc = -1
			},
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 3,
				name = "green",
				id = 3,
				cor = marker_to_coord3d(3),
				cannonCDR = -1,
				cannonc3d = -1,
				lightCannonBall = 0,
				gunPowder = 0,
				boatOnFire = 0,
				boatHP = 1024,
				greekFire = -1,
				greekFirec3d = nil,
				respawn = -1,
				rechargeCannon = 0,
				reinc = -1
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 7,
				name = "cyan",
				id = 4,
				cor = marker_to_coord3d(4),
				cannonCDR = -1,
				cannonc3d = -1,
				lightCannonBall = 0,
				gunPowder = 0,
				boatOnFire = 0,
				boatHP = 1024,
				greekFire = -1,
				greekFirec3d = nil,
				respawn = -1,
				rechargeCannon = 0,
				reinc = -1
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 6,
				name = "magenta",
				id = 5,
				cor = marker_to_coord3d(5),
				cannonCDR = -1,
				cannonc3d = -1,
				lightCannonBall = 0,
				gunPowder = 0,
				boatOnFire = 0,
				boatHP = 1024,
				greekFire = -1,
				greekFirec3d = nil,
				respawn = -1,
				rechargeCannon = 0,
				reinc = -1
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 1,
				name = "black",
				id = 6,
				cor = marker_to_coord3d(6),
				cannonCDR = -1,
				cannonc3d = -1,
				lightCannonBall = 0,
				gunPowder = 0,
				boatOnFire = 0,
				boatHP = 1024,
				greekFire = -1,
				greekFirec3d = nil,
				respawn = -1,
				rechargeCannon = 0,
				reinc = -1
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				id = 7,
				cor = marker_to_coord3d(7),
				cannonCDR = -1,
				cannonc3d = -1,
				lightCannonBall = 0,
				gunPowder = 0,
				boatOnFire = 0,
				boatHP = 1024,
				greekFire = -1,
				greekFirec3d = nil,
				respawn = -1,
				rechargeCannon = 0,
				reinc = -1
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--[[if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
		--[[if getShaman(i) == nil and pl[i].reinc == 0 then
			pl[i].alive = 0
			pl[i].reinc = -1
		end]]
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
local greekFireSpr = 1737
local lightIronSpr = 1738
local gunPowderSpr = 1739
--
local PupHomeMk = 16
local PupDist = 256
local PupTime = 12*6
local PuPEvilTime = 12*8 + 12*(G_RANDOM(12))
local PuP13Time = 12*17 + 12*(G_RANDOM(13))
----------------------------------------------------
local power1 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(PupHomeMk),false,false) --greek fire
power1.DrawInfo.DrawNum = greekFireSpr ; power1.DrawInfo.Alpha = -16 ; power1.Pos.D3.Ypos = power1.Pos.D3.Ypos + 5
--
local power2 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(PupHomeMk),false,false) --greek fire
power2.DrawInfo.DrawNum = greekFireSpr ; power2.DrawInfo.Alpha = -16 ; power2.Pos.D3.Ypos = power2.Pos.D3.Ypos + 5
----------------------------------------------------
local power9 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(PupHomeMk),false,false) --light iron
power9.DrawInfo.DrawNum = lightIronSpr ; power9.DrawInfo.Alpha = -16 ; power9.Pos.D3.Ypos = power9.Pos.D3.Ypos + 5
----------------------------------------------------
local power13 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(PupHomeMk),false,false) --gunpowder
power13.DrawInfo.DrawNum = gunPowderSpr ; power13.DrawInfo.Alpha = -16 ; power13.Pos.D3.Ypos = power13.Pos.D3.Ypos + 5
---------------------------------------------------------------------------------------------------------
function CopyC3d(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end

function ProcessBoat(pn)
	local a = nil
	ProcessGlobalTypeList(T_VEHICLE,function(t)
		if t.Owner == pn then
			if t.Model < 3 then --boats
				a = t
			end
		end
	return true end)
	return a
end

function ProcessBoatOnWater()
	ProcessGlobalTypeList(T_VEHICLE,function(boat)
		if boat.Model < 3 then --boats
			SearchMapCells(CIRCULAR, 0, 0 , 0, world_coord3d_to_map_idx(boat.Pos.D3), function(me)
				ProcessGlobalTypeList(T_EFFECT,function(gf) --greek fire
					if (gf.Model == 10) then
						if get_world_dist_xz(boat.Pos.D2,gf.Pos.D2) < 256+64 then
							for i = 0,7 do
								if i == boat.Owner then
									pl[i].boatOnFire = 12*8 + 12*(G_RANDOM(3)) --8-10sec
								end
							end
						end
					end
				return true end)
			return true end)
		end
	return true end)
end

function CannonBall(pn,c3d)
	if c3d ~= nil then
		createThing(T_EFFECT,M_EFFECT_LAVA_GLOOP,8,c3d,false,false)
		local bf = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; bf.u.Effect.Duration = 12*(math.random(3,5))
		--create child fires nearby
		local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-256,256) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-256,256)
		local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-256,256) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-256,256)
		local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-256,256) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-256,256)
		local rnd = math.random(100)
		if rnd < 60 then
			local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-512,512) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-512,512)
		end
		if rnd < 30 then
			local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-512,512) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-512,512)
		end
		local explosion = {M_EFFECT_EXPLOSION_1,M_EFFECT_EXPLOSION_2,M_EFFECT_EXPLOSION_3,M_EFFECT_ROCK_EXPLOSION}
		local explo = createThing(T_EFFECT,explosion[math.random(#explosion)],8,c3d,false,false)
		queue_sound_event(explo,SND_EVENT_W_SPLASH, SEF_FIXED_VARS) --ADD SOUND
		local fc = createThing(T_EFFECT,M_EFFECT_FIRECLOUD,8,c3d,false,false) ; fc.Pos.D3.Ypos = -76 ; fc.u.Effect.Duration = 12
		--water splash/snd
		SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(c3d), function(me)
			if (is_map_elem_sea_or_coast(me) > 0) then
				local splash = createThing(T_EFFECT,M_EFFECT_SPLASH,8,c3d,false,false)
				queue_sound_event(splash,SND_EVENT_W_SPLASH, SEF_FIXED_VARS)
				if (is_map_elem_sea_or_coast(me) == 2) then
					splash.u.Effect.Duration = 6*1
				end
			else
				createThing(T_EFFECT,M_EFFECT_WW_DUST,8,c3d,false,false)
				local l = createThing(T_EFFECT,M_EFFECT_LAVA_SQUARE,8,c3d,false,false)
				local smok = createThing(T_EFFECT,M_EFFECT_BLDG_DAMAGED_SMOKE,8,c3d,false,false)
				createThing(T_EFFECT,M_EFFECT_GROUND_SHOCKWAVE,8,c3d,false,false)
			end
		return true
		end)
	end
	--hit shamans
	if pl[pn].gunPowder < 1 then --without gunpowder
		local c2d = Coord2D.new() ; coord3D_to_coord2D(c3d, c2d)
		ProcessGlobalSpecialListAll(0, function(t)
			if t.Model == M_PERSON_MEDICINE_MAN then
				local dist = get_world_dist_xz(t.Pos.D2,c2d) 
				if dist < 1536 and dist > 512 then
					local dmg = math.ceil((1536 - dist)/1.5)
					pl[t.Owner].boatHP = pl[t.Owner].boatHP - dmg
					if dist < 1024 then
						pl[t.Owner].boatOnFire = pl[t.Owner].boatOnFire + 12*3
					end
					if pl[t.Owner].boatHP < 1 then
						ExplodeBoat(t.Owner,pn)
					end
				elseif dist <= 512 then
					local dmg = 1024
					pl[t.Owner].boatHP = pl[t.Owner].boatHP - dmg
					ExplodeBoat(t.Owner,pn)
				end
			end
		return true
		end)
	else --with gunpowder
		--create extra child fires nearby
		local bf = createThing(T_EFFECT,M_EFFECT_ROCK_EXPLOSION,8,c3d,false,false)
		local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-512,512) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-512,512)
		local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-512,512) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-512,512)
		local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-1024,1024) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-1024,1024)
		local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-768,768) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-768,768)
		local child = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,c3d,false,false) ; child.u.Effect.Duration = 24 + math.random(24) ; child.Pos.D3.Ypos = -96 ; child.Pos.D3.Xpos = bf.Pos.D3.Xpos - math.random(-768,768) ; child.Pos.D3.Zpos = bf.Pos.D3.Zpos - math.random(-768,768)
		local c2d = Coord2D.new() ; coord3D_to_coord2D(c3d, c2d)
		ProcessGlobalSpecialListAll(0, function(t)
			if t.Model == M_PERSON_MEDICINE_MAN then
				local dist = get_world_dist_xz(t.Pos.D2,c2d)  
				if dist < 3072 and dist > 1536 then
					local dmg = math.ceil((3072 - dist)/4)
					pl[t.Owner].boatHP = pl[t.Owner].boatHP - dmg
					if pl[t.Owner].boatHP < 1 then
						ExplodeBoat(t.Owner,pn)
					end
				elseif dist <= 1536 and dist > 512+256+64 then
					local dmg = math.ceil((1536 - dist)/2)+512
					pl[t.Owner].boatHP = pl[t.Owner].boatHP - dmg
					pl[t.Owner].boatOnFire = pl[t.Owner].boatOnFire + 12*4
					if pl[t.Owner].boatHP < 1 then
						ExplodeBoat(t.Owner,pn)
					end
				elseif dist <= 512+256 then
					local dmg = 1024
					pl[t.Owner].boatHP = pl[t.Owner].boatHP - dmg
					ExplodeBoat(t.Owner,pn)
				end
			end
		return true
		end)
	end
end

function ExplodeBoat(pn,killer)
	ProcessGlobalTypeList(T_VEHICLE,function(boat)
		if boat.Model < 3 and boat.Owner == pn then
			if boat ~= nil then boat.State = S_VEHICLE_BLAST_EXPLODING end
		end
	return true end)
	--add death visual
	--local Dsprite = 24
	--if pl[i].ldb ~= 8 then
		Dsprite = 2083 + killer --+ pl[pn].ldb
	--end
	local Dname = "..."
	if Dsprite ~= 24 then
		Dname = pl[killer].name
	end
	local Dname2 = pl[pn].name
	table.insert(deaths,{Dname,Dname2,Dsprite,2083+pn,12*7})
end

function SinkBoatsAdrift()
	ProcessGlobalTypeList(T_VEHICLE,function(boat)
		if boat.Model < 3 then
			if boat ~= nil and boat.State == S_VEHICLE_DRIFT_TO_SHORE then if rnd() < 50 then boat.State = S_VEHICLE_BOAT_DYING else boat.State = S_VEHICLE_BLAST_EXPLODING end end
		end
	return true end)
end

function GreekFire(i,c3d)
	if pl[i].greekFirec3d ~= nil then
		SearchMapCells(CIRCULAR ,0, 5, 4, world_coord3d_to_map_idx(pl[i].greekFirec3d), function(me)
			local ptr = MAP_ELEM_PTR_2_IDX(me)
			local c3d = Coord3D.new()
			map_idx_to_world_coord3d(ptr,c3d)
			local greekFire = createThing(T_EFFECT,10,8,c3d,false,false) centre_coord3d_on_block(greekFire.Pos.D3)
			greekFire.u.Effect.Duration = 12*10 + math.random(24) ; greekFire.DrawInfo.DrawNum = 1090
			if i < 4 then
				greekFire.DrawInfo.Alpha = pl[i].color
			else
				greekFire.DrawInfo.Alpha = 6
			end
		return true end)
		queue_sound_event(nil, SND_EVENT_CMD_MENU_HILITE, SEF_FIXED_VARS)
	end
end

function ResetStates(i)
	pl[i].boatOnFire = 0
	pl[i].boatHP = 1024
	pl[i].alive = 1
	pl[i].cannonCDR = -1
	pl[i].cannonc3d = -1
	pl[i].lightCannonBall = 0
	pl[i].gunPowder = 0
	pl[i].greekFire = -1
	pl[i].greekFirec3d = nil
end

--local onFireDamage = 4 --replaced with math.random(1,5)

function CatchPowerUp(pn)
	ProcessGlobalTypeList(T_GENERAL,function(powerUp)
		if powerUp.Model == M_GENERAL_MAPWHO_THING then
			if are_coords_on_same_map_cell(marker_to_coord2d(PupHomeMk),powerUp.Pos.D2) == 0 then
				if get_world_dist_xz(getShaman(pn).Pos.D2,powerUp.Pos.D2) < PupDist then
					--greek fire
					if powerUp.DrawInfo.DrawNum == greekFireSpr then
						if GET_NUM_ONE_OFF_SPELLS(pn,greekFireSpell) < 2 then
							gs.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[greekFireSpell] = gs.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[greekFireSpell] + 1
						end
					--light iron
					elseif powerUp.DrawInfo.DrawNum == lightIronSpr then
						pl[pn].lightCannonBall = 12*25
					--gun powder
					elseif powerUp.DrawInfo.DrawNum == gunPowderSpr then
						pl[pn].gunPowder = 12*25
					end
					--reset power up:
					createThing(T_EFFECT,M_EFFECT_ORBITER,8,getShaman(pn).Pos.D3,false,false)
					move_thing_within_mapwho(powerUp,marker_to_coord3d(PupHomeMk))
					powerUp.DrawInfo.DrawNum = 54 ; powerUp.DrawInfo.Alpha = 0
				end
			end
		end
	return true end)
end

function CreatePowerUp(thing,sprite)
	if are_coords_on_same_map_cell(thing.Pos.D2,marker_to_coord2d(PupHomeMk)) == 1 then
		local a = 0
		local c3d = nil
		repeat 
			local x = math.random(10,134) ; local z = math.random(10,134)
			local m = MapPosXZ.new() ; c3d = Coord3D.new()
			m.XZ.X = x ; m.XZ.Z = z ; map_idx_to_world_coord3d(m.Pos, c3d)
			--ensure it wont spawn in middle island
			SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(c3d), function(me)
				if (is_map_elem_sea_or_coast(me) < 1) then
					a = a + 1
				end
			return true end)
			--dont overlap power ups on same cell
			local c2d = Coord2D.new() ; coord3D_to_coord2D(c3d,c2d)
			ProcessGlobalTypeList(T_GENERAL,function(p)
				if p.Model == M_GENERAL_MAPWHO_THING then
					if are_coords_on_same_map_cell(p.Pos.D2,c2d) == 1 then
						a = a + 1
					end
				end
			return true end)
		until a == 0	
		move_thing_within_mapwho(thing,c3d)
		thing.DrawInfo.DrawNum = sprite ; thing.DrawInfo.Alpha = -16 ; thing.Pos.D3.Ypos = thing.Pos.D3.Ypos + 8
		queue_sound_event(nil, SND_EVENT_BLDG_STAMP, SEF_FIXED_VARS)
	end
end





function OnTurn()

	if win ~= 1 then AliveandOnline() end

	if win == 0 then
		--give score if ded
		for i = 0,7 do
			if getShaman(i) == nil and pl[i].reinc == -1 and pl[i].online == 1 then
				pl[i].reinc = 0
				pl[i].alive = 0
				if i < 4 then
					team2Score = team2Score + 1
				else
					team1Score = team1Score + 1
				end
			elseif getShaman(i) ~= nil and pl[i].online == 1 then
				if pl[i].alive == 0 then
					pl[i].alive = 1
				end
				if pl[i].reinc == 0 then
					pl[i].reinc = -1
				end
			end
		end
		--power up timer going down
		if PupTime > 0 then
			PupTime = PupTime - 1
		elseif PupTime == 0 then
			PupTime = 12*16 + 12*math.random(10)
			if are_coords_on_same_map_cell(marker_to_coord2d(PupHomeMk),power1.Pos.D2) == 1 then
				CreatePowerUp(power1,greekFireSpr)
			else
				if are_coords_on_same_map_cell(marker_to_coord2d(PupHomeMk),power2.Pos.D2) == 1 then
					CreatePowerUp(power2,greekFireSpr)
				end
			end
		end
		if PuPEvilTime > 0 then
			PuPEvilTime = PuPEvilTime - 1
		elseif PuPEvilTime == 0 then
			PuPEvilTime = 12*22 + 12*math.random(5)
			CreatePowerUp(power9,lightIronSpr)
		end
		if PuP13Time > 0 then
			PuP13Time = PuP13Time - 1
		elseif PuP13Time == 0 then
			PuP13Time = 12*22 + 12*math.random(5)
			CreatePowerUp(power13,gunPowderSpr)
		end
		if every2Pow(4) then
			for i = 0,7 do
				if _gsi.Players[i].NumVehiclesOfType[M_VEHICLE_BOAT_1] == 0 and getShaman(i) ~= nil and IS_SHAMAN_IN_AREA(i,i+8,4) == 1 then
					createThing(T_VEHICLE,M_VEHICLE_BOAT_1,i,marker_to_coord3d(i+8),false,false)
				end
			end
		end
		if every2Pow(5) then
			--Find adrift boats
			SinkBoatsAdrift()
		end
		if every2Pow(2) then
			ProcessBoatOnWater()
			for i = 0,7 do
				--kill extra boats
				if _gsi.Players[i].NumVehiclesOfType[M_VEHICLE_BOAT_1] > 1 then
					ProcessGlobalTypeList(T_VEHICLE,function(boat)
						if boat.Model < 3 and boat.Owner == i then
							if boat.u.Vehicle.NumOccupants == 0 then
								if boat ~= nil then DestroyThing(boat) end
							end
						end
					return true end)
				end
			end
		end
		for i = 0,7 do
			--catch power up
			if getShaman(i) ~= nil and getShaman(i).u.Pers.Life > 0 then
				CatchPowerUp(i)
			end
			--kill if low hp
			if pl[i].boatHP < 1 then
				if getShaman(i) ~= nil then
					damage_person(getShaman(i), TRIBE_NEUTRAL, 6666, 1)
				end	
				ProcessGlobalTypeList(T_VEHICLE,function(boat)
					if boat.Model < 3 and boat.Owner == i then
						if boat ~= nil then boat.State = S_VEHICLE_BOAT_DYING end
					end
				return true end)
			end
			if pl[i].online == 1 then
				--respawn
				if getShaman(i) == nil then
					if pl[i].respawn > 0 then
						pl[i].respawn = pl[i].respawn - 1
					elseif pl[i].respawn == 0 then
						pl[i].respawn = -1
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,marker_to_coord3d(i),false,false)
						ResetStates(i)
					end
				end
				if pl[i].respawn == -1 and getShaman(i) == nil then
						pl[i].respawn = 12*3
					end
				--greekfire cd3
				if pl[i].greekFire > 0 then
					pl[i].greekFire = pl[i].greekFire - 1
				elseif pl[i].greekFire == 0 then
					pl[i].greekFire = -1
					GreekFire(i,pl[i].greekFirec3d)
				end
				--cannon ball
				if pl[i].cannonCDR > 0 then
					pl[i].cannonCDR = pl[i].cannonCDR - 1
				elseif pl[i].cannonCDR == 0 then
					pl[i].cannonCDR = -1
					CannonBall(i,pl[i].cannonc3d)
				end
				--cannon recharge
				if pl[i].rechargeCannon > 0 then
					pl[i].rechargeCannon = pl[i].rechargeCannon - 1
				elseif pl[i].rechargeCannon == 0 then
					pl[i].rechargeCannon = -1
					gs.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[CannonSpell] = gs.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[CannonSpell] + 1
				end
				--gun powder and light cannonball
				if pl[i].lightCannonBall > 0 then
					pl[i].lightCannonBall = pl[i].lightCannonBall - 1
				end
				if pl[i].gunPowder > 0 then
					pl[i].gunPowder = pl[i].gunPowder - 1
				end
				--boat on fire
				if pl[i].boatOnFire > 0 then
					pl[i].boatOnFire = pl[i].boatOnFire - 1
					--lose hp
					if _gsi.Players[i].NumVehiclesOfType[M_VEHICLE_BOAT_1] == 1 and getShaman(i) ~= nil then
						pl[i].boatHP = pl[i].boatHP - math.random(1,5)--onFireDamage
						local boat = ProcessBoat(i)
						if boat ~= nil then
							DrawFire(boat)
						end
					end
				end
				--low hp boat smokes
				if _gsi.Players[i].NumVehiclesOfType[M_VEHICLE_BOAT_1] == 1 and pl[i].boatOnFire == 0 then
					if pl[i].boatHP < 512 then
						local boat = ProcessBoat(i)
						if boat ~= nil then
							DrawHalfHpBoatSmokes(boat)
						end
					elseif pl[i].boatHP < 256 then
						local boat = ProcessBoat(i)
						if boat ~= nil then
							DrawLowHpBoatSmokes(boat)
						end
					end
				end
			end
		end
		--win by pts
		if team1Score == 30 or team2Score == 30 then
			if team1Score == 30 and team2Score == 30 then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		--process timer
		if timer > 0 then
			timer = timer - 1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
			smok.DrawInfo.Alpha = pl[i].color ; smok.u.Effect.Duration = 2
			smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 32
			if is_person_driver_in_any_vehicle(getShaman(i)) == 1 then
				smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 196
			end
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
	end
	--reset score if too big
	if team1Score > 30 then team1Score = 30 end
	if team2Score > 30 then team2Score = 30 end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			pl[i].ldb = getShaman(i).u.Pers.u.Owned.LastDamagedBy
		end
	end
end


local safeZones = {}
local m1 = MapPosXZ.new()
for x= -4,12 do ; for z= -4,12 do
    m1.XZ.X = x ; m1.XZ.Z = z ; table.insert(safeZones, m1.Pos)
end end
for x= 62,78 do ; for z= -4,14 do
    m1.XZ.X = x ; m1.XZ.Z = z ; table.insert(safeZones, m1.Pos)
end end
for x= 132,148 do ; for z= -4,12 do
    m1.XZ.X = x ; m1.XZ.Z = z ; table.insert(safeZones, m1.Pos)
end end
for x= 129,148 do ; for z= 66,82 do
    m1.XZ.X = x ; m1.XZ.Z = z ; table.insert(safeZones, m1.Pos)
end end

for x= 132,148 do ; for z= 132,148 do
    m1.XZ.X = x ; m1.XZ.Z = z ; table.insert(safeZones, m1.Pos)
end end
for x= 64,80 do ; for z= 129,148 do
    m1.XZ.X = x ; m1.XZ.Z = z ; table.insert(safeZones, m1.Pos)
end end
for x= -4,12 do ; for z= 132,148 do
    m1.XZ.X = x ; m1.XZ.Z = z ; table.insert(safeZones, m1.Pos)
end end
for x= -4,14 do ; for z= 64,80 do
    m1.XZ.X = x ; m1.XZ.Z = z ; table.insert(safeZones, m1.Pos)
end end


local dropIcon = 0
function OnCreateThing(t)
	if t.Type == T_SPELL then
		KILL_ALL_MSG_ID(dropIcon)
		dropIcon = dropIcon + 1
		CLEAR_ALL_MSG()
	end
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
	if t.Type == T_EFFECT and (t.Model == greekFireSpell or t.Model == CannonSpell) then
		t.u.Effect.Duration = 1
	end
	--safe zones
	if (t.Type == T_SPELL) then
		local pos = world_coord3d_to_map_idx(t.Pos.D3)
		for k, v in pairs(safeZones) do
			if (v == pos) then
				t.Model = M_SPELL_NONE
			end
		end
		--outside vehicle cant cast
		if is_person_driver_in_any_vehicle(getShaman(t.Owner)) == 0 then
			t.Model = M_SPELL_NONE
		end
	end
	
	--greek fire
	if (t.Type == T_SPELL) and (t.Model == greekFireSpell) and getShaman(t.Owner) ~= nil then
		--t.Model = M_SPELL_NONE
		--queue_sound_event(nil,SND_EVENT_SHOT_STANDARD, SEF_FIXED_VARS)
		pl[t.Owner].greekFire = 8
		pl[t.Owner].greekFirec3d = CopyC3d(t.Pos.D3)
		if GET_NUM_ONE_OFF_SPELLS(t.Owner,greekFireSpell) == 1 then
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[greekFireSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[greekFireSpell] & 240
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[greekFireSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[greekFireSpell] | 0
		else
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[greekFireSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[greekFireSpell] & 240
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[greekFireSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[greekFireSpell] | 1
		end
		local newS = createThing(T_SPELL, M_SPELL_SHIELD, t.Owner, t.Pos.D3, false, false)--this creates the spellcast line between caster and target pos
	end
	--cannon ball
	if (t.Type == T_SPELL) then
		if (t.Model == CannonSpell) then --stolen from kosjak pls dont tell him
		  --t.Model = M_SPELL_NONE
		  gs.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[CannonSpell] = gs.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[CannonSpell] - 1
		  pl[t.Owner].cannonCDR = 16
		  pl[t.Owner].cannonc3d = CopyC3d(t.Pos.D3)
		  g = createThing(T_EFFECT,60,8,t.Pos.D3,false,false) ; set_thing_draw_info(g,TDI_SPRITE_F8_D1_ALPHA, 1441) ; g.u.Effect.Duration = 24 ; g.DrawInfo.Alpha = pl[t.Owner].color
		  if pl[t.Owner].lightCannonBall == 0 then pl[t.Owner].rechargeCannon = 36 else pl[t.Owner].rechargeCannon = 18 end
		  t.u.Spell.TargetThingIdx:set(0)
		  t.u.Spell.ShotThingIdx:set(0)
		  local s = getShaman(t.Owner)
		  if (s ~= nil) then
			local z = (t.Pos.D2.Zpos - s.Pos.D2.Zpos)
			local x = (t.Pos.D2.Xpos - s.Pos.D2.Xpos)
			local ax = math.abs(x)
			local az = math.abs(z)

			if (x > 0 and z > 32767) then
			  if (ax > ((256*256)>>1)) then x = -(ax - (256*256)) end
			  if (az > ((256*256)>>1)) then z = (az - (256*256)) end
			else
			  if (x < 0) then
				if (z >= 0) then
				  if (ax > ((256*256)>>1)) then x = -(ax - (256*256)) end
				  if (az > ((256*256)>>1)) then z = (az - (256*256)) end
				else
				  if (ax > ((256*256)>>1)) then x = -(ax - (256*256)) end
				  if (az > ((256*256)>>1)) then z = -(az - (256*256)) end
				end
			  else
				if (z >= 0) then
				  if (ax > ((256*256)>>1)) then x = (ax - (256*256)) end
				  if (az > ((256*256)>>1)) then z = -(az - (256*256)) end
				else
				  if (ax > ((256*256)>>1)) then x = (ax - (256*256)) end
				  if (az > ((256*256)>>1)) then z = -(az - (256*256)) end
				end
			  end
			end
			local angle = math.atan(z, x) * 180 / math.pi
			angle = math.ceil(angle)
			if (angle<0) then
			  angle=angle+360
			end

			local rotation = (angle * math.pi) / 180
			local veloc = Coord3D.new()
			local distance_xyz = math.ceil(get_world_dist_xyz(s.Pos.D3,t.Pos.D3)/512)
			veloc.Xpos = math.ceil((math.cos(rotation) * 32*distance_xyz))
			veloc.Zpos = math.ceil((math.sin(rotation) * 32*distance_xyz))
			local grenade = createThing(T_SHOT,7,s.Owner,s.Pos.D3,false,false)
			grenade.Move.Velocity.X = veloc.Xpos
			grenade.Move.Velocity.Z = veloc.Zpos
			grenade.Move.Velocity.Y = 256
			grenade.Move.SelfPowerSpeed = 128
		  end
		end
   end
   --no follow cannon balls / change model
	if (t.Type == T_SHOT) then
		if (t.Model == M_SHOT_VOLCANO_FIREBALL_1) then
			t.u.Shot.TargetThingIdx:set(0)
			t.DrawInfo.Alpha = -16
			set_thing_draw_info(t,TDI_SPRITE_F1_D1, 1742)
			if pl[t.Owner].gunPowder > 0 then
				set_thing_draw_info(t,TDI_SPRITE_F1_D1, 1745)
				if pl[t.Owner].lightCannonBall > 0 then
					set_thing_draw_info(t,TDI_SPRITE_F1_D1, 1744)
				end
			else
				if pl[t.Owner].lightCannonBall > 0 then
					set_thing_draw_info(t,TDI_SPRITE_F1_D1, 1743)
				end
			end
		end
	end
end



function OnFrame()
		function DrawFire(vehicle)
			if vehicle ~= nil then
				--fire inside boat
				local fire = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,vehicle.Pos.D3,false,false)
				fire.u.Effect.Duration = 2 ; fire.DrawInfo.Alpha = 0
				--smoke inside boat
				local smoke = createThing(T_EFFECT,M_EFFECT_BLDG_DAMAGED_SMOKE,8,vehicle.Pos.D3,false,false)
				smoke.u.Effect.Duration = 24
				--fire outside boat
				if gs.Counts.ProcessThings % 4 == 0 then
					local fire2 = createThing(T_EFFECT,M_EFFECT_BIG_FIRE ,8,vehicle.Pos.D3,false,false)
					fire2.u.Effect.Duration = 36 + math.random(24,60) ; fire2.DrawInfo.Alpha = 0
					--smoke outside boat
					if math.random(100) < 50 then
						local smoke = createThing(T_EFFECT,M_EFFECT_BLDG_DAMAGED_SMOKE,8,vehicle.Pos.D3,false,false)
						smoke.u.Effect.Duration = 48 + math.random(48,70)
					end
				end
				--some fires on the sides
				if gs.Counts.ProcessThings % 4 == 0 then
					local fire2 = createThing(T_EFFECT,M_EFFECT_BIG_FIRE,8,vehicle.Pos.D3,false,false)
					fire2.u.Effect.Duration = 36 + math.random(24,60) ; fire2.DrawInfo.Alpha = 0
					fire2.Pos.D3.Xpos = fire2.Pos.D3.Xpos + math.random(-512,512) ; fire2.Pos.D3.Zpos = fire2.Pos.D3.Zpos + math.random(-512,512)
				end
			end
		end
		
		function DrawLowHpBoatSmokes(vehicle)
			if vehicle ~= nil then
				local smoke = createThing(T_EFFECT,M_EFFECT_BLDG_DAMAGED_SMOKE,8,vehicle.Pos.D3,false,false)
				smoke.u.Effect.Duration = 12
				local smoke = createThing(T_EFFECT,M_EFFECT_BLDG_DAMAGED_SMOKE,8,vehicle.Pos.D3,false,false)
				smoke.u.Effect.Duration = 12
				smoke.Pos.D3.Xpos = smoke.Pos.D3.Xpos + math.random(-512,512) ; smoke.Pos.D3.Zpos = smoke.Pos.D3.Zpos + math.random(-512,512)
			end
		end
		
		function DrawHalfHpBoatSmokes(vehicle)
			if vehicle ~= nil then
				local smoke = createThing(T_EFFECT,M_EFFECT_BLDG_DAMAGED_SMOKE,8,vehicle.Pos.D3,false,false)
				smoke.u.Effect.Duration = 12
				local smoke = createThing(T_EFFECT,M_EFFECT_BLDG_DAMAGED_SMOKE,8,vehicle.Pos.D3,false,false)
				smoke.u.Effect.Duration = 12
				local smoke = createThing(T_EFFECT,M_EFFECT_BLDG_DAMAGED_SMOKE,8,vehicle.Pos.D3,false,false)
				smoke.u.Effect.Duration = 12
				smoke.Pos.D3.Ypos = smoke.Pos.D3.Ypos + 96
				smoke.Pos.D3.Xpos = smoke.Pos.D3.Xpos + math.random(-256,256) ; smoke.Pos.D3.Zpos = smoke.Pos.D3.Zpos + math.random(-256,256)
				local smoke = createThing(T_EFFECT,M_EFFECT_BLDG_DAMAGED_SMOKE,8,vehicle.Pos.D3,false,false)
				smoke.u.Effect.Duration = 12
				smoke.Pos.D3.Ypos = smoke.Pos.D3.Ypos + 64
				smoke.Pos.D3.Xpos = smoke.Pos.D3.Xpos + math.random(-256,256) ; smoke.Pos.D3.Zpos = smoke.Pos.D3.Zpos + math.random(-256,256)
			end
		end
	
	--------------------------------------------------------------------------------------------------------------------------------

	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/30)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/30"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/30)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/30"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		for i = 0,7 do
			if pl[i].online == 1 then
				local spr = 125 if i < 4 then spr = spr+i else spr = 1723+(i-4) end --654?
				local barLen = 64
				DrawBox(w-4-box2,math.floor(((h-4-box2-(2*7)-(box2*7)))+(i*2)+(i*box2)),box2,box2,0)
				LbDraw_ScaledSprite(w-4-box2,math.floor(((h-4-box2-(2*7)-(box2*7)))+(i*2)+(i*box2)),get_sprite(0,spr),box2,box2)
				--hp bars
				local percent = math.floor((pl[i].boatHP * 100)/1024)
				local barpercent = math.floor((barLen * percent) / 100)
				DrawBox(w-4-box2-barLen-2,math.floor(((h-4-box2-(2*7)-(box2*7)))+(i*2)+(i*box2)+(box2/2)-2),barLen,4,0)
				DrawBox(w-4-box2-barLen-2,math.floor(((h-4-box2-(2*7)-(box2*7)))+(i*2)+(i*box2)+(box2/2)-2),barpercent,4,pl[i].drawClr)
				--show light iron / gunpowder icons
				if pl[i].lightCannonBall > 0 then
					LbDraw_ScaledSprite(w-4-box2-barLen-2-2-box2,math.floor(((h-4-box2-(2*7)-(box2*7)))+(i*2)+(i*box2)),get_sprite(0,lightIronSpr),box2,box2)
				end
				if pl[i].gunPowder > 0 and pl[i].lightCannonBall < 1 then
					LbDraw_ScaledSprite(w-4-box2-barLen-2-2-box2,math.floor(((h-4-box2-(2*7)-(box2*7)))+(i*2)+(i*box2)),get_sprite(0,gunPowderSpr),box2,box2)
				elseif pl[i].gunPowder > 0 and pl[i].lightCannonBall > 0 then
					LbDraw_ScaledSprite(w-4-box2-barLen-2-2-box2-2-box2,math.floor(((h-4-box2-(2*7)-(box2*7)))+(i*2)+(i*box2)),get_sprite(0,gunPowderSpr),box2,box2)
				end
			end
		end
		
		if win == 0 then
			--draw light iron / gunpowder icons
			for i = 0,7 do
				if i == _gnsi.PlayerNum then
					if pl[i].gunPowder > 0 then
						DrawBox(guiW+4,math.floor(h-4-box),box,box,1)
						LbDraw_ScaledSprite(guiW+4,math.floor(h-4-box),get_sprite(0,gunPowderSpr),box,box)
						if pl[i].gunPowder > 60 then PopSetFont(10) else PopSetFont(11) end
						LbDraw_Text(math.floor(guiW+4+(box/2)-2),math.floor(h-4-box-8),"" .. tostring(math.floor(pl[i].gunPowder/12)),0)
					end
					if pl[i].lightCannonBall > 0 and pl[i].gunPowder < 1 then
						DrawBox(guiW+4,math.floor(h-4-box),box,box,1)
						LbDraw_ScaledSprite(guiW+4,math.floor(h-4-box),get_sprite(0,lightIronSpr),box,box)
						if pl[i].lightCannonBall > 60 then PopSetFont(10) else PopSetFont(11) end
						LbDraw_Text(math.floor(guiW+4+(box/2)-2),math.floor(h-4-box-8),"" .. tostring(math.floor(pl[i].lightCannonBall/12)),0)
					elseif pl[i].lightCannonBall > 0 and pl[i].gunPowder > 0 then
						DrawBox(guiW+4+box+4,math.floor(h-4-box),box,box,1)
						LbDraw_ScaledSprite(guiW+4+box+4,math.floor(h-4-box),get_sprite(0,lightIronSpr),box,box)
						if pl[i].lightCannonBall > 60 then PopSetFont(10) else PopSetFont(11) end
						LbDraw_Text(math.floor(guiW+4+box+4+(box/2)-2),math.floor(h-4-box-8),"" .. tostring(math.floor(pl[i].lightCannonBall/12)),0)
					end
				end
			end
		end
	end
end



--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Naval Warfare MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Each shaman has a ship, and must target the enemy shamans to score points for their team")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Players refill the cannon ball every 3 seconds - it has a huge range and deal proximity damage (very close = insta kill)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- If the bomb is rather close, it also sets the boat on fire for a short duration")
	   	imgui.NextColumn()
		imgui.TextUnformatted("There are 3 power ups:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- greek fire (spell): creates a large fire arena, trapping boats inside for 8-10s. boats touching this fire are set on fire for a long duration (max 2 shots)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- light iron (cannon upgrade): you get refills of cannonball 1 second earlier (25s duration)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- gunpowder (cannon upgrade): your cannon balls deal extra damage, and explode in a larger area (25s duration)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* players can only own 1 boat ; your own bombs or greek fire affect you *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* see boats hp and current power ups at bottom right of screen *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* anti camping system: spells don't work near CoRs *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points wins).")
		imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("CANNON - swamp")
		imgui.NextColumn()
		imgui.TextUnformatted("GREEK FIRE - hypnotism")
		imgui.NextColumn()
		
		imgui.End()
	end
end

--surround arena with stone heads
ProcessGlobalTypeList(T_SCENERY,function(t)
	if t.Model < 10 then
		set_thing_draw_info(t,TDI_SPRITE_F1_D1, 687) 
	end
return true end)

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_SHAM_HYPNO) or (event == SND_EVENT_ESHAM_HYPNO) or (event == SND_EVENT_SHOT_FIREBALL) or (event == SND_EVENT_INFO_DROP) or (event == SND_EVENT_INFO_BOUNCE) then
		return 1
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(200,200),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2121)
