-- 4v4 Ninja Shamans Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Spells)
import(Module_Building)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 0
local team2Score = 0
local maxScore = 45
----------------------------------------------------spell constants
sti = spells_type_info()

local addedTimer = 8
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)


local shurikenSpell = M_SPELL_INSECT_PLAGUE
sti[shurikenSpell].Cost = sti[M_SPELL_INSECT_PLAGUE].Cost
sti[shurikenSpell].OneOffMaximum = 2
sti[shurikenSpell].WorldCoordRange = 1024*4
sti[shurikenSpell].CursorSpriteNum = 164
sti[shurikenSpell].AvailableSpriteIdx = 2115
sti[shurikenSpell].NotAvailableSpriteIdx = 2115
sti[shurikenSpell].ClickedSpriteIdx = 2115
--sti[shurikenSpell].ToolTipStrIdx = sti[M_SPELL_VOLCANO].ToolTipStrIdx
--sti[shurikenSpell].ToolTipStrIdxLSME = sti[M_SPELL_VOLCANO].ToolTipStrIdxLSME
set_correct_gui_menu()
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				id = 0,
				cor = marker_to_coord3d(0),
				spellCDR = -1,
				spellc3d = 0,
				incense = -1,
				yoroi = -1,
				danger = 0,
				online = -1,
				reinc = -1,
				ldb = 8
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = -2,
				drawClr = 12,
				name = "red",
				id = 1,
				cor = marker_to_coord3d(1),
				spellCDR = -1,
				spellc3d = 0,
				incense = -1,
				yoroi = -1,
				danger = 0,
				online = -1,
				reinc = -1,
				ldb = 8
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 3,
				drawClr = 5,
				name = "yellow",
				id = 2,
				cor = marker_to_coord3d(2),
				spellCDR = -1,
				spellc3d = 0,
				incense = -1,
				yoroi = -1,
				danger = 0,
				online = -1,
				reinc = -1,
				ldb = 8
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 1,
				drawClr = 3,
				name = "green",
				id = 3,
				cor = marker_to_coord3d(3),
				spellCDR = -1,
				spellc3d = 0,
				incense = -1,
				yoroi = -1,
				danger = 0,
				online = -1,
				reinc = -1,
				ldb = 8
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 10,
				drawClr = 7,
				name = "cyan",
				id = 4,
				cor = marker_to_coord3d(4),
				spellCDR = -1,
				spellc3d = 0,
				incense = -1,
				yoroi = -1,
				danger = 0,
				online = -1,
				reinc = -1,
				ldb = 8
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 11,
				drawClr = 6,
				name = "magenta",
				id = 5,
				cor = marker_to_coord3d(5),
				spellCDR = -1,
				spellc3d = 0,
				incense = -1,
				yoroi = -1,
				danger = 0,
				online = -1,
				reinc = -1,
				ldb = 8
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 7,
				drawClr = 16,
				name = "black",
				id = 6,
				cor = marker_to_coord3d(6),
				spellCDR = -1,
				spellc3d = 0,
				incense = -1,
				yoroi = -1,
				danger = 0,
				online = -1,
				reinc = -1,
				ldb = 8
			},
			{
				score = 0,
				kills = 0,
				deaths = 0,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				id = 7,
				cor = marker_to_coord3d(7),
				spellCDR = -1,
				spellc3d = 0,
				incense = -1,
				yoroi = -1,
				danger = 0,
				online = -1,
				reinc = -1,
				ldb = 8
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--[[if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil then
			pl[i].alive = 0
			if pl[i].reinc == -1 then
				pl[i].reinc = 12*5
				pl[i].danger = 0
				--add death visual
				local Dsprite = 24
				if pl[i].ldb ~= 8 then
					Dsprite = 2083 + pl[i].ldb
				end
				local Dname = "..."
				if Dsprite ~= 24 then
					Dname = pl[pl[i].ldb].name
				end
				local Dname2 = pl[i].name
				if pl[i].ldb ~= 8 then
					table.insert(deaths,{Dname,Dname2,Dsprite,2083+i,12*7})
				end
			end
		end
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
function CopyC3d(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end

--power ups
yoroiCDR = 12*120 + 12*G_RANDOM(10)
incenseCDR = 12*180 + 12*G_RANDOM(10)

yoroi = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(21),false,false)
yoroi.DrawInfo.DrawNum = 54
yoroi.DrawInfo.Alpha = -16
yoroi.Pos.D3.Ypos = yoroi.Pos.D3.Ypos + 5

incense = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(21),false,false)
incense.DrawInfo.DrawNum = 54
incense.DrawInfo.Alpha = -16
incense.Pos.D3.Ypos = incense.Pos.D3.Ypos + 5
--

blood = {2109,2110,2111,2112}
function Shuriken(pn,c3d)
	local s = createThing(T_EFFECT,60,pn,c3d,false,false)
	set_thing_draw_info(s,TDI_SPRITE_F1_D1, 2101+pn)
	s.u.Effect.Duration = 12*5 + (4) --5sec
	s.DrawInfo.Alpha = -16
	--water splash/snd
	SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(c3d), function(me)
		if (is_map_elem_sea_or_coast(me) > 0) then
			 queue_sound_event(nil,SND_EVENT_W_SPLASH, SEF_FIXED_VARS)
			 createThing(T_EFFECT,M_EFFECT_SPLASH,8,c3d,false,false)
			 if (is_map_elem_sea_or_coast(me) == 2) then
				s.u.Effect.Duration = 6*1
			 end
		else
			createThing(T_EFFECT,M_EFFECT_WW_DUST,8,c3d,false,false)
		end
	return true
	end)
	--hit shamans
	local c2d = Coord2D.new()
	coord3D_to_coord2D(c3d, c2d)
	ProcessGlobalSpecialListAll(0, function(t)
		if t.Owner ~= pn then
			if pl[t.Owner].yoroi == -1 then
				if get_world_dist_xz(t.Pos.D2,c2d) < 256+128+64+16 then --since they invi, better give larger area else too hard
					local rdm = blood[math.random(#blood)]
					local ss = createThing(T_EFFECT,60,8,c3d,false,false)
					set_thing_draw_info(ss,TDI_SPRITE_F1_D1, rdm)
					ss.u.Effect.Duration = -1
					ss.DrawInfo.Alpha = -16
					pl[pn].kills = pl[pn].kills + 1
					pl[t.Owner].deaths = pl[t.Owner].deaths + 1
					if t.Owner < 4 then
						team2Score = team2Score + 1
					else
						team1Score = team1Score + 1
					end
					pl[pn].danger = 0
					--move shamans
					if getShaman(t.Owner) ~= nil then
						damage_person(getShaman(t.Owner), pn, 10000, TRUE)
					end
				elseif get_world_dist_xz(t.Pos.D2,c2d) >= 256+128+64+16 and get_world_dist_xz(t.Pos.D2,c2d) < 256+256+256+64+16 then
					local circ = createThing(T_EFFECT,M_EFFECT_LIGHTNING_ELEM ,8,getShaman(t.Owner).Pos.D3,false,false)
					centre_coord3d_on_block(circ.Pos.D3)
				end
			end
		end
	return true
	end)
end



function OnTurn()

	if win ~= 1 then AliveandOnline() end
	for i = 0,255 do KILL_ALL_MSG_ID(i) end
	CLEAR_ALL_MSG()

	if win == 0 then
		if everySeconds(15) then
			--show smoke above shamans
			for i = 0,7 do
				if getShaman(i) ~= nil then
					local s = createThing(T_EFFECT,60,8,getShaman(i).Pos.D3,false,false)
					s.DrawInfo.Alpha = pl[i].color
				end
			end
		end
		for i = 0,7 do
			--revive shamans
			if pl[i].online == 1 then
				if getShaman(i) == nil and pl[i].reinc > 0 then
					pl[i].reinc = pl[i].reinc - 1
				elseif getShaman(i) == nil and pl[i].reinc == 0 then
					local randommarker = G_RANDOM(8)
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,marker_to_coord3d(randommarker),false,false)
					MOVE_SHAMAN_TO_MARKER(i,randommarker+8)
					if getShaman(i) ~= nil then
						getShaman(i).Flags2 = EnableFlag(getShaman(i).Flags2, TF2_THING_IS_AN_INVISIBLE_PERSON)
					end
					pl[i].alive = 1
					pl[i].reinc = -1
				end
			end
			--process spells delay (12gt)
			if pl[i].spellCDR > 0 then
				pl[i].spellCDR = pl[i].spellCDR - 1
			elseif pl[i].spellCDR == 0 then
				pl[i].spellCDR = -1
				Shuriken(i,pl[i].spellc3d)
			end
			--incense decay
			if pl[i].incense > 0 then
				pl[i].incense = pl[i].incense - 1
			elseif pl[i].incense == 0 then
				pl[i].incense = -1
			end
			--yoroi decay
			if pl[i].yoroi > 0 then
				pl[i].yoroi = pl[i].yoroi - 1
			elseif pl[i].yoroi == 0 then
				pl[i].yoroi = -1
				if getShaman(i) ~= nil then
					getShaman(i).Flags3 = DisableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
				end
			end
		end
		--PuPcdr
		if yoroiCDR > 0 then
			yoroiCDR = yoroiCDR - 1
		elseif yoroiCDR == 0 then
			move_thing_within_mapwho(yoroi,marker_to_coord3d(math.random(16,20)))
			centre_coord3d_on_block(yoroi.Pos.D3) ; yoroi.DrawInfo.DrawNum = 2113 ; yoroi.DrawInfo.Alpha = -16 ; yoroi.Pos.D3.Ypos = yoroi.Pos.D3.Ypos + 8 ; yoroiCDR = -1
		end
		if incenseCDR > 0 then
			incenseCDR = incenseCDR - 1
		elseif incenseCDR == 0 then
			move_thing_within_mapwho(incense,marker_to_coord3d(math.random(16,20)))
			centre_coord3d_on_block(incense.Pos.D3) ; incense.DrawInfo.DrawNum = 2114 ; incense.DrawInfo.Alpha = -16 ; incense.Pos.D3.Ypos = incense.Pos.D3.Ypos + 8 ; incenseCDR = -1
		end
		--catching power ups
		for i = 0,7,1 do
			if getShaman(i) ~= nil then
				if get_world_dist_xz(getShaman(i).Pos.D2,yoroi.Pos.D2) <= 256 then
					pl[i].yoroi = 12*45
					queue_sound_event(nil,SND_EVENT_BLDG_MENU_SPIN, SEF_FIXED_VARS)
					yoroiCDR = 12*120 + G_RANDOM(12*10) ; move_thing_within_mapwho(yoroi,marker_to_coord3d(21)) ; yoroi.DrawInfo.DrawNum = 54
					getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
					--log_msg(8,"" .. pl[i].name .. " equiped the yoroi (ninja armor). Obtained immunity to shurikens for 45s")
				end
				--
				if get_world_dist_xz(getShaman(i).Pos.D2,incense.Pos.D2) <= 256 then
					pl[i].incense = 12*45
					queue_sound_event(nil,SND_EVENT_PLACE_BLDG, SEF_FIXED_VARS)
					incenseCDR = 12*180 + G_RANDOM(12*10) ; move_thing_within_mapwho(incense,marker_to_coord3d(21)) ; incense.DrawInfo.DrawNum = 54
					--log_msg(8,"" .. pl[i].name .. " found some ninja incense, covering his enemies with it for 30s")
				end
			end
		end
		if every2Pow(3) then
			for i = 0,7 do
				--danger (ninja meter bar)
				if getShaman(i) ~= nil then
					local c = 0
					if i < 4 then 
						for radius = 0,9 do
							if c == 0 then
								SearchMapCells(SQUARE ,0, 0, radius, world_coord3d_to_map_idx(getShaman(i).Pos.D3), function(me)
									me.MapWhoList:processList( function (t)
										if t.Type == T_PERSON and t.Model == M_PERSON_MEDICINE_MAN then
											if t.Owner ~= i and t.Owner > 3 and c == 0 then
												c = 1
												pl[i].danger = 9 - radius
											end
										end
									return true end)
								return true end)
							end
						end
					else
						for radius = 0,9 do
							if c == 0 then
								SearchMapCells(SQUARE ,0, 0, radius, world_coord3d_to_map_idx(getShaman(i).Pos.D3), function(me)
									me.MapWhoList:processList( function (t)
										if t.Type == T_PERSON and t.Model == M_PERSON_MEDICINE_MAN then
											if t.Owner ~= i and t.Owner < 4 and c == 0 then
												c = 1
												pl[i].danger = 9 - radius
											end
										end
									return true end)
								return true end)
							end
						end
					end
				end
				if getShaman(i) ~= nil then
					--regive invi if needed
					if getShaman(i).Flags2 & TF2_THING_IS_AN_INVISIBLE_PERSON == 0 then
						getShaman(i).Flags2 = EnableFlag(getShaman(i).Flags2, TF2_THING_IS_AN_INVISIBLE_PERSON)
					end
				end
			end
		end
		if every2Pow(6) then
			--give shuriken
			for pn = 0,7,1 do
				local shuriken = GET_NUM_ONE_OFF_SPELLS(pn,shurikenSpell)
				if shuriken == 0 then
					_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[shurikenSpell] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[shurikenSpell] & 240
					_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[shurikenSpell] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[shurikenSpell] | 1
				elseif shuriken >= 1 then
					_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[shurikenSpell] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[shurikenSpell] & 240
					_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[shurikenSpell] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[shurikenSpell] | 2
				end
			end
		end
		if every2Pow(4) then
			for i = 0,7,1 do
				--show incense over shamans
				if pl[i].incense >= 0 then
					if i > 4 then
						for j = 0,3 do
							if getShaman(j) ~= nil then
								local inc = createThing(T_EFFECT,M_EFFECT_WW_DUST,8,getShaman(j).Pos.D3,false,false)
								inc.Pos.D3.Ypos = getShaman(j).Pos.D3.Ypos + 128
								inc.DrawInfo.Alpha = pl[j].color
								inc.u.Effect.Duration = 2
							end
						end
					else
						for j = 4,7 do
							if getShaman(j) ~= nil then
								local inc = createThing(T_EFFECT,M_EFFECT_WW_DUST,8,getShaman(j).Pos.D3,false,false)
								inc.Pos.D3.Ypos = getShaman(j).Pos.D3.Ypos + 128
								inc.DrawInfo.Alpha = pl[j].color
								inc.u.Effect.Duration = 2
							end
						end
					end
				end
			end
		end
		--win by pts
		if team1Score == maxScore or team2Score == maxScore then
			if team1Score == maxScore and team2Score == maxScore then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		if timer > 0 then
			timer = timer -1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
	end
	--reset score if too big
	if team1Score > maxScore then team1Score = maxScore end
	if team2Score > maxScore then team2Score = maxScore end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			pl[i].ldb = getShaman(i).u.Pers.u.Owned.LastDamagedBy
		end
	end
	--process shamans not being targetable
	ProcessGlobalSpecialListAll(0, function(targ)
		if (targ.Type == T_PERSON) and (targ.Model == M_PERSON_MEDICINE_MAN) then
			local cmd = get_thing_curr_cmd_list_ptr(targ)
			if (cmd ~= nil) then
				if (cmd.CommandType == CMD_ATTACK_AREA_2) or (cmd.CommandType == CMD_ATTACK_TARGET) then
					cmd.CommandType = CMD_HEAD_PRAY
				end
			end
		end
	return true
	end)
end


local dropIcon = 0
function OnCreateThing(t)
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
	if t.Type == T_SPELL then
		KILL_ALL_MSG_ID(dropIcon)
		dropIcon = dropIcon + 1
		CLEAR_ALL_MSG()
	end
	if (t.Type == T_SPELL) and (t.Model == shurikenSpell) and getShaman(t.Owner) ~= nil and win == 0 then --shuriken
		queue_sound_event(getShaman(t.Owner),SND_EVENT_OPT_HILITE, SEF_PLAY_ME)
		pl[t.Owner].spellCDR = 8
		pl[t.Owner].spellc3d = CopyC3d(t.Pos.D3)
		local circ = createThing(T_EFFECT,M_EFFECT_SPRITE_CIRCLES ,8,getShaman(t.Owner).Pos.D3,false,false) --makes game easier
		centre_coord3d_on_block(circ.Pos.D3)
		--remove shot
		local shuriken = GET_NUM_ONE_OFF_SPELLS(t.Owner,shurikenSpell)
		if shuriken == 1 then
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[shurikenSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[shurikenSpell] & 240
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[shurikenSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[shurikenSpell] | 0
		elseif shuriken >= 2 then
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[shurikenSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[shurikenSpell] & 240
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[shurikenSpell] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[shurikenSpell] | 1
		end
	end
	if t.Type == T_EFFECT then
		if t.Model == M_EFFECT_INSECT_PLAGUE then
			t.u.Effect.Duration = 1
		end
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		local gaugeW = (box*2)+2+2
		local gaugeH = math.floor((box+4)*7)
		local alertsW = math.floor(w-8-gaugeW+2)
		local alertsHstart = (h-8)-gaugeH+2
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/maxScore)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/45"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/maxScore)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/45"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,2101+(deaths[i][3]-2083)),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			for i = 0,7,1 do
				if _gnsi.PlayerNum == i then
					--ninja gauge bar
					DrawBox(w-8-gaugeW,(h-8)-gaugeH,gaugeW,gaugeH,1)
					DrawBox(w-8-gaugeW+2,(h-8)-gaugeH+2,gaugeW-4,gaugeH-4,0)
					if pl[i].danger ~= 0 then
						if pl[i].danger >= 1 then
							DrawBox(alertsW,alertsHstart+(box*6)+24,box*2,box,2) --lowest level of danger
						end
						if pl[i].danger >= 2 then
							DrawBox(alertsW,alertsHstart+(box*5)+20,box*2,box,2)
						end
						if pl[i].danger >= 3 then
							DrawBox(alertsW,alertsHstart+(box*4)+16,box*2,box,2)
						end
						if pl[i].danger >= 4 then
							DrawBox(alertsW,alertsHstart+(box*3)+12,box*2,box,2)
						end
						if pl[i].danger >= 5 then
							DrawBox(alertsW,alertsHstart+(box*2)+8,box*2,box,2)
						end
						if pl[i].danger >= 6 then
							DrawBox(alertsW,alertsHstart+(box*1)+4,box*2,box,2)
						end
						if pl[i].danger >= 7 then
							DrawBox(alertsW,alertsHstart+(box*0)+0,box*2,box,2) -- highest level of danger
						end
					end
				end
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end	
end


--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Ninja Shamans MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Shamans are invisible ninjas, scoring 1 point per kill")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Ninjas are invisible, but using shurikens will show the casting animation particles")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Also, the danger meter gauge bar shows if an enemy is nearby (in a circular radius):")
	   	imgui.NextColumn()
		imgui.TextUnformatted("(if the gauge is fully charged, someone is very close to you!)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("* Every 2 minutes, a \"yoroi\" power up appears: it grants shuriken immunity for 45sec *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* Every 3 minutes, an \"incense\" power up appears: it spoils the location of all enemies for 30sec *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* Every 15 seconds, a sparkle gives everyone's location away *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* Friendly fire is on, but suiciding with shurikens won't work *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points wins).")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("SHURIKEN - swarm")
		imgui.NextColumn()
		
		imgui.End()
	end
end

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_INFO_DROP) or (event == SND_EVENT_INFO_BOUNCE) or (event == SND_EVENT_SHIELD) or event == SND_EVENT_SHAM_SELECTED or event == SND_EVENT_SHAM_AFFIRM 
		or event == SND_EVENT_SHAM_INSECT or event == SND_EVENT_ESHAM_INSECT then
		return 1
	end
	if event ==  SND_EVENT_SHAM_SHIELD or event == SND_EVENT_ESHAM_SHIELD then
		return 1
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(254,176),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2122)
