----4v4 Sun and Moon Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Building)
import(Module_Spells)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 0
local team2Score = 0
----------------------------------------------------spell constants
sti = spells_type_info()
tmi = thing_move_info()

--acquire
local acq = M_SPELL_INSECT_PLAGUE
sti[acq].OneOffMaximum = 2
sti[acq].WorldCoordRange = 8192
sti[acq].CursorSpriteNum = 152
sti[acq].ToolTipStrIdx = sti[M_SPELL_TELEPORT].ToolTipStrIdx
sti[acq].ToolTipStrIdxLSME = sti[M_SPELL_TELEPORT].ToolTipStrIdxLSME
sti[acq].AvailableSpriteIdx = 1778
sti[acq].NotAvailableSpriteIdx = 1778
sti[acq].ClickedSpriteIdx = 1778

local addedTimer = 8
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)


tmi[TMI_PERSON_MEDICINE_MAN].BaseSpeed = 72
set_correct_gui_menu()
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				cor = marker_to_coord3d(0),
				acquireCDR = -1,
				acquirec3d = -1,
				star = 0,
				ldb = 8,
				reinc = -1
			},
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 12,
				name = "red",
				cor = marker_to_coord3d(1),
				acquireCDR = -1,
				acquirec3d = -1,
				star = 0,
				ldb = 8,
				reinc = -1
			},
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 5,
				name = "yellow",
				cor = marker_to_coord3d(2),
				acquireCDR = -1,
				acquirec3d = -1,
				star = 0,
				ldb = 8,
				reinc = -1
			},
			{
				team = 0,
				online = -1,
				alive = 1,
				color = 2,
				drawClr = 3,
				name = "green",
				cor = marker_to_coord3d(3),
				acquireCDR = -1,
				acquirec3d = -1,
				star = 0,
				ldb = 8,
				reinc = -1
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 7,
				name = "cyan",
				cor = marker_to_coord3d(4),
				acquireCDR = -1,
				acquirec3d = -1,
				star = 0,
				ldb = 8,
				reinc = -1
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 6,
				name = "magenta",
				cor = marker_to_coord3d(5),
				acquireCDR = -1,
				acquirec3d = -1,
				star = 0,
				ldb = 8,
				reinc = -1
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 16,
				name = "black",
				cor = marker_to_coord3d(6),
				acquireCDR = -1,
				acquirec3d = -1,
				star = 0,
				ldb = 8,
				reinc = -1
			},
			{
				team = 7,
				online = -1,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				cor = marker_to_coord3d(7),
				acquireCDR = -1,
				acquirec3d = -1,
				star = 0,
				ldb = 8,
				reinc = -1
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--[[if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil and pl[i].reinc == -1 then
			pl[i].alive = 0
			pl[i].star = 0
			pl[i].reinc = 12*5
			--add death visual
			local Dsprite = 24
			if pl[i].ldb ~= 8 then
				Dsprite = 2083 + pl[i].ldb
			end
			local Dname = "..."
			if Dsprite ~= 24 then
				Dname = pl[pl[i].ldb].name
			end
			local Dname2 = pl[i].name
			table.insert(deaths,{Dname,Dname2,Dsprite,2083+i,12*7})
		end
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
function CopyC3d(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end

--create star middle map
star = createThing(T_EFFECT,60,8,marker_to_coord3d(240),false,false)
centre_coord3d_on_block(star.Pos.D3)
set_thing_draw_info(star,TDI_SPRITE_F16_D1_ALPHA, 1746) --moon is 1762
star.u.Effect.Duration = -1
star.DrawInfo.Alpha = -16

local daycicle = 1
local texture = 12*70
set_level_type(14)
draw_sky_clr_overlay(2,-1)
function DayCycle()
	if daycicle == 1 then
		daycicle = 2
		set_level_type(3) --night
		draw_sky_clr_overlay(-1,-1)
		if star ~= nil then
			set_thing_draw_info(star,TDI_SPRITE_F16_D1_ALPHA, 1762)
			star.u.Effect.Duration = -1
			star.DrawInfo.Alpha = -16
		end
	else
		daycicle = 1
		set_level_type(14) --day
		draw_sky_clr_overlay(2,-1)
		if star ~= nil then
			set_thing_draw_info(star,TDI_SPRITE_F16_D1_ALPHA, 1746)
			star.u.Effect.Duration = -1
			star.DrawInfo.Alpha = -16
		end
	end
	texture = 12*60
end

function Acquire(pn,c3d)
	local s = createThing(T_EFFECT,66,8,c3d,false,false) ; s.u.Effect.Duration = 4 s.DrawInfo.Alpha = pl[pn].color
	local c2d = Coord2D.new() ; coord3D_to_coord2D(c3d, c2d)
	ProcessGlobalSpecialListAll(0, function(t)
		if t.Owner ~= pn then
			if ((pn < 4 and t.Owner > 3) or (pn > 3 and t.Owner < 4)) then
				if getShaman(pn) ~= nil and pl[pn].star == 0 then
					if pl[t.Owner].star == 1 then
						if get_world_dist_xz(t.Pos.D2,c2d) < 256+128 then
							queue_sound_event(nil,SND_EVENT_DISCOBLDG_END, SEF_FIXED_VARS)
							pl[t.Owner].star = 0
							pl[pn].star = 1
							if pn < 4 then
								team1Score = team1Score + 5
							else
								team2Score = team2Score + 5
							end
							_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] & 240
							_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] | 0
						end
					end
				end
			end
		end
	return true end)
	queue_sound_event(nil,SND_EVENT_SHRAPNEL, SEF_FIXED_VARS) --SND_EVENT_SHOT_STANDARD
end

function SomeoneHasStar()
	local a = 0
	for i = 0,7 do
		if pl[i].star == 1 then
			a = a + 1
		end
	end
	if a > 0 then return 1 else return 0 end
end



local up = 1
function OnTurn()

	if win ~= 1 then AliveandOnline() end

	if win == 0 then
		--process star up down
		local starCount = 0
		for i = 0,7,1 do
			if pl[i].star == 1 then
				starCount = starCount + 1
			end
		end
		if starCount == 0 then
			local starPos = point_altitude(star.Pos.D2.Xpos,star.Pos.D2.Zpos)
			if star ~= nil then
				if star.Pos.D3.Ypos < starPos+256 and up == 1 then
					star.Pos.D3.Ypos = star.Pos.D3.Ypos + 6
				elseif star.Pos.D3.Ypos >= starPos+256 and up == 1 then
					up = 0
					star.Pos.D3.Ypos = star.Pos.D3.Ypos - 6
				end
				if star.Pos.D3.Ypos > starPos+32 and up == 0 then
					star.Pos.D3.Ypos = star.Pos.D3.Ypos - 6
				elseif star.Pos.D3.Ypos <= starPos+32 and up == 0 then
					up = 1
					star.Pos.D3.Ypos = star.Pos.D3.Ypos + 6
				end
			end
		end
		--process texture cycle
		if texture > 0 then
			texture = texture - 1
		else
			DayCycle()
		end
		for i = 0,7,1 do
			--catch the star on floor
			if star ~= nil then
				if getShaman(i) ~= nil and pl[i].online == 1 and pl[i].star == 0 then
					if get_world_dist_xz(getShaman(i).Pos.D2,star.Pos.D2) < 128+32 and SomeoneHasStar() == 0 then
						pl[i].star = 1
						if i < 4 then
							team1Score = team1Score + 5
						else
							team2Score = team2Score + 5
						end
					end
				end
			end
			--process acquireCDR
			if pl[i].acquireCDR > 0 then
				pl[i].acquireCDR = pl[i].acquireCDR - 1
			elseif pl[i].acquireCDR == 0 then
				pl[i].acquireCDR = -1
				Acquire(i,pl[i].acquirec3d)
			end
			--process star position
			if getShaman(i) ~= nil and pl[i].online == 1 and pl[i].star == 1 then
				if star ~= nil then
					move_thing_within_mapwho(star,getShaman(i).Pos.D3)
					star.Pos.D3.Ypos = 256 + getShaman(i).Pos.D3.Ypos
				end
			end
		end
		if everySeconds(3) then
			for i = 0,7,1 do
				if getShaman(i) ~= nil then
					local shots = GET_NUM_ONE_OFF_SPELLS(i,M_SPELL_BLAST)
					if shots < 4 then
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] & 240
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_BLAST] | shots+1
					end
				end
			end
		end
		if everySeconds(7) then
			for i = 0,7,1 do
				if pl[i].star == 1 then
					--star holders get lights every 5s
					local shots = GET_NUM_ONE_OFF_SPELLS(i,M_SPELL_LIGHTNING_BOLT)
					if shots < 4 then
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] & 240
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] | shots+1
					end
				end
			end
		end
		--revive shamans
		for i = 0,7 do
			if pl[i].online == 1 then
				if getShaman(i) == nil and pl[i].reinc > 0 then
					pl[i].reinc = pl[i].reinc - 1
				elseif getShaman(i) == nil and pl[i].reinc == 0 then
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,marker_to_coord3d(math.random(200,230)),false,false)
					if getShaman(i) ~= nil then
						getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
						getShaman(i).u.Pers.u.Owned.ShieldCount = 5
					end
					pl[i].alive = 1
					pl[i].reinc = -1
				end
			end
		end
		if every2Pow(7) then
			for i = 0,7,1 do
				--[[reinc shaman who die
				if getShaman(i) == nil and pl[i].online == 1 then
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,marker_to_coord3d(math.random(200,230)),false,false)
					if getShaman(i) ~= nil then
						getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
						getShaman(i).u.Pers.u.Owned.ShieldCount = 5
					end
				end]]
				--spells give (acquire)
				if GET_NUM_ONE_OFF_SPELLS(i,M_SPELL_INSECT_PLAGUE) == 0 then
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] & 240
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] | 1
				elseif GET_NUM_ONE_OFF_SPELLS(i,M_SPELL_INSECT_PLAGUE) == 1 then
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] & 240
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_INSECT_PLAGUE] | 2
				end
			end
		end
		if every2Pow(4) then
			--star on water
			if star ~= nil and SomeoneHasStar() == 0 then
				SearchMapCells(CIRCULAR, 0, 0, 0, world_coord2d_to_map_idx(star.Pos.D2), function(me)
					if (is_map_elem_all_sea(me)	> 0) or is_map_elem_sea_or_coast(me) > 0 then
						SearchMapCells(CIRCULAR, 0, 0, 10, world_coord2d_to_map_idx(star.Pos.D2), function(_me)
							if (is_map_elem_all_land(_me) > 0) then
								local land2D = Coord2D.new() ; map_ptr_to_world_coord2d(_me, land2D)
								local land3D = Coord3D.new() ; coord2D_to_coord3D(land2D,land3D)
								move_thing_within_mapwho(star,land3D)
							return false end
						return true end)
					end
				return true end)
			end
			for i = 0,7,1 do
				--remove lights if no star
				if pl[i].star == 0 then
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] & 240
					_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] | 0
				end
				--detach from dead shamans/quitters
				if pl[i].online == 0 or getShaman(i) == nil then
					if pl[i].star == 1 then
						pl[i].star = 0
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] & 240
						_gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] = _gsi.ThisLevelInfo.PlayerThings[i].SpellsAvailableOnce[M_SPELL_LIGHTNING_BOLT] | 0
						--check if water anyway
						SearchMapCells(CIRCULAR, 0, 0, 0, world_coord2d_to_map_idx(star.Pos.D2), function(me)
							if (is_map_elem_all_sea(me)	> 0) or is_map_elem_sea_or_coast(me) > 0 then
								SearchMapCells(CIRCULAR, 0, 0, 10, world_coord2d_to_map_idx(star.Pos.D2), function(_me)
									if (is_map_elem_all_land(_me) > 0) then
										local land2D = Coord2D.new() ; map_ptr_to_world_coord2d(_me, land2D)
										local land3D = Coord3D.new() ; coord2D_to_coord3D(land2D,land3D)
										move_thing_within_mapwho(star,land3D)
									return false end
								return true end)
							end
						return true end)
					end
				end
				if getShaman(i) ~= nil and pl[i].online == 1 and pl[i].star == 1 then
					--process points
					if daycicle == 1 then
						if i < 4 then
							team1Score = team1Score + 2
						else
							team2Score = team2Score + 2
						end
					else
						if i < 4 then
							team1Score = team1Score + 1
							team2Score = team2Score - 1
						else
							team2Score = team2Score + 1
							team1Score = team1Score - 1
						end
					end
				end
			end
		end
		--win by pts
		if team1Score == 300 or team2Score == 300 then
			if team1Score == 300 and team2Score == 300 then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		if timer > 0 then
			timer = timer -1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
			smok.DrawInfo.Alpha = pl[i].color ; smok.u.Effect.Duration = 2
			smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 32
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
	end
	--reset score if too big
	if team1Score > 300 then team1Score = 300 end
	if team2Score > 300 then team2Score = 300 end
	if team1Score < 0 then team1Score = 0 end
	if team2Score < 0 then team2Score = 0 end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			pl[i].ldb = getShaman(i).u.Pers.u.Owned.LastDamagedBy
		end
	end
end



function OnCreateThing(t)
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
	if t.Type == T_EFFECT and t.Model == M_EFFECT_INSECT_PLAGUE then
		t.u.Effect.Duration = 1
	end
	if (t.Type == T_SPELL) and (t.Model == M_SPELL_INSECT_PLAGUE) and getShaman(t.Owner) ~= nil then --acquire
		--t.Model = M_SPELL_INVISIBILITY --M_SPELL_NONE --changing model causes hyperspeed somethimes i think
		queue_sound_event(nil,SND_EVENT_BIRTH, SEF_FIXED_VARS) --SND_EVENT_SHOT_STANDARD
		pl[t.Owner].acquireCDR = 12
		pl[t.Owner].acquirec3d = CopyC3d(t.Pos.D3)
		local newS = createThing(T_SPELL, M_SPELL_SHIELD, t.Owner, t.Pos.D3, false, false)--this creates the spellcast line between caster and target pos
		--no s click follow
		if (not t.u.Spell.TargetThingIdx:isNull()) then
			if (t.u.Spell.TargetThingIdx:get().Model == M_PERSON_MEDICINE_MAN) then
				t.u.Spell.TargetThingIdx:set(0)
			end
		end
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/300)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/300"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/300)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/300"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end
end



--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Sun and Moon MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Teams must fight to own the sun or moon. Shamans can obtain it by casting 'acquire' spell on the current holder, or walking over it (if it's on the floor)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* There's a 1s delay between casting Acquire and it hitting the target - just like any spell *")
		imgui.NextColumn()
		imgui.TextUnformatted("Once a shaman acquires the star, the rest of the team must defend her, and the holder must try to run away and keep it for as long as possible")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- Catching the son/moon instantly earns the team 5 points")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- During the day, the sun earns the team 2 points per second")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- During the night, the moon earns the team 1 point per second, and removes 1 point from the enemy")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("* Each day/night cycle lasts 1 minute ; you can not steal the sun/moon from your teammates *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* Shamans occasionally earn blast spells. Whoever is holding the sun/moon also earns lights (half as often) *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points wins).")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("ACQUIRE - swarm")
		imgui.NextColumn()
		
		imgui.End()
	end
end

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_SHAM_INSECT) or (event == SND_EVENT_ESHAM_INSECT) then
		return 1
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(72,10),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2122)